import { LfI18n, LfRouter, LfStorage, PathBased } from '@lightweightform/core';
import { SelectionValue } from './selection-value';
import * as i0 from "@angular/core";
/**
 * Abstract class used to represent components where a single option is selected
 * from a set of options.
 */
export declare abstract class SingleSelectionValue extends SelectionValue {
    constructor(parentPathBasedComponent: PathBased | null, lfStorage: LfStorage, lfI18n: LfI18n, lfRouter: LfRouter | null);
    /**
     * Whether to show the "is required" icon on the component.
     */
    get showIsRequired(): boolean;
    /**
     * Index of the selected option; `-1` when none of the available options is
     * selected.
     */
    get selectedOptionIndex(): number;
    static ɵfac: i0.ɵɵFactoryDeclaration<SingleSelectionValue, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<SingleSelectionValue, never, never, {}, {}, never>;
}
