import { LfI18n, LfRouter, LfStorage, PathBased } from '@lightweightform/core';
import { InlineValue } from '../../abstract/inline-value';
import * as i0 from "@angular/core";
/**
 * LF checkbox component.
 */
export declare class CheckboxComponent extends InlineValue {
    constructor(parentPathBasedComponent: PathBased | null, lfStorage: LfStorage, lfI18n: LfI18n, lfRouter: LfRouter | null);
    /**
     * Whether to show the "is required" icon on the component.
     */
    get showIsRequired(): boolean;
    /**
     * Action to run whenever the value of the checkbox changes.
     * @param evt `change` event.
     */
    _onCheckboxChange(evt: any): void;
    protected validatePath(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<CheckboxComponent, [{ optional: true; }, null, null, { optional: true; }]>;
    static ɵcmp: i0.ɵɵComponentDeclaration<CheckboxComponent, "lf-checkbox", never, {}, {}, never, never>;
}
