import { LfI18n, LfRouter, LfStorage, PathBased } from '@lightweightform/core';
import { SingleSelectionValue } from '../../abstract/single-selection-value';
import * as i0 from "@angular/core";
/**
 * Component used for selecting from a list of options by using inputs of type
 * `radio`.
 */
export declare class RadioComponent extends SingleSelectionValue {
    /**
     * Whether the list of radio inputs should be displayed inline. The component
     * will still display in "block" mode in small screens.
     */
    displayInline: boolean;
    constructor(parentPathBasedComponent: PathBased | null, lfStorage: LfStorage, lfI18n: LfI18n, lfRouter: LfRouter | null);
    /**
     * Action to run whenever the value of the `radio` input changes.
     * @param evt `change` event.
     */
    _onRadioChange(evt: any): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<RadioComponent, [{ optional: true; }, null, null, { optional: true; }]>;
    static ɵcmp: i0.ɵɵComponentDeclaration<RadioComponent, "lf-radio", never, { "displayInline": "displayInline"; }, {}, never, never>;
}
