import { LfI18n, LfRouter, LfStorage, PathBased } from '@lightweightform/core';
import { InlineValue } from '../../abstract/inline-value';
import * as i0 from "@angular/core";
/**
 * Component used for editing a "single line" LF string.
 */
export declare class TextComponent extends InlineValue {
    constructor(parentPathBasedComponent: PathBased | null, lfStorage: LfStorage, lfI18n: LfI18n, lfRouter: LfRouter | null);
    /**
     * Whether to show the "is required" icon on the component.
     */
    get showIsRequired(): boolean;
    /**
     * Minimum length allowed.
     */
    get minLength(): number | undefined;
    /**
     * Maximum length allowed.
     */
    get maxLength(): number | undefined;
    /**
     * Action to run on every `input` event of the text input.
     * @param evt `input` event.
     */
    _onInput(evt: any): void;
    protected validatePath(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<TextComponent, [{ optional: true; }, null, null, { optional: true; }]>;
    static ɵcmp: i0.ɵɵComponentDeclaration<TextComponent, "lf-text", never, {}, {}, never, never>;
}
