import { LfI18n, LfRouter, LfStorage, PathBased } from '@lightweightform/core';
import { InlineValue } from '../../abstract/inline-value';
import * as i0 from "@angular/core";
/**
 * Component used for editing a "multiple lines" LF string.
 */
export declare class TextareaComponent extends InlineValue {
    /**
     * Initial height of the textarea (CSS measurement string).
     */
    initialHeight: string;
    constructor(parentPathBasedComponent: PathBased | null, lfStorage: LfStorage, lfI18n: LfI18n, lfRouter: LfRouter | null);
    /**
     * Whether to show the "is required" icon on the component.
     */
    get showIsRequired(): boolean;
    /**
     * Minimum length allowed.
     */
    get minLength(): number | undefined;
    /**
     * Maximum length allowed.
     */
    get maxLength(): number | undefined;
    /**
     * Action to run on every `input` event of the textarea input.
     * @param evt `input` event.
     */
    _onInput(evt: any): void;
    protected validatePath(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<TextareaComponent, [{ optional: true; }, null, null, { optional: true; }]>;
    static ɵcmp: i0.ɵɵComponentDeclaration<TextareaComponent, "lf-textarea", never, { "initialHeight": "initialHeight"; }, {}, never, never>;
}
