import { LfI18n, LfStorage, PathBased } from '@lightweightform/core';
import * as i0 from "@angular/core";
/**
 * Component used to debug information about the state of a value.
 */
export declare class ValueStateComponent extends PathBased {
    /**
     * Whether the application is in production mode.
     */
    inProduction: boolean;
    constructor(parentPathBasedComponent: PathBased | null, lfStorage: LfStorage, lfI18n: LfI18n);
    /**
     * State properties where each "promise" is transformed into an object for
     * easier rendering as a JSON. Also hides the `$mobx` property.
     */
    get stateProperties(): Record<string, any>;
    /**
     * Whether the state properties contain at least one async property.
     */
    get hasAsyncProperties(): boolean;
    static ɵfac: i0.ɵɵFactoryDeclaration<ValueStateComponent, [{ optional: true; }, null, null]>;
    static ɵcmp: i0.ɵɵComponentDeclaration<ValueStateComponent, "lf-value-state", never, {}, {}, never, never>;
}
