'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var tasks = require('@angular-devkit/schematics/tasks');
var dependencies = require('@schematics/angular/utility/dependencies');

/*! *****************************************************************************
Copyright (c) Microsoft Corporation.

Permission to use, copy, modify, and/or distribute this software for any
purpose with or without fee is hereby granted.

THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
PERFORMANCE OF THIS SOFTWARE.
***************************************************************************** */

function __values(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
}

/**
 * `ng-add` schematic function.
 * @param options Schematic options.
 * @returns Schematic rule.
 */
function ngAdd(options) {
    return function (host, context) {
        var e_1, _a;
        var themePeerDependencies = {"@angular/animations":"~12.2.15","@angular/cdk":"~12.2.13","@angular/common":"~12.2.15","@angular/core":"~12.2.15","@angular/forms":"~12.2.15","@angular/platform-browser":"~12.2.15","@angular/router":"~12.2.15","@lightweightform/core":"^4.13.0","@lightweightform/numeric-input":"^4.13.0","@lightweightform/storage":"^4.13.0","@lightweightform/theme-common":"^4.13.0","bootstrap":"~4.6.1","font-awesome":"^4.7.0","jquery":"^3.6.0","mobx":"6.3.2","mobx-angular":"~4.3.0","mobx-utils":"^6.0.4","ngx-bootstrap":"^7.1.2","ngx-markdown":"^12.0.1","popper.js":"^1.16.1","rxjs":"~6.5.4"};
        try {
            for (var _b = __values(Object.keys(themePeerDependencies)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var dep = _c.value;
                // Add dependencies only if they don't exist to prevent recording changes
                // on `package.json`
                if (dependencies.getPackageJsonDependency(host, dep) === null) {
                    dependencies.addPackageJsonDependency(host, {
                        type: dependencies.NodeDependencyType.Default,
                        name: dep,
                        version: themePeerDependencies[dep],
                    });
                }
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
            }
            finally { if (e_1) throw e_1.error; }
        }
        var taskDeps = [];
        // Install missing peer dependencies since we depend on the `theme-common`
        // schematics utilities and only then can we set up the project
        // XXX: Don't install dependencies in development mode since `npm install`
        // overrides `npm link`s (see: https://github.com/npm/npm/issues/17287),
        // thus messing up local projects testing the schematics
        {
            taskDeps.push(context.addTask(new tasks.NodePackageInstallTask()));
        }
        context.addTask(new tasks.RunSchematicTask('ng-add-setup', options), taskDeps);
    };
}

exports.ngAdd = ngAdd;
//# sourceMappingURL=before-install.js.map
