'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var schematics$1 = require('@angular-devkit/schematics');
var schematics = require('@lightweightform/theme-common/schematics');
var lintFix = require('@schematics/angular/utility/lint-fix');
var core = require('@angular-devkit/core');
var change = require('@schematics/angular/utility/change');

/*! *****************************************************************************
Copyright (c) Microsoft Corporation.

Permission to use, copy, modify, and/or distribute this software for any
purpose with or without fee is hereby granted.

THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
PERFORMANCE OF THIS SOFTWARE.
***************************************************************************** */

var __assign = function() {
    __assign = Object.assign || function __assign(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};

function __awaiter(thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
}

function __generator(thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
}

function __values(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
}

function __read(o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
}

function __spreadArray(to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
}

/**
 * Returns the list of locales given a string representing them.
 * @param localesStr String representing the locales.
 * @returns List of locales.
 */
function getLocalesArrayFromString(localesStr) {
    return localesStr.split(',').map(function (l) { return l.trim(); });
}

/**
 * Default i18n folder name.
 */
// tslint:disable-next-line:no-var-requires
var defaultI18nFolderName = require('./ng-add/ng-add.schema.json')
    .properties.i18nFolderName.default;
/**
 * Locales supported by the Bootstrap theme.
 */
var themeSupportedLocales = {
    'en-US': 'I18N_EN_US',
    'pt-PT': 'I18N_PT_PT',
};
/**
 * Adds the application i18n to the project.
 * @param options Schematic options.
 * @returns Schematic rule.
 */
function addI18n$1(options) {
    var _this = this;
    return function (host) { return __awaiter(_this, void 0, void 0, function () {
        var project, modulePath, moduleDir, moduleName, localesArr, commonLocales, skipI18n, templateSource, localeTemplateSources, localesArr_1, localesArr_1_1, locale;
        var e_1, _a;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0: return [4 /*yield*/, schematics.getProject(host, options.project)];
                case 1:
                    project = _b.sent();
                    modulePath = schematics.getModulePath(host, project, options.module);
                    moduleDir = core.dirname(modulePath);
                    moduleName = schematics.getModuleNameFromPath(modulePath);
                    localesArr = getLocalesArrayFromString(options.locales);
                    commonLocales = Object.keys(themeSupportedLocales).reduce(function (obj, locale) {
                        if (localesArr.indexOf(locale) !== -1) {
                            obj[locale] = themeSupportedLocales[locale];
                        }
                        return obj;
                    }, {});
                    skipI18n = false;
                    templateSource = schematics$1.apply(schematics$1.url('ng-add/i18n/files'), [
                        schematics$1.applyTemplates(__assign(__assign(__assign({}, core.strings), options), { moduleName: moduleName, commonLocales: commonLocales, localesArr: localesArr })),
                        schematics$1.move(moduleDir),
                        schematics$1.forEach(function (entry) {
                            var path = entry.path;
                            if (host.exists(path)) {
                                if (path.endsWith('.i18n.ts')) {
                                    console.warn("File \"" + path.slice(1) + "\" already exists. Skipping i18n " +
                                        'generation.');
                                    skipI18n = true;
                                }
                                return null;
                            }
                            return entry;
                        }),
                    ]);
                    localeTemplateSources = [];
                    if (!skipI18n) {
                        try {
                            for (localesArr_1 = __values(localesArr), localesArr_1_1 = localesArr_1.next(); !localesArr_1_1.done; localesArr_1_1 = localesArr_1.next()) {
                                locale = localesArr_1_1.value;
                                localeTemplateSources.push(schematics$1.apply(schematics$1.url('ng-add/i18n/per-locale-files'), [
                                    schematics$1.applyTemplates(__assign(__assign(__assign({}, core.strings), options), { moduleName: moduleName, localesArr: localesArr, locale: locale })),
                                    schematics$1.move(moduleDir + "/" + options.i18nFolderName),
                                    schematics$1.forEach(function (entry) {
                                        return host.exists(entry.path) ? null : entry;
                                    }),
                                ]));
                            }
                        }
                        catch (e_1_1) { e_1 = { error: e_1_1 }; }
                        finally {
                            try {
                                if (localesArr_1_1 && !localesArr_1_1.done && (_a = localesArr_1.return)) _a.call(localesArr_1);
                            }
                            finally { if (e_1) throw e_1.error; }
                        }
                    }
                    return [2 /*return*/, schematics$1.chain(__spreadArray([
                            saveI18nOptions(options)
                        ], __read((skipI18n
                            ? []
                            : __spreadArray(__spreadArray([
                                schematics$1.mergeWith(templateSource)
                            ], __read(localeTemplateSources.map(function (source) { return schematics$1.mergeWith(source); }))), [
                                importAppI18n(options),
                            ])))))];
            }
        });
    }); };
}
/**
 * Imports the i18n object in the module.
 * @param options Schematic options.
 * @returns Schematic rule.
 */
function importAppI18n(options) {
    var _this = this;
    return function (host) { return __awaiter(_this, void 0, void 0, function () {
        var project, modulePath, moduleName;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, schematics.getProject(host, options.project)];
                case 1:
                    project = _a.sent();
                    modulePath = schematics.getModulePath(host, project, options.module);
                    moduleName = schematics.getModuleNameFromPath(modulePath);
                    schematics.addNgModuleValueProvider(host, modulePath, 'LF_APP_I18N', '@lightweightform/core', core.strings.camelize(moduleName) + "I18n", "./" + core.strings.dasherize(moduleName) + ".i18n");
                    return [2 /*return*/];
            }
        });
    }); };
}
/**
 * Saves the app locales and name of the i18n folder within `angular.json` when
 * necessary.
 * @param options Schematic options.
 * @returns Schematic rule.
 */
function saveI18nOptions(options) {
    return function (host) {
        schematics.setProjectSchematicOptions(host, options.project, '@lightweightform/bootstrap-theme:form', { locales: options.locales });
        if (options.i18nFolderName !== defaultI18nFolderName) {
            schematics.setProjectSchematicOptions(host, options.project, '@lightweightform/bootstrap-theme:form', { i18nFolderName: options.i18nFolderName });
        }
    };
}

/**
 * Content for the HTML file that should contain an `<lf-app>`.
 * @param setRouterOutlet Whether to set the `<router-outlet>`.
 * @returns File content containing an `<lf-app>`.
 */
function htmlComponentContent(setRouterOutlet) {
    if (setRouterOutlet === void 0) { setRouterOutlet = true; }
    return "<lf-app>\n  <!-- Top-bar of the application -->\n  <lf-top-bar [actions]=\"actions\">\n    <!-- Title -->\n    <lf-i18n key=\"label\"></lf-i18n>\n  </lf-top-bar>\n\n  <!-- Tree-nav -->\n  <lf-tree-nav></lf-tree-nav>\n\n  <!-- Content -->\n  " + (setRouterOutlet
        ? '<router-outlet></router-outlet>'
        : '<!-- <router-outlet></router-outlet> -->') + "\n</lf-app>";
}
/**
 * Actions to set as a property in the component's TS file.
 * @param localesArr Array of locales the application should support.
 * @returns Actions to set in the component's TS file.
 */
function tsComponentActions(localesArr) {
    return "[\n  {\n    id: 'save',\n    style: 'outline-secondary',\n    icon: 'save',\n    callback: () => this.save()\n  },\n  {\n    id: 'load',\n    style: 'outline-secondary',\n    icon: 'folder-open',\n    isDisabled: () => !this.lfFileStorage.loadIsSupported,\n    callback: () => this.load()\n  }," + (localesArr.length > 1
        ? "\n  {\n    id: 'language',\n    style: 'outline-primary',\n    icon: 'language',\n    options: this.lfI18n.languages.map(lang => ({\n      id: lang,\n      value: lang,\n      isActive: () => this.lfI18n.currentLanguage === lang\n    })),\n    callback: lang => this.lfI18n.setCurrentLanguage(lang)\n  },"
        : '') + "\n  {\n    id: 'validate',\n    style: 'outline-danger',\n    icon: 'check-square-o',\n    callback: () => this.lfApp.validate()\n  },\n  {\n    id: 'submit',\n    style: 'outline-success',\n    icon: 'send',\n    callback: () => this.submit()\n  }\n]";
}
/**
 * Method signature and body to set as the `ngOnInit` method of the component's
 * TS file.
 * @returns Method signature and body to set in the component's TS file.
 */
function tsComponentNgOnInit() {
    return "() {\n  if (!isDevMode()) {\n    this.lfUnloadAlert.enable();\n  }\n}";
}
/**
 * Method signature and body to set as the `save` method of the component's TS
 * file.
 * @returns Method signature and body to set in the component's TS file.
 */
function tsComponentSave(moduleName) {
    return "(): Promise<void> {\n  try {\n    const dateStr = new Date().toISOString().replace(/[T:.]/g, '-');\n    const fileName = `" + moduleName + "-${dateStr}`;\n    await this.lfFileStorage.saveToFile('/', fileName);\n    this.lfStorage.setPristine();\n  } catch (err) {\n    console.error('Error saving file:', err);\n  }\n}";
}
/**
 * Method signature and body to set as the `load` method of the component's TS
 * file.
 * @returns Method signature and body to set in the component's TS file.
 */
function tsComponentLoad() {
    return "(): Promise<void> {\n  try {\n    await this.lfFileStorage.loadFromFile('/');\n    this.lfStorage.setTouched('/', true);\n  } catch (err) {\n    console.error('Error loading file:', err);\n  }\n}";
}
/**
 * Method signature and body to set as the `submit` method of the component's TS
 * file.
 * @returns Method signature and body to set in the component's TS file.
 */
function tsComponentSubmit() {
    return "(): void {\n  if (!this.lfStorage.hasErrors()) {\n    const appJSON = JSON.stringify(this.lfStorage.getAsJS());\n    alert(appJSON); // Do something with the JSON\n  } else {\n    this.lfApp.validate();\n  }\n}";
}

/**
 * Adds an `<lf-app>` to the project.
 * @param options Schematic options.
 * @returns Schematic rule.
 */
function addLfApp(options) {
    var _this = this;
    return function (host) { return __awaiter(_this, void 0, void 0, function () {
        var project, modulePath, moduleName, moduleDir, componentTsPath, componentHtmlPath, localesArr;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, schematics.getProject(host, options.project)];
                case 1:
                    project = _a.sent();
                    modulePath = schematics.getModulePath(host, project, options.module);
                    moduleName = schematics.getModuleNameFromPath(modulePath);
                    moduleDir = core.dirname(modulePath);
                    componentTsPath = core.join(moduleDir, moduleName + ".component.ts");
                    componentHtmlPath = core.join(moduleDir, moduleName + ".component.html");
                    localesArr = getLocalesArrayFromString(options.locales);
                    if (!host.exists(componentTsPath)) {
                        return [2 /*return*/, schematics$1.chain([
                                schematics$1.externalSchematic('@schematics/angular', 'component', __assign(__assign({}, options), { flat: true, path: moduleDir, name: moduleName })),
                                function (h) { return h.overwrite(componentHtmlPath, htmlComponentContent()); },
                                editComponentTs$1(moduleName, localesArr, componentTsPath),
                            ])];
                    }
                    return [2 /*return*/, schematics$1.chain([
                            appendLfAppHtml(moduleName, localesArr, componentTsPath, componentHtmlPath),
                        ])];
            }
        });
    }); };
}
/**
 * Append the `<lf-app>` to the given HTML file and set the default `actions` in
 * the TS file.
 * @param componentTsPath Component's TS file path.
 * @param componentHtmlPath Component's HTML file path.
 * @returns Schematic rule.
 */
function appendLfAppHtml(moduleName, localesArr, componentTsPath, componentHtmlPath) {
    return function (host) {
        if (!host.exists(componentHtmlPath)) {
            return schematics$1.chain([
                function (h) { return h.create(componentHtmlPath, htmlComponentContent()); },
                editComponentTs$1(moduleName, localesArr, componentTsPath),
            ]);
        }
        var currentHtml = host.read(componentHtmlPath).toString('utf-8');
        if (!schematics.htmlContainsTag(currentHtml, 'lf-app')) {
            return schematics$1.chain([
                function (h) {
                    var newHtml;
                    if ((moduleName === 'app' &&
                        schematics.isUnmodifiedHtmlAppComponent(currentHtml)) ||
                        (moduleName !== 'app' &&
                            schematics.isUnmodifiedHtmlModuleComponent(currentHtml, moduleName))) {
                        newHtml = htmlComponentContent();
                    }
                    else {
                        console.warn("Prepended `<lf-app>` in \"" + componentHtmlPath.slice(1) + "\" " +
                            'since we cannot safely replace the existing content. Make ' +
                            'sure to adapt the file to your needs.');
                        newHtml =
                            htmlComponentContent(!schematics.htmlContainsTag(currentHtml, 'router-outlet')) + ("\n\n" + currentHtml);
                    }
                    h.overwrite(componentHtmlPath, newHtml);
                },
                editComponentTs$1(moduleName, localesArr, componentTsPath),
            ]);
        }
    };
}
/**
 * Sets the default `actions` in the component's TS file and the `ngOnInit`.
 * @param moduleName Name of the module we are working on.
 * @param componentTsPath Component's TS file path.
 * @returns Schematic rule.
 */
function editComponentTs$1(moduleName, localesArr, componentTsPath) {
    return function (host) {
        // Set actions property
        schematics.addTsComponentProperty(host, componentTsPath, 'actions', 'ActionsMenuAction[]', tsComponentActions(localesArr), undefined, [new schematics.TsImport('ActionsMenuAction', '@lightweightform/bootstrap-theme')]);
        // Add a property for referencing the `<lf-app>` (to call `validate` on)
        var importName = moduleName === 'app' ? 'LfAppComponent' : 'AppComponent';
        schematics.addTsComponentProperty(host, componentTsPath, 'lfApp', importName, undefined, ["@ViewChild(" + importName + ")"], [
            new schematics.TsImport('AppComponent', '@lightweightform/bootstrap-theme', importName),
            new schematics.TsImport('ViewChild', '@angular/core'),
        ]);
        // Inject `LfStorage`, `LfFileStorage`, `LfI18n`, and `LfUnloadAlert` when
        // appropriate
        schematics.addTsComponentConstructorParameter(host, componentTsPath, 'lfStorage', 'LfStorage', ['public'], [new schematics.TsImport('LfStorage', '@lightweightform/core')]);
        schematics.addTsComponentConstructorParameter(host, componentTsPath, 'lfFileStorage', 'LfFileStorage', ['public'], [new schematics.TsImport('LfFileStorage', '@lightweightform/core')]);
        if (localesArr.length > 1) {
            schematics.addTsComponentConstructorParameter(host, componentTsPath, 'lfI18n', 'LfI18n', ['public'], [new schematics.TsImport('LfI18n', '@lightweightform/core')]);
        }
        schematics.addTsComponentConstructorParameter(host, componentTsPath, 'lfUnloadAlert', 'LfUnloadAlert', ['public'], [new schematics.TsImport('LfUnloadAlert', '@lightweightform/core')]);
        // Add mock ngOnInit, save, load, and submit methods
        schematics.addTsComponentInterface(host, componentTsPath, 'OnInit', new schematics.TsImport('OnInit', '@angular/core'));
        schematics.addTsComponentMethod(host, componentTsPath, 'ngOnInit', tsComponentNgOnInit(), undefined, [new schematics.TsImport('isDevMode', '@angular/core')]);
        schematics.addTsComponentMethod(host, componentTsPath, 'save', tsComponentSave(moduleName), ['async']);
        schematics.addTsComponentMethod(host, componentTsPath, 'load', tsComponentLoad(), [
            'async',
        ]);
        schematics.addTsComponentMethod(host, componentTsPath, 'submit', tsComponentSubmit());
    };
}

/**
 * Adds the theme module and required services to the root `NgModule`.
 * @param options Schematic options.
 * @returns Schematic rule.
 */
function addThemeModuleAndProviders(options) {
    var _this = this;
    return function (host) { return __awaiter(_this, void 0, void 0, function () {
        var project, modulePath;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, schematics.getProject(host, options.project)];
                case 1:
                    project = _a.sent();
                    modulePath = schematics.getModulePath(host, project, options.module);
                    // Add `LfBootstrapThemeModule`
                    schematics.addNgModuleImport(host, modulePath, 'LfBootstrapThemeModule', '@lightweightform/bootstrap-theme');
                    // Add `LfStorage`, `LfFileStorage`, `LfI18n`, and `LfUnloadAlert` services
                    schematics.addNgModuleProvider(host, modulePath, 'LfStorage', '@lightweightform/core');
                    schematics.addNgModuleProvider(host, modulePath, 'LfFileStorage', '@lightweightform/core');
                    schematics.addNgModuleProvider(host, modulePath, 'LfI18n', '@lightweightform/core');
                    schematics.addNgModuleProvider(host, modulePath, 'LfUnloadAlert', '@lightweightform/core');
                    // Add the JSON serialiser `LfJsonSerializer` as the file storage serialiser
                    schematics.addNgModuleClassProvider(host, modulePath, 'LfSerializer', '@lightweightform/core', 'LfJsonSerializer', '@lightweightform/core');
                    return [2 /*return*/];
            }
        });
    }); };
}

/**
 * Adds the application schema to the project.
 * @param options Schematic options.
 * @returns Schematic rule.
 */
function addLfRouter(options) {
    var _this = this;
    return function (host) { return __awaiter(_this, void 0, void 0, function () {
        var project, modulePath, localesArr;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, schematics.getProject(host, options.project)];
                case 1:
                    project = _a.sent();
                    try {
                        modulePath = schematics.getModulePath(host, project, options.module, true);
                    }
                    catch (err) {
                        return [2 /*return*/, console.warn('Routing module not found. Skipping incorporation of `LfRouter`.')];
                    }
                    schematics.addNgModuleProvider(host, modulePath, 'LfRouter', '@lightweightform/core');
                    schematics.addNgModuleValueProvider(host, modulePath, 'LF_ROUTER_BASE_PATH', '@lightweightform/core', "'" + options.routerBasePath + "'");
                    localesArr = getLocalesArrayFromString(options.locales);
                    if (localesArr.length > 1) {
                        schematics.addNgModuleValueProvider(host, modulePath, 'LF_I18N_LANGUAGE_QUERY_PARAM', '@lightweightform/core', "'l'");
                    }
                    schematics.changeRoutesToLfRoutes(host, modulePath);
                    return [2 /*return*/];
            }
        });
    }); };
}

/**
 * Adds the application schema to the project.
 * @param options Schematic options.
 * @returns Schematic rule.
 */
function addAppSchema(options) {
    var _this = this;
    return function (host) { return __awaiter(_this, void 0, void 0, function () {
        var project, modulePath, moduleDir, moduleName, skipSchema, templateSource;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, schematics.getProject(host, options.project)];
                case 1:
                    project = _a.sent();
                    modulePath = schematics.getModulePath(host, project, options.module);
                    moduleDir = core.dirname(modulePath);
                    moduleName = schematics.getModuleNameFromPath(modulePath);
                    skipSchema = false;
                    templateSource = schematics$1.apply(schematics$1.url('ng-add/schema/files'), [
                        options.skipTests
                            ? schematics$1.filter(function (p) { return !p.endsWith('.spec.ts.template'); })
                            : schematics$1.noop(),
                        schematics$1.applyTemplates(__assign(__assign(__assign({}, core.strings), options), { moduleName: moduleName })),
                        schematics$1.move(moduleDir),
                        schematics$1.forEach(function (entry) {
                            var path = entry.path;
                            if (host.exists(path)) {
                                if (path.endsWith('.schema.ts')) {
                                    console.warn("File \"" + path.slice(1) + "\" already exists. Skipping schema " +
                                        'generation.');
                                    skipSchema = true;
                                }
                                return null;
                            }
                            return entry;
                        }),
                    ]);
                    return [2 /*return*/, skipSchema
                            ? schematics$1.noop()
                            : schematics$1.chain([schematics$1.mergeWith(templateSource), importAppSchema(options)])];
            }
        });
    }); };
}
/**
 * Imports the schema in the module.
 * @param options Schematic options.
 * @returns Schematic rule.
 */
function importAppSchema(options) {
    var _this = this;
    return function (host) { return __awaiter(_this, void 0, void 0, function () {
        var project, modulePath, moduleName;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, schematics.getProject(host, options.project)];
                case 1:
                    project = _a.sent();
                    modulePath = schematics.getModulePath(host, project, options.module);
                    moduleName = schematics.getModuleNameFromPath(modulePath);
                    schematics.addNgModuleValueProvider(host, modulePath, 'LF_APP_SCHEMA', '@lightweightform/core', core.strings.camelize(moduleName) + "Schema", "./" + core.strings.dasherize(moduleName) + ".schema");
                    return [2 /*return*/];
            }
        });
    }); };
}

/**
 * Content for the file that imports LF's Bootstrap-theme styles.
 * @param fileType Type of file where the content will be inserted.
 * @returns File content to import the theme.
 */
function themeStylesContent(fileType) {
    var semicolon = fileType === 'scss' ? ';' : '';
    var bsVersion = "4.6.1";
    var bsVersionMajMin = bsVersion.match(/^\d+\.\d+/)[0];
    // TODO: Get Bootstrap version from dependencies
    return "// Upstream Bootstrap variables and theme variables may be overridden here. See:\n// https://getbootstrap.com/docs/" + bsVersionMajMin + "/getting-started/theming/#variable-defaults\n// and https://github.com/twbs/bootstrap/blob/v" + bsVersion + "/scss/_variables.scss to\n// override Bootstrap variables. LF theme variables names can be found at:\n// https://bitbucket.org/opensoftgitrepo/lightweightform/src/master/libs/bootstrap-theme/src/scss-utils/_variables.scss\n\n@import '~@lightweightform/bootstrap-theme/scss/bootstrap-theme'" + semicolon;
}
/**
 * Whether an existing file content already imports the theme's styles.
 * @param content Current file content.
 * @returns Whether the current file current already imports the theme's styles.
 */
function containsImport(content) {
    var importRegExp = /@import\s+('|")~@lightweightform\/bootstrap-theme\/scss\/bootstrap-theme\1/;
    return content.match(importRegExp) !== null;
}

/**
 * File used to import the Bootstrap-theme styles.
 */
var themeStylesFilename = 'lf-bootstrap-theme.scss';
/**
 * Imports the Bootstrap-theme styles to the project.
 * @param options Schematic options.
 * @returns Schematic rule.
 */
function addThemeStyles(options) {
    var _this = this;
    var projectName = options.project;
    return function (host) { return __awaiter(_this, void 0, void 0, function () {
        var project, stylesPath, themeStylesPath, ext, insertion, recorder;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, schematics.getProject(host, projectName)];
                case 1:
                    project = _a.sent();
                    stylesPath = schematics.getProjectStyleFilePath(project, 'scss') ||
                        schematics.getProjectStyleFilePath(project, 'sass');
                    themeStylesPath = themeStylesFilePath(project);
                    if (!stylesPath || stylesPath === themeStylesPath) {
                        if (host.exists(themeStylesPath)) {
                            return [2 /*return*/, console.warn("File \"" + themeStylesPath + "\" already exists. Skipping import of " +
                                    'styles.')];
                        }
                        host.create(themeStylesPath, themeStylesContent('scss'));
                        schematics.addStylePathToProjectTarget(host, projectName, 'build', themeStylesPath);
                        schematics.addStylePathToProjectTarget(host, projectName, 'test', themeStylesPath);
                        return [2 /*return*/];
                    }
                    // Add theme styles only if they haven't already been imported
                    if (!containsImport(host.read(stylesPath).toString('utf-8'))) {
                        ext = stylesPath.slice(-4);
                        insertion = new change.InsertChange(stylesPath, 0, themeStylesContent(ext) + "\n\n");
                        recorder = host.beginUpdate(stylesPath);
                        recorder.insertLeft(insertion.pos, insertion.toAdd);
                        host.commitUpdate(recorder);
                    }
                    return [2 /*return*/];
            }
        });
    }); };
}
/**
 * File path of the file used to import the Bootstrap-theme styles.
 * @param project Project on which the styles are being added.
 * @returns File path.
 */
function themeStylesFilePath(project) {
    return core.normalize(core.join(project.sourceRoot || core.join(project.root, 'src'), themeStylesFilename));
}

/**
 * Adds application specific styles to the project.
 * @param options Schematic options.
 * @returns Schematic rule.
 */
function addAppStyles(options) {
    var _this = this;
    return function (host) { return __awaiter(_this, void 0, void 0, function () {
        var project, styleFilePath, buffer, content, indent, toInsert, recorder;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, schematics.getProject(host, options.project)];
                case 1:
                    project = _a.sent();
                    styleFilePath = schematics.getProjectStyleFilePath(project);
                    // Verify that the obtained path is not the path used by the schematics to
                    // imports the theme's styles
                    if (!styleFilePath || styleFilePath === themeStylesFilePath(project)) {
                        return [2 /*return*/, console.error('Could not find the default style file for the project.')];
                    }
                    buffer = host.read(styleFilePath);
                    if (!buffer) {
                        return [2 /*return*/, console.error("Could not read \"" + styleFilePath + "\" in the project.")];
                    }
                    content = buffer.toString('utf-8');
                    indent = schematics.getIndentation(content);
                    toInsert = '\n' +
                        (styleFilePath.endsWith('sass')
                            ? "html, body\n" + indent + "height: 100%\n"
                            : "html, body {\n" + indent + "height: 100%;\n}\n");
                    if (content.includes(toInsert)) {
                        return [2 /*return*/];
                    }
                    recorder = host.beginUpdate(styleFilePath);
                    recorder.insertLeft(content.length, toInsert);
                    host.commitUpdate(recorder);
                    return [2 /*return*/];
            }
        });
    }); };
}

/**
 * `ng-add-setup` schematic function.
 * @param options Schematic options.
 * @returns Schematic rule.
 */
function ngAddSetup(options) {
    return schematics$1.chain([
        copyAngularComponentSchematicOptions(options),
        addThemeModuleAndProviders(options),
        addThemeStyles(options),
        addAppStyles(options),
        addAppSchema(options),
        addLfRouter(options),
        addLfApp(options),
        addI18n$1(options),
        options.lintFix ? lintFix.applyLintFix() : schematics$1.noop(),
    ]);
}
/**
 * Copies the Angular component schematic options to our form schematic options
 * so that both schematics use the same defaults.
 * @param options Schematic options.
 * @returns Schematic rule.
 */
function copyAngularComponentSchematicOptions(options) {
    return function (host) {
        var ngComponentOptions = schematics.getProjectSchematicOptions(host, options.project, '@schematics/angular:component');
        if (ngComponentOptions) {
            schematics.setProjectSchematicOptions(host, options.project, '@lightweightform/bootstrap-theme:form', ngComponentOptions);
        }
    };
}

/**
 * HTML content for the form's component.
 * @param storagePath Form's storage path.
 * @returns HTML content for the form's component.
 */
function htmlFormComponentContent(storagePath, routePlaceholders) {
    var pathAssignment = routePlaceholders.length === 0 ? "path=\"" + storagePath + "\"" : '[path]="path"';
    return "<lf-form " + pathAssignment + ">\n</lf-form>";
}
/**
 * HTML content for the collection's component.
 * @param storagePath Collection's storage path.
 * @returns HTML content for the collection's component.
 */
function htmlCollectionComponentContent(storagePath, routePlaceholders) {
    var pathAssignment = routePlaceholders.length === 0 ? "path=\"" + storagePath + "\"" : '[path]="path"';
    return "<lf-form " + pathAssignment + ">\n  <lf-table path=\".\">\n    <lf-table-header>\n      <lf-table-column id=\"navigation\"></lf-table-column>\n    </lf-table-header>\n\n    <ng-template #lfTableRowTemplate let-id=\"id\">\n      <tr lf-table-row [path]=\"id\">\n        <td lf-table-cell>\n          <a\n            lf-button\n            size=\"sm\"\n            [style]=\"'outline-success'\"\n            [block]=\"true\"\n            [routerLink]=\"id\"\n            queryParamsHandling=\"merge\"\n          >\n            <lf-icon icon=\"share-square-o\"></lf-icon>\n            <lf-i18n path=\"..\" key=\"navigateButtonLabel\"></lf-i18n>\n          </a>\n        </td>\n      </tr>\n    </ng-template>\n  </lf-table>\n</lf-form>";
}
/**
 * Content for the getter used to get a component's storage path.
 * @param storagePath Component's storage path.
 * @param routeParams Param names for the component's route.
 * @returns `path` getter.
 */
function tsComponentPathGetterContent(storagePath, routeParams) {
    var paramsAsIds = routeParams.map(function (p) {
        return schematics.validTsIdRegExp.test(p) ? p : core.strings.camelize(p);
    });
    var paramsAsProps = routeParams.map(function (p, i) {
        return p === paramsAsIds[i] ? p : schematics.stringAsProperty(p) + ": " + paramsAsIds[i];
    });
    var j = 0;
    var pathWithParams = storagePath
        .split('/')
        .map(function (id) { return (id === '?' ? "${" + paramsAsIds[j++] + "}" : id); })
        .join('/');
    return "{\n  const { " + paramsAsProps.join(', ') + " } = this.lfRouter.params;\n  return `" + pathWithParams + "`;\n}\n";
}

/**
 * `form` schematic function.
 * @param options Schematic options.
 * @returns Schematic rule.
 */
function form(options) {
    var _this = this;
    return function (host) { return __awaiter(_this, void 0, void 0, function () {
        var project, moduleDir, formPath, formName, collectionPath, collectionName, formStoragePathId, formSchemaPath, collectionStoragePathId, collectionSchemaPath, schemaExplorer, parentStoragePath, routerModulePath, parentRouteInfo, routeParams;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, schematics.getProject(host, options.project)];
                case 1:
                    project = _a.sent();
                    moduleDir = core.dirname(schematics.getModulePath(host, project, options.module));
                    formPath = core.join(moduleDir, core.dirname(options.name));
                    formName = core.basename(options.name);
                    options.formName = formName;
                    if (options.collection) {
                        collectionPath = core.dirname(formPath);
                        if (options.flat) {
                            formPath = collectionPath;
                        }
                        collectionName = core.basename(core.dirname(options.name));
                        if (collectionName === '.') {
                            throw new schematics$1.SchematicsException('The provided name does not include the collection name. A name ' +
                                'is expected in the format: "collection-name/form-name", ' +
                                'possibly prepended by the path where the collection should be ' +
                                'created.');
                        }
                    }
                    formStoragePathId = core.strings.dasherize(formName);
                    formSchemaPath = core.join(formPath, options.flat ? '' : core.strings.dasherize(formName), core.strings.dasherize(formName) + '.schema.ts');
                    if (options.collection) {
                        formStoragePathId = '?';
                        collectionStoragePathId = core.strings.dasherize(collectionName);
                        collectionSchemaPath = core.join(collectionPath, options.flat ? '' : core.strings.dasherize(collectionName), core.strings.dasherize(collectionName) + '.schema.ts');
                    }
                    schemaExplorer = new schematics.SchemaExplorer(host, moduleDir);
                    parentStoragePath = options.parentPath ||
                        schematics.getParentStoragePath(schemaExplorer, options.collection ? collectionSchemaPath : formSchemaPath);
                    routerModulePath = schematics.getModulePath(host, project, options.module, true);
                    parentRouteInfo = schematics.getLfRouteInfo(host, routerModulePath, parentStoragePath);
                    routeParams = parentRouteInfo
                        ? parentRouteInfo.params
                        : // Default params from parent storage path
                            parentStoragePath
                                .split('/')
                                .filter(function (id) { return id === '?'; })
                                .map(function (_, i) { return "param-" + (i + 1); });
                    return [2 /*return*/, schematics$1.chain([
                            options.collection
                                ? createCollection(options, schemaExplorer, moduleDir, routerModulePath, formName, collectionPath, collectionName, collectionSchemaPath, formSchemaPath, collectionStoragePathId, parentStoragePath, routeParams)
                                : schematics$1.noop(),
                            createForm(options, schemaExplorer, moduleDir, routerModulePath, formPath, formName, formSchemaPath, formStoragePathId, options.collection
                                ? core.join(parentStoragePath, collectionStoragePathId)
                                : parentStoragePath, options.collection
                                ? __spreadArray(__spreadArray([], __read(routeParams)), [core.strings.dasherize(formName) + "-id"]) : routeParams),
                        ])];
            }
        });
    }); };
}
/**
 * Creates the form collection.
 * @param options Schematic options.
 * @param schemaExplorer `SchemaExplorer` instance.
 * @param moduleDir Module directory where to find the root schema.
 * @param routerModulePath Path of the router module.
 * @param formName Form name.
 * @param path Path where the collection is being created (independently of
 * whether it is flat).
 * @param name Collection name.
 * @param schemaPath Path of the collection's schema.
 * @param formSchemaPath Path of the form's schema.
 * @param storagePathId Id of the collection in the storage path.
 * @param parentStoragePath Storage path of the collection's parent.
 * @param routeParams Param names for the collection's route.
 * @returns Schematic rule.
 */
function createCollection(options, schemaExplorer, moduleDir, routerModulePath, formName, path, name, schemaPath, formSchemaPath, storagePathId, parentStoragePath, routeParams) {
    return function () {
        var formSchemaImportPath = schematics.relativeTsImportPath(schemaPath, formSchemaPath);
        var storagePath = core.join(parentStoragePath, storagePathId);
        return schematics$1.chain([
            options.skipCollectionComponent
                ? schematics$1.noop()
                : schematics$1.externalSchematic('@schematics/angular', 'component', __assign(__assign({}, options), { path: path, name: name, lintFix: false })),
            addSchema(options, schemaExplorer, path, name, schemaPath, storagePathId, storagePath, parentStoragePath, 'collection-files', { formName: formName, formSchemaImportPath: formSchemaImportPath }),
            addI18n(options, moduleDir, path, name, storagePath, 'collection-per-locale-files'),
            options.skipCollectionComponent
                ? schematics$1.noop()
                : setHtml(options, path, name, htmlCollectionComponentContent(storagePath, routeParams)),
            options.skipCollectionComponent
                ? schematics$1.noop()
                : editComponentTs(options, path, name, storagePath, routeParams),
            options.skipCollectionComponent
                ? schematics$1.noop()
                : addRoute(options, routerModulePath, path, name, storagePath, routeParams),
            options.lintFix ? lintFix.applyLintFix() : schematics$1.noop(),
        ]);
    };
}
/**
 * Creates the form.
 * @param options Schematic options.
 * @param schemaExplorer `SchemaExplorer` instance.
 * @param moduleDir Module directory where to find the root schema.
 * @param routerModulePath Path of the router module.
 * @param path Path where the form is being created (independently of whether it
 * is flat).
 * @param name Form name.
 * @param schemaPath Path of the form's schema.
 * @param storagePathId Id of the form in the storage path.
 * @param parentStoragePath Storage path of the form's parent.
 * @param routeParams Param names for the form's route.
 * @returns Schematic rule.
 */
function createForm(options, schemaExplorer, moduleDir, routerModulePath, path, name, schemaPath, storagePathId, parentStoragePath, routeParams) {
    return function () {
        var storagePath = core.join(parentStoragePath, storagePathId);
        return schematics$1.chain([
            schematics$1.externalSchematic('@schematics/angular', 'component', __assign(__assign({}, options), { path: path, name: name, lintFix: false })),
            addSchema(options, schemaExplorer, path, name, schemaPath, storagePathId, storagePath, parentStoragePath, 'form-files', {}, !options.collection),
            addI18n(options, moduleDir, path, name, storagePath, 'form-per-locale-files'),
            setHtml(options, path, name, htmlFormComponentContent(storagePath, routeParams)),
            editComponentTs(options, path, name, storagePath, routeParams),
            addRoute(options, routerModulePath, path, name, storagePath, routeParams),
            options.lintFix ? lintFix.applyLintFix() : schematics$1.noop(),
        ]);
    };
}
/**
 * Add needed schema files.
 * @param options Schematic options.
 * @param schemaExplorer `SchemaExplorer` instance.
 * @param path Path where the component is being created (independently of
 * whether it is flat).
 * @param name Component name.
 * @param schemaPath Path of the component's schema to add.
 * @param storagePathId Identifier of the component's schema in the storage
 * path.
 * @param storagePath Path of the component's schema in the storage.
 * @param parentStoragePath Parent path of the component's schema in the
 * storage.
 * @param filesDir Directory containing the files to be created.
 * @param addToParent Whether to add the component's schema to the parent
 * schema.
 * @returns Schematic rule.
 */
function addSchema(options, schemaExplorer, path, name, schemaPath, storagePathId, storagePath, parentStoragePath, filesDir, extraTemplateBindings, addToParent) {
    if (extraTemplateBindings === void 0) { extraTemplateBindings = {}; }
    if (addToParent === void 0) { addToParent = true; }
    return function (host) {
        var tsSchemaName = core.strings.camelize(name) + "Schema";
        var rootSchemaInfo = schemaExplorer.getSchemaInfoFromStoragePath('/');
        var rootSchemaImportPath = schematics.relativeTsImportPath(schemaPath, rootSchemaInfo.fileInfo.filePath);
        var templateSource = schematics$1.apply(schematics$1.url("form/" + filesDir), [
            options.skipTests
                ? schematics$1.filter(function (p) { return !p.endsWith('.spec.ts.template'); })
                : schematics$1.noop(),
            schematics$1.applyTemplates(__assign(__assign(__assign(__assign({}, core.strings), options), { 'if-flat': function (str) { return (options.flat ? '' : str); }, name: name, storagePath: storagePath, rootTsSchemaName: schemaExplorer.rootSchemaName, rootSchemaImportPath: rootSchemaImportPath }), extraTemplateBindings)),
            schematics$1.move(path),
        ]);
        if (addToParent) {
            schematics.addSchemaToParentSchema(host, schemaExplorer, schemaPath, tsSchemaName, storagePathId, parentStoragePath);
        }
        return schematics$1.chain([schematics$1.mergeWith(templateSource)]);
    };
}
/**
 * Add component's i18n objects.
 * @param options Schematic options.
 * @param moduleDir Module directory where to find the root i18n file.
 * @param path Path where the component is being created (independently of
 * whether it is flat).
 * @param name Component name.
 * @param storagePath Path of the component's schema in the storage.
 * @param filesDir Directory where to find the "per-locale" i18n files.
 * @returns Schematic rule.
 */
function addI18n(options, moduleDir, path, name, storagePath, filesDir) {
    return function (host) {
        var e_1, _a;
        var localesArr = getLocalesArrayFromString(options.locales);
        var rootI18nPath = schematics.getRootI18nPath(host, moduleDir);
        var i18nDirPath = core.join(path, options.flat ? '' : core.strings.dasherize(name), options.i18nFolderName);
        // Per language sources
        var languageTemplateSources = [];
        try {
            for (var localesArr_1 = __values(localesArr), localesArr_1_1 = localesArr_1.next(); !localesArr_1_1.done; localesArr_1_1 = localesArr_1.next()) {
                var locale = localesArr_1_1.value;
                languageTemplateSources.push(schematics$1.apply(schematics$1.url("form/" + filesDir), [
                    schematics$1.applyTemplates(__assign(__assign(__assign({}, core.strings), options), { name: name, locale: locale, storagePath: storagePath })),
                    schematics$1.move(i18nDirPath),
                ]));
                // Add locale to the root i18n
                var localePath = core.join(i18nDirPath, core.strings.dasherize(name) + ".i18n." + locale + ".ts");
                var localeTsName = core.strings.camelize(name) + "I18n" + core.strings.classify(locale);
                schematics.addFormLocaleToRootI18n(host, rootI18nPath, locale, localePath, localeTsName);
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (localesArr_1_1 && !localesArr_1_1.done && (_a = localesArr_1.return)) _a.call(localesArr_1);
            }
            finally { if (e_1) throw e_1.error; }
        }
        return schematics$1.chain(__spreadArray([], __read(languageTemplateSources.map(function (source) { return schematics$1.mergeWith(source); }))));
    };
}
/**
 * Sets the component's HTML content.
 * @param options Schematic options.
 * @param path Path where the component is being created (independently of
 * whether it is flat).
 * @param name Component name.
 * @param htmlContent HTML content to set.
 * @returns Schematic rule.
 */
function setHtml(options, path, name, htmlContent) {
    return function (host) {
        if (!options.inlineTemplate) {
            var componentHtmlPath = core.join(path, options.flat ? '' : core.strings.dasherize(name), core.strings.dasherize(name) + '.component.html');
            host.overwrite(componentHtmlPath, htmlContent);
        }
        else {
            var componentTsPath = core.join(path, options.flat ? '' : core.strings.dasherize(name), core.strings.dasherize(name) + '.component.ts');
            schematics.setTsComponentInlineTemplate(host, componentTsPath, htmlContent);
        }
    };
}
/**
 * Adds a way of accessing the component's path when needed.
 * @param options Schematic options.
 * @param path Path where the component is being created (independently of
 * whether it is flat).
 */
function editComponentTs(options, path, name, storagePath, routeParams) {
    return function (host) {
        if (routeParams.length > 0) {
            var componentTsPath = core.join(path, options.flat ? '' : core.strings.dasherize(name), core.strings.dasherize(name) + '.component.ts');
            // Add `lfRouter` to constructor
            schematics.addTsComponentConstructorParameter(host, componentTsPath, 'lfRouter', 'LfRouter', ['private'], [new schematics.TsImport('LfRouter', '@lightweightform/core')]);
            // Set `path` getter
            schematics.addTsComponentGetter(host, componentTsPath, 'path', 'string', tsComponentPathGetterContent(storagePath, routeParams), ['@computed'], [new schematics.TsImport('computed', 'mobx-angular')]);
        }
    };
}
/**
 * Add a route to the form.
 * @param options Schematic options.
 * @param routerModulePath Path of the router module.
 * @param name Form name.
 * @param project Project where the form is being created.
 * @param storagePath Path of the form in the storage.
 * @returns Schematic rule.
 */
function addRoute(options, routerModulePath, path, name, storagePath, routeParams) {
    return function (host) {
        if (!routerModulePath) {
            return console.warn('Routing module not found. Skipping insertion of component route.');
        }
        var i = 0;
        var routePath = storagePath
            .slice(1)
            .split('/')
            .map(function (id) { return (id === '?' ? ":" + routeParams[i++] : id); })
            .join('/');
        // Add a redirect to the route when there are no routes
        if (!schematics.hasRoutes(host, routerModulePath)) {
            schematics.addLfRoute(host, routerModulePath, {
                routePath: '',
                storagePath: '/',
                redirectTo: routePath,
                pathMatch: 'full',
            });
        }
        var componentTsName = core.strings.classify(name) + "Component";
        var componentFilePath = core.join(path, options.flat ? '' : core.strings.dasherize(name), core.strings.dasherize(name) + '.component.ts');
        schematics.addLfRoute(host, routerModulePath, {
            routePath: routePath,
            storagePath: storagePath,
            componentTsName: componentTsName,
            componentFilePath: componentFilePath,
        });
    };
}

exports.createCollection = createCollection;
exports.createForm = createForm;
exports.form = form;
exports.ngAddSetup = ngAddSetup;
//# sourceMappingURL=index.js.map
