import * as i3 from '@angular/cdk/scrolling';
import { ScrollingModule } from '@angular/cdk/scrolling';
import * as i7 from '@angular/common';
import { CommonModule } from '@angular/common';
import * as i0 from '@angular/core';
import { Component, ChangeDetectionStrategy, Input, HostBinding, EventEmitter, Directive, Output, ElementRef, Optional, SkipSelf, Inject, ContentChild, HostListener, ViewChild, ViewChildren, Injectable, NgModule } from '@angular/core';
import { BrowserAnimationsModule } from '@angular/platform-browser/animations';
import * as i7$1 from '@angular/router';
import { RouterModule } from '@angular/router';
import * as i1 from '@lightweightform/core';
import { PathBased, LfI18n, LfRouter, LfFileStorage, LfCoreModule, I18N_UNLOAD_ALERT_MESSAGE_KEY } from '@lightweightform/core';
import * as i2$2 from '@lightweightform/theme-common';
import { asap, TableHeaderDirective, LfTableHeaderModule } from '@lightweightform/theme-common';
import * as i6 from 'mobx-angular';
import { observable, computed, action, MobxAngularModule } from 'mobx-angular';
import * as i9 from 'ngx-bootstrap/datepicker';
import { BsDatepickerModule } from 'ngx-bootstrap/datepicker';
import * as i2$1 from 'ngx-bootstrap/tooltip';
import { TooltipModule } from 'ngx-bootstrap/tooltip';
import * as i2 from 'ngx-markdown';
import { MarkedRenderer, MarkdownModule } from 'ngx-markdown';
import { __decorate, __awaiter } from 'tslib';
import { makeObservable, reaction, runInAction, observe, autorun, comparer } from 'mobx';
import 'bootstrap/js/dist/dropdown.js';
import $ from 'jquery';
import { compareDates, DATE_OUT_OF_BOUNDS_CODE, DATE_OUT_OF_BOUNDS_TYPE, isArrayLike, tupleSchema, dateSchema, isTupleSchema, isDateSchema, resolvePath, LENGTH_OUT_OF_BOUNDS_TYPE, LENGTH_OUT_OF_BOUNDS_CODE, NUMBER_OUT_OF_BOUNDS_TYPE, NUMBER_OUT_OF_BOUNDS_CODE, SIZE_OUT_OF_BOUNDS_TYPE, SIZE_OUT_OF_BOUNDS_CODE, DISALLOWED_VALUE_TYPE, DISALLOWED_VALUE_CODE, IS_REQUIRED_TYPE, IS_REQUIRED_CODE, ValidationMode, isRecordSchema, isNullableSchema, pathError, isReservedStateProp, getStateProperty, isListSchema, isBooleanSchema, isStringSchema, isNumberSchema, getRowId, isTableSchema, appendToPath, isComplexSchema, IS_REJECTED_CODE } from '@lightweightform/storage';
import { PENDING, isPromiseBasedObservable } from 'mobx-utils';
import 'bootstrap/js/dist/modal.js';
import { NumericInput } from '@lightweightform/numeric-input';
import { animationFrameScheduler, asapScheduler } from 'rxjs';
import { auditTime } from 'rxjs/operators';
import { defineLocale } from 'ngx-bootstrap/chronos';
import { esLocale, ptBrLocale } from 'ngx-bootstrap/locale';

// App =========================================================================
/**
 * I18n key used to set the locale used by `ngx-bootstrap`.
 */
const I18N_BS_LOCALE_KEY = 'bsLocale';
// Value =======================================================================
/**
 * I18n key used to associate a label with a value.
 */
const I18N_VALUE_LABEL_KEY = 'label';
/**
 * I18n key used to associate a code with a value.
 */
const I18N_VALUE_CODE_KEY = 'code';
/**
 * I18n key used to associate a help message with a value.
 */
const I18N_VALUE_HELP_MESSAGE_KEY = 'helpMessage';
/**
 * I18n key used to associate a legend with a value.
 */
const I18N_VALUE_LEGEND_KEY = 'legend';
/**
 * I18n key used to associate messages with validation errors.
 */
const I18N_VALIDATIONS_KEY = 'validations';
/**
 * I18n key used to ask the user to retry validating the value.
 */
const I18N_VALUE_RETRY_VALIDATE_TEXT_KEY = 'retryValidateText';
// Tree-nav ====================================================================
/**
 * I18n key used to set the text of the dropdown button used to add optional
 * forms.
 */
const I18N_TREE_NAV_ADD_OPTIONAL_VALUE_BUTTON_TEXT_KEY = 'addOptionalValueButtonText';
/**
 * I18n key used to set the text of the button used to add forms to a list of
 * forms.
 */
const I18N_TREE_NAV_ADD_VALUE_TO_LIST_BUTTON_TEXT_KEY = 'addValueToListButtonText';
// Closeable ===================================================================
/**
 * I18n key used to set the text of the tooltip of the "close" button in
 * components.
 */
const I18N_CLOSE_BUTTON_TOOLTIP_KEY = 'closeButtonTooltip';
// Actions-menu ================================================================
/**
 * I18n key used to set the text of the actions-menu button when it is in
 * "mobile" mode.
 */
const I18N_ACTIONS_MENU_BUTTON_TEXT_KEY = 'actionsButtonText';
/**
 * I18n key used to translate the text of the buttons.
 */
const I18N_ACTIONS_MENU_KEY = 'actionsMenu';
/**
 * I18n key used to translate the text of the options of the buttons.
 */
const I18N_ACTIONS_MENU_OPTIONS_KEY = 'actionsMenuOptions';
// Validation panel ============================================================
/**
 * I18n key used to set the "errors" title of validation panel.
 */
const I18N_VALIDATION_PANEL_ERRORS_TEXT_KEY = 'errorsText';
/**
 * I18n key used to set the "warnings" title of validation panel.
 */
const I18N_VALIDATION_PANEL_WARNINGS_TEXT_KEY = 'warningsText';
/**
 * I18n key used to set the text that shows up in the validation panel when
 * there are no errors or warnings.
 */
const I18N_VALIDATION_PANEL_NO_ISSUES_TEXT_KEY = 'noIssuesText';
/**
 * I18n key used to set the text of the tooltip of the "focus" button in the
 * validation panel.
 */
const I18N_VALIDATION_PANEL_FOCUS_TEXT_KEY = 'focusButtonTooltip';
/**
 * I18n key used to set the text of the tooltip of the "next" button in the
 * validation panel.
 */
const I18N_VALIDATION_PANEL_NEXT_BUTTON_TOOLTIP_KEY = 'nextButtonTooltip';
/**
 * I18n key used to set the text of the tooltip of the "previous" button in the
 * validation panel.
 */
const I18N_VALIDATION_PANEL_PREV_BUTTON_TOOLTIP_KEY = 'prevButtonTooltip';
// Form ========================================================================
/**
 * I18n key used to set the text of a form component's help action.
 */
const I18N_FORM_HELP_ACTION_TEXT_KEY = 'helpActionText';
/**
 * I18n key used to set the text of a form component's remove action.
 */
const I18N_FORM_REMOVE_ACTION_TEXT_KEY = 'removeActionText';
/**
 * I18n key used to set the message displayed to the user in a form component to
 * confirm removal of a form.
 */
const I18N_FORM_ENSURE_REMOVE_TEXT_KEY = 'ensureRemoveText';
/**
 * I18n key used to set the text of a form component's "cancel" button in the
 * removal modal.
 */
const I18N_FORM_CANCEL_REMOVE_BUTTON_TEXT_KEY = 'cancelRemoveButtonText';
/**
 * I18n key used to set the text of a form component's "confirm" button in the
 * removal modal.
 */
const I18N_FORM_CONFIRM_REMOVE_BUTTON_TEXT_KEY = 'confirmRemoveButtonText';
// Date ========================================================================
/**
 * I18n key used to set the format of a date component.
 */
const I18N_DATE_FORMAT_KEY = 'format';
/**
 * I18n key used to set the placeholder of a date component's input field.
 */
const I18N_DATE_PLACEHOLDER_KEY = 'placeholder';
// Date range ==================================================================
/**
 * I18n keys used to set the separator of the date range.
 */
const I18N_DATE_RANGE_SEPARATOR_KEY = 'separator';
// File ========================================================================
/**
 * I18n key used to set the "Choose file" placeholder of the file input.
 */
const I18N_FILE_CHOOSE_PLACEHOLDER_KEY = 'choosePlaceholder';
/**
 * I18n key used to set the "Browse" text of the file input.
 */
const I18N_FILE_BROWSE_TEXT_KEY = 'browseText';
/**
 * I18n key used to set the "No file chosen" text of the file input.
 */
const I18N_FILE_NONE_CHOSEN_KEY = 'noneChosenText';
/**
 * I18n key used to set the "Clear" button tooltip text.
 */
const I18N_FILE_CLEAR_BUTTON_TOOLTIP_KEY = 'clearButtonTooltip';
// Number ======================================================================
/**
 * I18n key used to set the prefix of a number component.
 */
const I18N_NUMBER_PREFIX_KEY = 'prefix';
/**
 * I18n key used to set the suffix of a number component.
 */
const I18N_NUMBER_SUFFIX_KEY = 'suffix';
/**
 * I18n key used to set the decimal separator of a number component.
 */
const I18N_NUMBER_DECIMAL_SEPARATOR_KEY = 'decimalSeparator';
/**
 * I18n key used to set the "thousands separator" of a number component.
 */
const I18N_NUMBER_THOUSANDS_SEPARATOR_KEY = 'thousandsSeparator';
// Table =======================================================================
/**
 * I18n key used to translate the "add row" text of the table component.
 */
const I18N_TABLE_ADD_ROW_ACTION_TEXT_KEY = 'addRowActionText';
/**
 * I18n key used to translate the "remove rows" text of the table component.
 */
const I18N_TABLE_REMOVE_ROWS_ACTION_TEXT_KEY = 'removeRowsActionText';
/**
 * I18n key used to translate the "no rows" text of the table component.
 */
const I18N_TABLE_NO_ROWS_TEXT_KEY = 'noRowsText';
/**
 * I18n key used to set the labels of the table columns in the table component.
 */
const I18N_TABLE_COLUMN_LABELS_KEY = 'columnLabels';
// Selection ===================================================================
/**
 * I18n key used to specify the list of options.
 */
const I18N_SELECTION_OPTIONS_KEY = 'options';
/**
 * I18n key used to translate the "no options" message on components that
 * require options.
 */
const I18N_SELECTION_NO_OPTIONS_TEXT_KEY = 'noOptionsText';

/**
 * Bootstrap button component.
 */
class ButtonComponent {
    constructor(_host) {
        /**
         * Button style. See available styles at [Bootstrap documentation](
         * https://getbootstrap.com/docs/4.0/components/buttons/#examples).
         */
        Object.defineProperty(this, "style", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        /**
         * Button size. See available sizes at [Bootstrap documentation](
         * https://getbootstrap.com/docs/4.0/components/buttons/#sizes).
         */
        Object.defineProperty(this, "size", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        /**
         * HTML button type.
         */
        Object.defineProperty(this, "type", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: 'button'
        });
        /**
         * Match the width of parent if `true`.
         */
        Object.defineProperty(this, "block", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: false
        });
        /**
         * Display a dropdown icon (this is automatic if `dropdownToggleSplit` is
         * set).
         */
        Object.defineProperty(this, "dropdownToggle", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: false
        });
        /**
         * Reduces the padding of the button so it can be used as the dropdown part of
         * a split dropdown.
         */
        Object.defineProperty(this, "dropdownToggleSplit", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: false
        });
        /**
         * Set the button as disabled.
         */
        Object.defineProperty(this, "isDisabled", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: false
        });
        /**
         * Set the button as active.
         */
        Object.defineProperty(this, "isActive", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: false
        });
        /**
         * Always add the class `btn` to LF buttons.
         */
        Object.defineProperty(this, "_hostClassBtn", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: true
        });
        /**
         * Tag of the element (`'button'` or `'a'`).
         */
        Object.defineProperty(this, "_tagName", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        makeObservable(this);
        this._tagName = _host.nativeElement.tagName.toLowerCase();
    }
    // Set the role as `'button'` when the element is an `a`.
    get _role() {
        return this._tagName === 'a' ? 'button' : undefined;
    }
    // Set the corresponding style class depending on the button style (setting
    // individual classes instead of `class` itself makes it possible for the user
    // to still set `class` on the component without it being overridden)
    get _hostClassBtnPrimary() {
        return this.style === 'primary';
    }
    get _hostClassBtnSecondary() {
        return this.style === 'secondary';
    }
    get _hostClassBtnSuccess() {
        return this.style === 'success';
    }
    get _hostClassBtnDanger() {
        return this.style === 'danger';
    }
    get _hostClassBtnWarning() {
        return this.style === 'warning';
    }
    get _hostClassBtnInfo() {
        return this.style === 'info';
    }
    get _hostClassBtnLight() {
        return this.style === 'light';
    }
    get _hostClassBtnDark() {
        return this.style === 'dark';
    }
    get _hostClassBtnLink() {
        return this.style === 'link';
    }
    get _hostClassBtnOutlinePrimary() {
        return this.style === 'outline-primary';
    }
    get _hostClassBtnOutlineSecondary() {
        return this.style === 'outline-secondary';
    }
    get _hostClassBtnOutlineSuccess() {
        return this.style === 'outline-success';
    }
    get _hostClassBtnOutlineDanger() {
        return this.style === 'outline-danger';
    }
    get _hostClassBtnOutlineWarning() {
        return this.style === 'outline-warning';
    }
    get _hostClassBtnOutlineInfo() {
        return this.style === 'outline-info';
    }
    get _hostClassBtnOutlineLight() {
        return this.style === 'outline-light';
    }
    get _hostClassBtnOutlineDark() {
        return this.style === 'outline-dark';
    }
    // Set the corresponding style class
    get _hostClassBtnSm() {
        return this.size === 'sm';
    }
    get _hostClassBtnLg() {
        return this.size === 'lg';
    }
    // Set the dropdown toggle class when possible
    get _hostClassDropdownToggle() {
        return (this._tagName !== 'input' &&
            (this.dropdownToggle || this.dropdownToggleSplit));
    }
    // Set type to `'button'` by default (on `button`s and `input`s)
    get _hostType() {
        return this._tagName !== 'a' ? this.type || 'button' : undefined;
    }
    get _hostDisabled() {
        return this._tagName !== 'a' && this.isDisabled ? '' : undefined;
    }
    get _hostAriaDisabled() {
        return this._tagName !== 'a' && this.isDisabled ? 'true' : undefined;
    }
    get _hostAriaPressed() {
        return this.isActive ? 'true' : undefined;
    }
}
Object.defineProperty(ButtonComponent, "\u0275fac", {
    enumerable: true,
    configurable: true,
    writable: true,
    value: i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0, type: ButtonComponent, deps: [{ token: i0.ElementRef }], target: i0.ɵɵFactoryTarget.Component })
});
Object.defineProperty(ButtonComponent, "\u0275cmp", {
    enumerable: true,
    configurable: true,
    writable: true,
    value: i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.15", type: ButtonComponent, selector: "button[lf-button], input[lf-button], a[lf-button]", inputs: { style: "style", size: "size", type: "type", block: "block", dropdownToggle: "dropdownToggle", dropdownToggleSplit: "dropdownToggleSplit", isDisabled: "isDisabled", isActive: "isActive" }, host: { properties: { "class.btn-block": "this.block", "class.dropdown-toggle-split": "this.dropdownToggleSplit", "class.active": "this.isActive", "class.btn": "this._hostClassBtn", "attr.role": "this._role", "class.btn-primary": "this._hostClassBtnPrimary", "class.btn-secondary": "this._hostClassBtnSecondary", "class.btn-success": "this._hostClassBtnSuccess", "class.btn-danger": "this._hostClassBtnDanger", "class.btn-warning": "this._hostClassBtnWarning", "class.btn-info": "this._hostClassBtnInfo", "class.btn-light": "this._hostClassBtnLight", "class.btn-dark": "this._hostClassBtnDark", "class.btn-link": "this._hostClassBtnLink", "class.btn-outline-primary": "this._hostClassBtnOutlinePrimary", "class.btn-outline-secondary": "this._hostClassBtnOutlineSecondary", "class.btn-outline-success": "this._hostClassBtnOutlineSuccess", "class.btn-outline-danger": "this._hostClassBtnOutlineDanger", "class.btn-outline-warning": "this._hostClassBtnOutlineWarning", "class.btn-outline-info": "this._hostClassBtnOutlineInfo", "class.btn-outline-light": "this._hostClassBtnOutlineLight", "class.btn-outline-dark": "this._hostClassBtnOutlineDark", "class.btn-sm": "this._hostClassBtnSm", "class.btn-lg": "this._hostClassBtnLg", "class.dropdown-toggle": "this._hostClassDropdownToggle", "attr.type": "this._hostType", "attr.disabled": "this._hostDisabled", "attr.aria-disabled": "this._hostAriaDisabled", "attr.aria-pressed": "this._hostAriaPressed" } }, ngImport: i0, template: '<ng-container *mobxAutorun><ng-content></ng-content></ng-container>', isInline: true, directives: [{ type: i6.MobxAutorunDirective, selector: "[mobxAutorun]", inputs: ["mobxAutorun"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush })
});
__decorate([
    observable
], ButtonComponent.prototype, "style", void 0);
__decorate([
    observable
], ButtonComponent.prototype, "size", void 0);
__decorate([
    observable
], ButtonComponent.prototype, "type", void 0);
__decorate([
    observable
], ButtonComponent.prototype, "block", void 0);
__decorate([
    observable
], ButtonComponent.prototype, "dropdownToggle", void 0);
__decorate([
    observable
], ButtonComponent.prototype, "dropdownToggleSplit", void 0);
__decorate([
    observable
], ButtonComponent.prototype, "isDisabled", void 0);
__decorate([
    observable
], ButtonComponent.prototype, "isActive", void 0);
__decorate([
    computed
], ButtonComponent.prototype, "_hostClassBtnPrimary", null);
__decorate([
    computed
], ButtonComponent.prototype, "_hostClassBtnSecondary", null);
__decorate([
    computed
], ButtonComponent.prototype, "_hostClassBtnSuccess", null);
__decorate([
    computed
], ButtonComponent.prototype, "_hostClassBtnDanger", null);
__decorate([
    computed
], ButtonComponent.prototype, "_hostClassBtnWarning", null);
__decorate([
    computed
], ButtonComponent.prototype, "_hostClassBtnInfo", null);
__decorate([
    computed
], ButtonComponent.prototype, "_hostClassBtnLight", null);
__decorate([
    computed
], ButtonComponent.prototype, "_hostClassBtnDark", null);
__decorate([
    computed
], ButtonComponent.prototype, "_hostClassBtnLink", null);
__decorate([
    computed
], ButtonComponent.prototype, "_hostClassBtnOutlinePrimary", null);
__decorate([
    computed
], ButtonComponent.prototype, "_hostClassBtnOutlineSecondary", null);
__decorate([
    computed
], ButtonComponent.prototype, "_hostClassBtnOutlineSuccess", null);
__decorate([
    computed
], ButtonComponent.prototype, "_hostClassBtnOutlineDanger", null);
__decorate([
    computed
], ButtonComponent.prototype, "_hostClassBtnOutlineWarning", null);
__decorate([
    computed
], ButtonComponent.prototype, "_hostClassBtnOutlineInfo", null);
__decorate([
    computed
], ButtonComponent.prototype, "_hostClassBtnOutlineLight", null);
__decorate([
    computed
], ButtonComponent.prototype, "_hostClassBtnOutlineDark", null);
__decorate([
    computed
], ButtonComponent.prototype, "_hostClassBtnSm", null);
__decorate([
    computed
], ButtonComponent.prototype, "_hostClassBtnLg", null);
__decorate([
    computed
], ButtonComponent.prototype, "_hostClassDropdownToggle", null);
__decorate([
    computed
], ButtonComponent.prototype, "_hostType", null);
__decorate([
    computed
], ButtonComponent.prototype, "_hostDisabled", null);
__decorate([
    computed
], ButtonComponent.prototype, "_hostAriaDisabled", null);
__decorate([
    computed
], ButtonComponent.prototype, "_hostAriaPressed", null);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0, type: ButtonComponent, decorators: [{
            type: Component,
            args: [{
                    // tslint:disable-next-line:component-selector
                    selector: 'button[lf-button], input[lf-button], a[lf-button]',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-container *mobxAutorun><ng-content></ng-content></ng-container>',
                }]
        }], ctorParameters: function () { return [{ type: i0.ElementRef }]; }, propDecorators: { style: [{
                type: Input
            }], size: [{
                type: Input
            }], type: [{
                type: Input
            }], block: [{
                type: Input
            }, {
                type: HostBinding,
                args: ['class.btn-block']
            }], dropdownToggle: [{
                type: Input
            }], dropdownToggleSplit: [{
                type: Input
            }, {
                type: HostBinding,
                args: ['class.dropdown-toggle-split']
            }], isDisabled: [{
                type: Input
            }], isActive: [{
                type: Input
            }, {
                type: HostBinding,
                args: ['class.active']
            }], _hostClassBtn: [{
                type: HostBinding,
                args: ['class.btn']
            }], _role: [{
                type: HostBinding,
                args: ['attr.role']
            }], _hostClassBtnPrimary: [{
                type: HostBinding,
                args: ['class.btn-primary']
            }], _hostClassBtnSecondary: [{
                type: HostBinding,
                args: ['class.btn-secondary']
            }], _hostClassBtnSuccess: [{
                type: HostBinding,
                args: ['class.btn-success']
            }], _hostClassBtnDanger: [{
                type: HostBinding,
                args: ['class.btn-danger']
            }], _hostClassBtnWarning: [{
                type: HostBinding,
                args: ['class.btn-warning']
            }], _hostClassBtnInfo: [{
                type: HostBinding,
                args: ['class.btn-info']
            }], _hostClassBtnLight: [{
                type: HostBinding,
                args: ['class.btn-light']
            }], _hostClassBtnDark: [{
                type: HostBinding,
                args: ['class.btn-dark']
            }], _hostClassBtnLink: [{
                type: HostBinding,
                args: ['class.btn-link']
            }], _hostClassBtnOutlinePrimary: [{
                type: HostBinding,
                args: ['class.btn-outline-primary']
            }], _hostClassBtnOutlineSecondary: [{
                type: HostBinding,
                args: ['class.btn-outline-secondary']
            }], _hostClassBtnOutlineSuccess: [{
                type: HostBinding,
                args: ['class.btn-outline-success']
            }], _hostClassBtnOutlineDanger: [{
                type: HostBinding,
                args: ['class.btn-outline-danger']
            }], _hostClassBtnOutlineWarning: [{
                type: HostBinding,
                args: ['class.btn-outline-warning']
            }], _hostClassBtnOutlineInfo: [{
                type: HostBinding,
                args: ['class.btn-outline-info']
            }], _hostClassBtnOutlineLight: [{
                type: HostBinding,
                args: ['class.btn-outline-light']
            }], _hostClassBtnOutlineDark: [{
                type: HostBinding,
                args: ['class.btn-outline-dark']
            }], _hostClassBtnSm: [{
                type: HostBinding,
                args: ['class.btn-sm']
            }], _hostClassBtnLg: [{
                type: HostBinding,
                args: ['class.btn-lg']
            }], _hostClassDropdownToggle: [{
                type: HostBinding,
                args: ['class.dropdown-toggle']
            }], _hostType: [{
                type: HostBinding,
                args: ['attr.type']
            }], _hostDisabled: [{
                type: HostBinding,
                args: ['attr.disabled']
            }], _hostAriaDisabled: [{
                type: HostBinding,
                args: ['attr.aria-disabled']
            }], _hostAriaPressed: [{
                type: HostBinding,
                args: ['attr.aria-pressed']
            }] } });

/**
 * LF icon component.
 */
class IconComponent {
    constructor() {
        Object.defineProperty(this, "icon", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        Object.defineProperty(this, "size", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        Object.defineProperty(this, "fixedWidth", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: false
        });
        Object.defineProperty(this, "spin", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: false
        });
        Object.defineProperty(this, "pulse", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: false
        });
        Object.defineProperty(this, "ariaHidden", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: true
        });
        makeObservable(this);
    }
    get classes() {
        const classes = {
            fa: true,
            ['fa-' + this.icon]: true,
            'fa-fw': this.fixedWidth,
            'fa-spin': this.spin,
            'fa-pulse': this.pulse,
        };
        if (this.size) {
            classes['fa-' + this.size] = true;
        }
        return classes;
    }
}
Object.defineProperty(IconComponent, "\u0275fac", {
    enumerable: true,
    configurable: true,
    writable: true,
    value: i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0, type: IconComponent, deps: [], target: i0.ɵɵFactoryTarget.Component })
});
Object.defineProperty(IconComponent, "\u0275cmp", {
    enumerable: true,
    configurable: true,
    writable: true,
    value: i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.15", type: IconComponent, selector: "lf-icon", inputs: { icon: "icon", size: "size", fixedWidth: "fixedWidth", spin: "spin", pulse: "pulse", ariaHidden: "ariaHidden" }, ngImport: i0, template: "<ng-container *mobxAutorun>\n  <i\n    *ngIf=\"icon\"\n    [ngClass]=\"classes\"\n    [attr.aria-hidden]=\"ariaHidden ? 'true' : 'false'\"\n  >\n  </i>\n</ng-container>\n", directives: [{ type: i6.MobxAutorunDirective, selector: "[mobxAutorun]", inputs: ["mobxAutorun"] }, { type: i7.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { type: i7.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush })
});
__decorate([
    observable
], IconComponent.prototype, "icon", void 0);
__decorate([
    observable
], IconComponent.prototype, "size", void 0);
__decorate([
    observable
], IconComponent.prototype, "fixedWidth", void 0);
__decorate([
    observable
], IconComponent.prototype, "spin", void 0);
__decorate([
    observable
], IconComponent.prototype, "pulse", void 0);
__decorate([
    observable
], IconComponent.prototype, "ariaHidden", void 0);
__decorate([
    computed
], IconComponent.prototype, "classes", null);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0, type: IconComponent, decorators: [{
            type: Component,
            args: [{
                    selector: 'lf-icon',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    templateUrl: './icon.component.html',
                }]
        }], ctorParameters: function () { return []; }, propDecorators: { icon: [{
                type: Input
            }], size: [{
                type: Input
            }], fixedWidth: [{
                type: Input
            }], spin: [{
                type: Input
            }], pulse: [{
                type: Input
            }], ariaHidden: [{
                type: Input
            }], classes: [] } });

/**
 * Abstract class for components that are toggleable and path based.
 */
// tslint:disable-next-line: directive-class-suffix
class Toggleable extends PathBased {
    constructor(parentPathBasedComponent, lfStorage, lfI18n) {
        super(parentPathBasedComponent, lfStorage, lfI18n);
        /**
         * Whether the toggleable element should start visible.
         */
        Object.defineProperty(this, "startVisible", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: false
        });
        /**
         * Event emitter which emits an event whenever the toggleable is set to be
         * shown.
         */
        // tslint:disable-next-line:no-output-rename
        Object.defineProperty(this, "_show", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: new EventEmitter()
        });
        /**
         * Event emitter which emits an event whenever the toggleable is set to be
         * hidden.
         */
        // tslint:disable-next-line:no-output-rename
        Object.defineProperty(this, "_hide", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: new EventEmitter()
        });
        Object.defineProperty(this, "_isVisible", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        makeObservable(this);
    }
    /**
     * Whether the toggleable is visible.
     */
    get isVisible() {
        return this._isVisible;
    }
    set isVisible(setVisible) {
        if (!this._isVisible && setVisible) {
            this._isVisible = true;
            this._show.emit();
        }
        else if (this._isVisible && !setVisible) {
            this._isVisible = false;
            this._hide.emit();
        }
    }
    ngOnInit() {
        this._isVisible = this.startVisible;
    }
    /**
     * Show the toggleable element.
     */
    show() {
        this.isVisible = true;
    }
    /**
     * Hide the toggleable element.
     */
    hide() {
        this.isVisible = false;
    }
    /**
     * Toggle the visibility of the toggleable element.
     */
    toggle() {
        this.isVisible = !this.isVisible;
    }
}
Object.defineProperty(Toggleable, "\u0275fac", {
    enumerable: true,
    configurable: true,
    writable: true,
    value: i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0, type: Toggleable, deps: [{ token: i1.PathBased }, { token: i1.LfStorage }, { token: i1.LfI18n }], target: i0.ɵɵFactoryTarget.Directive })
});
Object.defineProperty(Toggleable, "\u0275dir", {
    enumerable: true,
    configurable: true,
    writable: true,
    value: i0.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "12.2.15", type: Toggleable, inputs: { startVisible: "startVisible" }, outputs: { _show: "show", _hide: "hide" }, usesInheritance: true, ngImport: i0 })
});
__decorate([
    observable
], Toggleable.prototype, "_isVisible", void 0);
__decorate([
    computed
], Toggleable.prototype, "isVisible", null);
__decorate([
    action
], Toggleable.prototype, "show", null);
__decorate([
    action
], Toggleable.prototype, "hide", null);
__decorate([
    action
], Toggleable.prototype, "toggle", null);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0, type: Toggleable, decorators: [{
            type: Directive
        }], ctorParameters: function () { return [{ type: i1.PathBased }, { type: i1.LfStorage }, { type: i1.LfI18n }]; }, propDecorators: { startVisible: [{
                type: Input
            }], _show: [{
                type: Output,
                args: ['show']
            }], _hide: [{
                type: Output,
                args: ['hide']
            }], _isVisible: [], isVisible: [], show: [], hide: [], toggle: [] } });

/**
 * LF dropdown component.
 */
class DropdownComponent extends Toggleable {
    constructor(parentPathBasedComponent, lfStorage, lfI18n, host) {
        super(parentPathBasedComponent, lfStorage, lfI18n);
        Object.defineProperty(this, "host", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: host
        });
        Object.defineProperty(this, "position", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: 'down'
        });
        Object.defineProperty(this, "offset", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: 0
        });
        Object.defineProperty(this, "flip", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: true
        });
        Object.defineProperty(this, "boundary", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: 'scrollParent'
        });
        Object.defineProperty(this, "reference", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: 'toggle'
        });
        Object.defineProperty(this, "display", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: 'dynamic'
        });
        Object.defineProperty(this, "shown", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: new EventEmitter()
        });
        Object.defineProperty(this, "hidden", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: new EventEmitter()
        });
        Object.defineProperty(this, "_hostClassBtnGroup", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: true
        });
        // The toggle of the dropdown is, by default, the first child of the
        // dropdown's content. Alternatively a `dropdownToggle` reference may be set
        // on the desired element
        Object.defineProperty(this, "_toggle", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        Object.defineProperty(this, "$host", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        Object.defineProperty(this, "$toggle", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        // Whether the dropdown is animating
        Object.defineProperty(this, "isAnimating", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        // Subscriptions
        Object.defineProperty(this, "disposeOnOptionsChange", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        Object.defineProperty(this, "showSubscription", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        Object.defineProperty(this, "hideSubscription", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        makeObservable(this);
    }
    get _hostClassDropleft() {
        return this.position === 'left';
    }
    get _hostClassDropright() {
        return this.position === 'right';
    }
    get _hostClassDropup() {
        return this.position === 'up';
    }
    ngAfterViewInit() {
        this.createDropdown();
    }
    ngOnDestroy() {
        this.destroyDropdown();
        super.ngOnDestroy();
    }
    /**
     * Creates a new dropdown and starts listening to events.
     */
    createDropdown() {
        const target = this._toggle
            ? this._toggle.nativeElement
            : this.host.nativeElement.children[0];
        this.$toggle = $(target)
            .attr('data-toggle', 'dropdown')
            .attr('aria-haspopup', 'true')
            .attr('aria-expanded', 'false')
            .dropdown({
            offset: this.offset,
            flip: this.flip,
            boundary: this.boundary instanceof ElementRef
                ? this.boundary.nativeElement
                : this.boundary,
            reference: this.reference instanceof ElementRef
                ? this.reference.nativeElement
                : this.reference,
            display: this.display,
        });
        this.$host = $(this.host.nativeElement);
        // Make UI match state at startup
        if (this.isVisible) {
            this.$toggle.dropdown('toggle');
        }
        // There seems to be no way of updating these settings, so the most we can
        // do is destroy and reconstruct the modal whenever they change. TODO:
        // Figure out a better approach for this
        this.disposeOnOptionsChange = reaction(() => [
            this.offset,
            this.flip,
            this.boundary,
            this.reference,
            this.display,
        ], () => {
            this.destroyDropdown();
            this.createDropdown();
        }, { name: 'dropdownReactionOnOptionsChange' });
        // Set the component's state if the dropdown is shown without calling
        // `show()`
        this.$host.on('show.bs.dropdown', () => {
            this.isAnimating = true;
            if (!this.isVisible) {
                this.show();
            }
        });
        // Set the component's state if the dropdown is hidden without calling
        // `hide()`
        this.$host.on('hide.bs.dropdown', () => {
            this.isAnimating = true;
            if (this.isVisible) {
                this.hide();
            }
        });
        // Runs when the showing animation ends
        this.$host.on('shown.bs.dropdown', () => {
            this.isAnimating = false;
            this.shown.emit();
            // `isVisible` may change faster than the animations occur, force the UI
            // state to match `isVisible`
            if (!this.isVisible) {
                this.hide();
            }
        });
        // Runs when the hiding animation ends
        this.$host.on('hidden.bs.dropdown', () => {
            this.isAnimating = false;
            this.hidden.emit();
            // `isVisible` may change faster than the animations occur, force the UI
            // state to match `isVisible`
            if (this.isVisible) {
                this.show();
            }
        });
        // Open the dropdown when `show` is called
        this.showSubscription = this._show.subscribe(() => {
            if (!this.isAnimating && !this.$host.hasClass('show')) {
                this.$toggle.dropdown('toggle');
            }
        });
        // Close the dropdown when `hide` is called
        this.hideSubscription = this._hide.subscribe(() => {
            if (!this.isAnimating && this.$host.hasClass('show')) {
                this.$toggle.dropdown('toggle');
            }
        });
    }
    /**
     * Unsubscribes from all events and destroys the dropdown.
     */
    destroyDropdown() {
        this.disposeOnOptionsChange && this.disposeOnOptionsChange();
        if (this.$host) {
            this.$host.off('show.bs.dropdown');
            this.$host.off('hide.bs.dropdown');
            this.$host.off('shown.bs.dropdown');
            this.$host.off('hidden.bs.dropdown');
        }
        this.showSubscription && this.showSubscription.unsubscribe();
        this.hideSubscription && this.hideSubscription.unsubscribe();
        this.$toggle &&
            this.$toggle
                .removeAttr('data-toggle')
                .removeAttr('aria-haspopup')
                .removeAttr('aria-expanded')
                .dropdown('dispose');
    }
}
Object.defineProperty(DropdownComponent, "\u0275fac", {
    enumerable: true,
    configurable: true,
    writable: true,
    value: i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0, type: DropdownComponent, deps: [{ token: PathBased, optional: true, skipSelf: true }, { token: i1.LfStorage }, { token: i1.LfI18n }, { token: i0.ElementRef }], target: i0.ɵɵFactoryTarget.Component })
});
Object.defineProperty(DropdownComponent, "\u0275cmp", {
    enumerable: true,
    configurable: true,
    writable: true,
    value: i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.15", type: DropdownComponent, selector: "lf-dropdown, [lf-dropdown]", inputs: { position: "position", offset: "offset", flip: "flip", boundary: "boundary", reference: "reference", display: "display" }, outputs: { shown: "shown", hidden: "hidden" }, host: { properties: { "class.btn-group": "this._hostClassBtnGroup", "class.dropleft": "this._hostClassDropleft", "class.dropright": "this._hostClassDropright", "class.dropup": "this._hostClassDropup" } }, providers: [{ provide: PathBased, useExisting: DropdownComponent }], queries: [{ propertyName: "_toggle", first: true, predicate: ["dropdownToggle"], descendants: true, read: ElementRef }], usesInheritance: true, ngImport: i0, template: '<ng-container *mobxAutorun><ng-content></ng-content></ng-container>', isInline: true, directives: [{ type: i6.MobxAutorunDirective, selector: "[mobxAutorun]", inputs: ["mobxAutorun"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush })
});
__decorate([
    observable
], DropdownComponent.prototype, "position", void 0);
__decorate([
    observable
], DropdownComponent.prototype, "offset", void 0);
__decorate([
    observable
], DropdownComponent.prototype, "flip", void 0);
__decorate([
    observable
], DropdownComponent.prototype, "boundary", void 0);
__decorate([
    observable
], DropdownComponent.prototype, "reference", void 0);
__decorate([
    observable
], DropdownComponent.prototype, "display", void 0);
__decorate([
    computed
], DropdownComponent.prototype, "_hostClassDropleft", null);
__decorate([
    computed
], DropdownComponent.prototype, "_hostClassDropright", null);
__decorate([
    computed
], DropdownComponent.prototype, "_hostClassDropup", null);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0, type: DropdownComponent, decorators: [{
            type: Component,
            args: [{
                    selector: 'lf-dropdown, [lf-dropdown]',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [{ provide: PathBased, useExisting: DropdownComponent }],
                    template: '<ng-container *mobxAutorun><ng-content></ng-content></ng-container>',
                }]
        }], ctorParameters: function () { return [{ type: i1.PathBased, decorators: [{
                    type: Optional
                }, {
                    type: SkipSelf
                }, {
                    type: Inject,
                    args: [PathBased]
                }] }, { type: i1.LfStorage }, { type: i1.LfI18n }, { type: i0.ElementRef }]; }, propDecorators: { position: [{
                type: Input
            }], offset: [{
                type: Input
            }], flip: [{
                type: Input
            }], boundary: [{
                type: Input
            }], reference: [{
                type: Input
            }], display: [{
                type: Input
            }], shown: [{
                type: Output
            }], hidden: [{
                type: Output
            }], _hostClassBtnGroup: [{
                type: HostBinding,
                args: ['class.btn-group']
            }], _toggle: [{
                type: ContentChild,
                args: ['dropdownToggle', { read: ElementRef }]
            }], _hostClassDropleft: [{
                type: HostBinding,
                args: ['class.dropleft']
            }], _hostClassDropright: [{
                type: HostBinding,
                args: ['class.dropright']
            }], _hostClassDropup: [{
                type: HostBinding,
                args: ['class.dropup']
            }] } });

class DropdownMenuComponent {
    constructor() {
        Object.defineProperty(this, "alignRight", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: false
        });
        Object.defineProperty(this, "_hostClassDropdownMenu", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: true
        });
        makeObservable(this);
    }
}
Object.defineProperty(DropdownMenuComponent, "\u0275fac", {
    enumerable: true,
    configurable: true,
    writable: true,
    value: i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0, type: DropdownMenuComponent, deps: [], target: i0.ɵɵFactoryTarget.Component })
});
Object.defineProperty(DropdownMenuComponent, "\u0275cmp", {
    enumerable: true,
    configurable: true,
    writable: true,
    value: i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.15", type: DropdownMenuComponent, selector: "lf-dropdown-menu, [lf-dropdown-menu]", inputs: { alignRight: "alignRight" }, host: { properties: { "class.dropdown-menu-right": "this.alignRight", "class.dropdown-menu": "this._hostClassDropdownMenu" } }, ngImport: i0, template: '<ng-container *mobxAutorun><ng-content></ng-content></ng-container>', isInline: true, directives: [{ type: i6.MobxAutorunDirective, selector: "[mobxAutorun]", inputs: ["mobxAutorun"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush })
});
__decorate([
    observable
], DropdownMenuComponent.prototype, "alignRight", void 0);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0, type: DropdownMenuComponent, decorators: [{
            type: Component,
            args: [{
                    selector: 'lf-dropdown-menu, [lf-dropdown-menu]',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-container *mobxAutorun><ng-content></ng-content></ng-container>',
                }]
        }], ctorParameters: function () { return []; }, propDecorators: { alignRight: [{
                type: Input
            }, {
                type: HostBinding,
                args: ['class.dropdown-menu-right']
            }], _hostClassDropdownMenu: [{
                type: HostBinding,
                args: ['class.dropdown-menu']
            }] } });

class DropdownItemComponent {
    constructor(_host) {
        Object.defineProperty(this, "itemType", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: 'item'
        });
        Object.defineProperty(this, "isActive", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: false
        });
        Object.defineProperty(this, "isDisabled", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: false
        });
        Object.defineProperty(this, "_tagName", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        this._tagName = _host.nativeElement.tagName.toLowerCase();
        makeObservable(this);
    }
    // Classes for each type of dropdown item
    get _hostClassDropdownItem() {
        return this.itemType === 'item';
    }
    get _hostClassDropdownDivider() {
        return this.itemType === 'divider';
    }
    get _hostClassDropdownItemText() {
        return this.itemType === 'text';
    }
    get _hostClassDropdownHeader() {
        return this.itemType === 'header';
    }
    // Set disable (attribute for buttons, class for others)
    get _hostClassDisabled() {
        return (this.itemType === 'item' && this._tagName !== 'button' && this.isDisabled);
    }
    get _hostDisabled() {
        return this.itemType === 'item' &&
            this._tagName === 'button' &&
            this.isDisabled
            ? ''
            : undefined;
    }
}
Object.defineProperty(DropdownItemComponent, "\u0275fac", {
    enumerable: true,
    configurable: true,
    writable: true,
    value: i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0, type: DropdownItemComponent, deps: [{ token: i0.ElementRef }], target: i0.ɵɵFactoryTarget.Component })
});
Object.defineProperty(DropdownItemComponent, "\u0275cmp", {
    enumerable: true,
    configurable: true,
    writable: true,
    value: i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.15", type: DropdownItemComponent, selector: "lf-dropdown-item, [lf-dropdown-item]", inputs: { itemType: "itemType", isActive: "isActive", isDisabled: "isDisabled" }, host: { properties: { "class.active": "this.isActive", "class.dropdown-item": "this._hostClassDropdownItem", "class.dropdown-divider": "this._hostClassDropdownDivider", "class.dropdown-item-text": "this._hostClassDropdownItemText", "class.dropdown-header": "this._hostClassDropdownHeader", "class.disabled": "this._hostClassDisabled", "attr.disabled": "this._hostDisabled" } }, ngImport: i0, template: '<ng-container *mobxAutorun><ng-content></ng-content></ng-container>', isInline: true, directives: [{ type: i6.MobxAutorunDirective, selector: "[mobxAutorun]", inputs: ["mobxAutorun"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush })
});
__decorate([
    observable
], DropdownItemComponent.prototype, "itemType", void 0);
__decorate([
    observable
], DropdownItemComponent.prototype, "isActive", void 0);
__decorate([
    observable
], DropdownItemComponent.prototype, "isDisabled", void 0);
__decorate([
    computed
], DropdownItemComponent.prototype, "_hostClassDropdownItem", null);
__decorate([
    computed
], DropdownItemComponent.prototype, "_hostClassDropdownDivider", null);
__decorate([
    computed
], DropdownItemComponent.prototype, "_hostClassDropdownItemText", null);
__decorate([
    computed
], DropdownItemComponent.prototype, "_hostClassDropdownHeader", null);
__decorate([
    computed
], DropdownItemComponent.prototype, "_hostClassDisabled", null);
__decorate([
    computed
], DropdownItemComponent.prototype, "_hostDisabled", null);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0, type: DropdownItemComponent, decorators: [{
            type: Component,
            args: [{
                    selector: 'lf-dropdown-item, [lf-dropdown-item]',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: '<ng-container *mobxAutorun><ng-content></ng-content></ng-container>',
                }]
        }], ctorParameters: function () { return [{ type: i0.ElementRef }]; }, propDecorators: { itemType: [{
                type: Input
            }], isActive: [{
                type: Input
            }, {
                type: HostBinding,
                args: ['class.active']
            }], isDisabled: [{
                type: Input
            }], _hostClassDropdownItem: [{
                type: HostBinding,
                args: ['class.dropdown-item']
            }], _hostClassDropdownDivider: [{
                type: HostBinding,
                args: ['class.dropdown-divider']
            }], _hostClassDropdownItemText: [{
                type: HostBinding,
                args: ['class.dropdown-item-text']
            }], _hostClassDropdownHeader: [{
                type: HostBinding,
                args: ['class.dropdown-header']
            }], _hostClassDisabled: [{
                type: HostBinding,
                args: ['class.disabled']
            }], _hostDisabled: [{
                type: HostBinding,
                args: ['attr.disabled']
            }] } });

/**
 * Component that responsively displays a menu of actions.
 */
class ActionsMenuComponent {
    constructor(lfI18n) {
        Object.defineProperty(this, "lfI18n", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: lfI18n
        });
        /**
         * Actions of the actions-menu.
         */
        Object.defineProperty(this, "actions", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        /**
         * Size of the buttons of the actions-menu.
         */
        Object.defineProperty(this, "buttonsSize", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        /**
         * Screen size at which the actions-menu should collapse.
         */
        Object.defineProperty(this, "collapseSize", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: 'md'
        });
        /**
         * Screen size at which the actions-menu button should collapse.
         */
        Object.defineProperty(this, "actionsLabelCollapseSize", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: 'sm'
        });
        /**
         * Whether the actions-menu (when collapsed) should align its menu to the
         * right.
         */
        Object.defineProperty(this, "alignMenusRight", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: false
        });
        /**
         * Actions currently executing.
         */
        Object.defineProperty(this, "runningActions", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: new Set()
        });
        makeObservable(this);
    }
    get actionsLabel() {
        return this.lfI18n.get(I18N_ACTIONS_MENU_BUTTON_TEXT_KEY);
    }
    actionText(act) {
        return act.text != null
            ? act.text
            : act.id != null
                ? this.lfI18n.get(`${I18N_ACTIONS_MENU_KEY}.${act.id}`)
                : '';
    }
    actionOptionText(act, option) {
        return option.text != null
            ? option.text
            : act.id != null && option.id != null
                ? this.lfI18n.get(`${I18N_ACTIONS_MENU_OPTIONS_KEY}.${act.id}.${option.id}`)
                : '';
    }
    _runAction(act, value) {
        return __awaiter(this, void 0, void 0, function* () {
            const res = act.callback && act.callback(value);
            if (res && typeof res.then === 'function') {
                const actionId = this.actionId(act);
                try {
                    this.runningActions.add(actionId);
                    yield res;
                }
                finally {
                    runInAction(() => this.runningActions.delete(actionId));
                }
            }
        });
    }
    _runActionOption(act, option) {
        return __awaiter(this, void 0, void 0, function* () {
            const optionId = this.actionId(act, option);
            const optionRes = option.callback && option.callback();
            this.runningActions.add(optionId);
            try {
                if (optionRes && typeof optionRes === 'function') {
                    yield optionRes;
                }
                yield this._runAction(act, option.value);
            }
            finally {
                runInAction(() => this.runningActions.delete(optionId));
            }
        });
    }
    get _isAnyActionRunning() {
        return this.runningActions.size > 0;
    }
    _isActionRunning(act) {
        return this.runningActions.has(this.actionId(act));
    }
    _isChildOptionRunning(act) {
        for (const id of this.runningActions) {
            if (id.startsWith(`${this.actionId(act)}.`)) {
                return true;
            }
        }
        return false;
    }
    _isActionOptionRunning(act, option) {
        return this.runningActions.has(this.actionId(act, option));
    }
    actionId(act, option) {
        const actionId = act.id || this.actionText(act);
        const optionId = option && (option.id || this.actionOptionText(act, option));
        return optionId ? `${actionId}.${optionId}` : `${actionId}`;
    }
}
Object.defineProperty(ActionsMenuComponent, "\u0275fac", {
    enumerable: true,
    configurable: true,
    writable: true,
    value: i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0, type: ActionsMenuComponent, deps: [{ token: LfI18n }], target: i0.ɵɵFactoryTarget.Component })
});
Object.defineProperty(ActionsMenuComponent, "\u0275cmp", {
    enumerable: true,
    configurable: true,
    writable: true,
    value: i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.15", type: ActionsMenuComponent, selector: "lf-actions-menu", inputs: { actions: "actions", buttonsSize: "buttonsSize", collapseSize: "collapseSize", actionsLabelCollapseSize: "actionsLabelCollapseSize", alignMenusRight: "alignMenusRight" }, ngImport: i0, template: "<ng-container *mobxAutorun>\n  <!-- Large screen: inline buttons -->\n  <div\n    *ngIf=\"actions && actions.length > 0 && collapseSize !== 'every'\"\n    class=\"btn-group {{\n      collapseSize === 'none' ? '' : 'd-none d-' + collapseSize + '-block'\n    }}\"\n  >\n    <ng-template ngFor let-action [ngForOf]=\"actions\">\n      <!-- Anchor action -->\n      <a\n        lf-button\n        *ngIf=\"action.href\"\n        [class]=\"action.class || ''\"\n        [style]=\"action.style\"\n        [size]=\"buttonsSize\"\n        [href]=\"action.href\"\n      >\n        <lf-icon *ngIf=\"action.icon\" [icon]=\"action.icon\"></lf-icon>\n        {{ actionText(action) }}\n      </a>\n      <!-- Regular action (button) -->\n      <button\n        lf-button\n        *ngIf=\"!action.options && !action.href\"\n        [class]=\"action.class || ''\"\n        [style]=\"action.style\"\n        [size]=\"buttonsSize\"\n        [isActive]=\"!!action.isActive && action.isActive()\"\n        [isDisabled]=\"\n          _isActionRunning(action) ||\n          (!!action.isDisabled && action.isDisabled())\n        \"\n        (click)=\"_runAction(action)\"\n      >\n        <div *ngIf=\"_isActionRunning(action)\" class=\"action-loading\"></div>\n        <lf-icon\n          *ngIf=\"!_isActionRunning(action) && action.icon\"\n          [icon]=\"action.icon\"\n        >\n        </lf-icon>\n        {{ actionText(action) }}\n      </button>\n      <!-- Action with options (dropdown) -->\n      <lf-dropdown *ngIf=\"action.options\">\n        <button\n          lf-button\n          [class]=\"action.class || ''\"\n          [style]=\"action.style\"\n          [size]=\"buttonsSize\"\n          [isDisabled]=\"!!action.isDisabled && action.isDisabled()\"\n          [dropdownToggle]=\"true\"\n        >\n          <div\n            *ngIf=\"_isActionRunning(action) || _isChildOptionRunning(action)\"\n            class=\"action-loading\"\n          ></div>\n          <lf-icon\n            *ngIf=\"\n              !_isActionRunning(action) &&\n              !_isChildOptionRunning(action) &&\n              action.icon\n            \"\n            [icon]=\"action.icon\"\n          ></lf-icon>\n          {{ actionText(action) }}\n        </button>\n        <lf-dropdown-menu\n          [alignRight]=\"\n            action.alignRight == null ? alignMenusRight : action.alignRight\n          \"\n        >\n          <ng-container *ngFor=\"let option of action.options\">\n            <!-- Anchor option -->\n            <a\n              lf-dropdown-item\n              *ngIf=\"option.href\"\n              [class]=\"option.class || ''\"\n              [href]=\"option.href\"\n            >\n              <lf-icon\n                *ngIf=\"option.icon\"\n                [icon]=\"option.icon\"\n                [fixedWidth]=\"true\"\n              >\n              </lf-icon>\n              {{ actionOptionText(action, option) }}\n            </a>\n            <!-- Regular option (button) -->\n            <button\n              lf-dropdown-item\n              *ngIf=\"!option.href\"\n              type=\"button\"\n              [class]=\"option.class || ''\"\n              [isActive]=\"!!option.isActive && option.isActive()\"\n              [isDisabled]=\"\n                _isActionOptionRunning(action, option) ||\n                (!!option.isDisabled && option.isDisabled())\n              \"\n              (click)=\"_runActionOption(action, option)\"\n            >\n              <div\n                *ngIf=\"_isActionOptionRunning(action, option)\"\n                class=\"d-inline-block fa-fw\"\n              >\n                <div class=\"action-loading\"></div>\n              </div>\n              <lf-icon\n                *ngIf=\"!_isActionOptionRunning(action, option) && option.icon\"\n                [icon]=\"option.icon\"\n                [fixedWidth]=\"true\"\n              >\n              </lf-icon>\n              {{ actionOptionText(action, option) }}\n            </button>\n          </ng-container>\n        </lf-dropdown-menu>\n      </lf-dropdown>\n    </ng-template>\n  </div>\n\n  <!-- Small screen: menu buttons -->\n  <div\n    *ngIf=\"actions && actions.length > 0 && collapseSize !== 'none'\"\n    [class]=\"\n      collapseSize === 'every' ? '' : 'd-' + collapseSize + '-none d-block'\n    \"\n  >\n    <lf-dropdown>\n      <button\n        lf-button\n        [style]=\"'outline-secondary'\"\n        [size]=\"buttonsSize\"\n        [dropdownToggle]=\"true\"\n      >\n        <div *ngIf=\"_isAnyActionRunning\" class=\"action-loading\"></div>\n        <lf-icon *ngIf=\"!_isAnyActionRunning\" icon=\"gear\"></lf-icon>\n        <!-- Show a label for the actions toggle depending on screen size -->\n        <span\n          *ngIf=\"actionsLabelCollapseSize !== 'every'\"\n          [class]=\"\n            actionsLabelCollapseSize === 'none'\n              ? ''\n              : 'd-none d-' + actionsLabelCollapseSize + '-inline'\n          \"\n        >\n          {{ actionsLabel }}\n        </span>\n      </button>\n      <lf-dropdown-menu [alignRight]=\"alignMenusRight\">\n        <ng-container *ngFor=\"let action of actions; let i = index\">\n          <!-- Anchor action -->\n          <a\n            lf-dropdown-item\n            *ngIf=\"action.href\"\n            [class]=\"action.class || ''\"\n            [href]=\"action.href\"\n          >\n            <lf-icon\n              *ngIf=\"action.icon\"\n              [icon]=\"action.icon\"\n              [fixedWidth]=\"true\"\n            >\n            </lf-icon>\n            {{ actionText(action) }}\n          </a>\n          <!-- Regular action (button) -->\n          <button\n            lf-dropdown-item\n            type=\"button\"\n            *ngIf=\"!action.options && !action.href\"\n            [class]=\"action.class || ''\"\n            [isActive]=\"!!action.isActive && action.isActive()\"\n            [isDisabled]=\"\n              _isActionRunning(action) ||\n              (!!action.isDisabled && action.isDisabled())\n            \"\n            (click)=\"_runAction(action)\"\n          >\n            <div *ngIf=\"_isActionRunning(action)\" class=\"d-inline-block fa-fw\">\n              <div class=\"action-loading\"></div>\n            </div>\n            <lf-icon\n              *ngIf=\"!_isActionRunning(action) && action.icon\"\n              [icon]=\"action.icon\"\n              [fixedWidth]=\"true\"\n            >\n            </lf-icon>\n            {{ actionText(action) }}\n          </button>\n          <!-- Action with options -->\n          <ng-container *ngIf=\"action.options\">\n            <!-- Surround actions with options with dividers -->\n            <div lf-dropdown-item *ngIf=\"i > 0\" [itemType]=\"'divider'\"></div>\n            <h6\n              lf-dropdown-item\n              [class]=\"action.class || ''\"\n              [itemType]=\"'header'\"\n            >\n              <lf-icon\n                *ngIf=\"action.icon\"\n                [icon]=\"action.icon\"\n                [fixedWidth]=\"true\"\n              >\n              </lf-icon>\n              {{ actionText(action) }}\n            </h6>\n            <ng-container *ngFor=\"let option of action.options\">\n              <!-- Anchor option -->\n              <a\n                lf-dropdown-item\n                *ngIf=\"option.href\"\n                [class]=\"option.class || ''\"\n                [href]=\"option.href\"\n              >\n                {{ actionOptionText(action, option) }}\n              </a>\n              <!-- Regular option (button) -->\n              <button\n                lf-dropdown-item\n                type=\"button\"\n                *ngIf=\"!option.href\"\n                [class]=\"option.class || ''\"\n                [isActive]=\"!!option.isActive && option.isActive()\"\n                [isDisabled]=\"\n                  _isActionOptionRunning(action, option) ||\n                  (!!option.isDisabled && option.isDisabled())\n                \"\n                (click)=\"_runActionOption(action, option)\"\n              >\n                <div\n                  *ngIf=\"_isActionOptionRunning(action, option)\"\n                  class=\"d-inline-block fa-fw\"\n                >\n                  <div class=\"action-loading\"></div>\n                </div>\n                {{ actionOptionText(action, option) }}\n              </button>\n            </ng-container>\n            <div\n              lf-dropdown-item\n              *ngIf=\"i < actions.length - 1 && !actions[i + 1].options\"\n              [itemType]=\"'divider'\"\n            ></div>\n          </ng-container>\n        </ng-container>\n      </lf-dropdown-menu>\n    </lf-dropdown>\n  </div>\n</ng-container>\n", components: [{ type: ButtonComponent, selector: "button[lf-button], input[lf-button], a[lf-button]", inputs: ["style", "size", "type", "block", "dropdownToggle", "dropdownToggleSplit", "isDisabled", "isActive"] }, { type: IconComponent, selector: "lf-icon", inputs: ["icon", "size", "fixedWidth", "spin", "pulse", "ariaHidden"] }, { type: DropdownComponent, selector: "lf-dropdown, [lf-dropdown]", inputs: ["position", "offset", "flip", "boundary", "reference", "display"], outputs: ["shown", "hidden"] }, { type: DropdownMenuComponent, selector: "lf-dropdown-menu, [lf-dropdown-menu]", inputs: ["alignRight"] }, { type: DropdownItemComponent, selector: "lf-dropdown-item, [lf-dropdown-item]", inputs: ["itemType", "isActive", "isDisabled"] }], directives: [{ type: i6.MobxAutorunDirective, selector: "[mobxAutorun]", inputs: ["mobxAutorun"] }, { type: i7.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { type: i7.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush })
});
__decorate([
    observable.struct
], ActionsMenuComponent.prototype, "actions", void 0);
__decorate([
    observable
], ActionsMenuComponent.prototype, "buttonsSize", void 0);
__decorate([
    observable
], ActionsMenuComponent.prototype, "collapseSize", void 0);
__decorate([
    observable
], ActionsMenuComponent.prototype, "actionsLabelCollapseSize", void 0);
__decorate([
    observable
], ActionsMenuComponent.prototype, "alignMenusRight", void 0);
__decorate([
    observable
], ActionsMenuComponent.prototype, "runningActions", void 0);
__decorate([
    computed
], ActionsMenuComponent.prototype, "actionsLabel", null);
__decorate([
    action
], ActionsMenuComponent.prototype, "_runAction", null);
__decorate([
    action
], ActionsMenuComponent.prototype, "_runActionOption", null);
__decorate([
    computed
], ActionsMenuComponent.prototype, "_isAnyActionRunning", null);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0, type: ActionsMenuComponent, decorators: [{
            type: Component,
            args: [{
                    selector: 'lf-actions-menu',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    templateUrl: './actions-menu.component.html',
                }]
        }], ctorParameters: function () { return [{ type: i1.LfI18n, decorators: [{
                    type: Inject,
                    args: [LfI18n]
                }] }]; }, propDecorators: { actions: [{
                type: Input
            }], buttonsSize: [{
                type: Input
            }], collapseSize: [{
                type: Input
            }], actionsLabelCollapseSize: [{
                type: Input
            }], alignMenusRight: [{
                type: Input
            }], runningActions: [], actionsLabel: [], _runAction: [], _runActionOption: [], _isAnyActionRunning: [] } });

/**
 * LF alert component.
 */
class AlertComponent extends Toggleable {
    constructor(parentPathBasedComponent, lfStorage, lfI18n) {
        super(parentPathBasedComponent, lfStorage, lfI18n);
        Object.defineProperty(this, "style", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        Object.defineProperty(this, "showCloseButton", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        makeObservable(this);
    }
    get closeButtonTooltip() {
        return this.translate(I18N_CLOSE_BUTTON_TOOLTIP_KEY);
    }
}
Object.defineProperty(AlertComponent, "\u0275fac", {
    enumerable: true,
    configurable: true,
    writable: true,
    value: i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0, type: AlertComponent, deps: [{ token: PathBased, optional: true, skipSelf: true }, { token: i1.LfStorage }, { token: i1.LfI18n }], target: i0.ɵɵFactoryTarget.Component })
});
Object.defineProperty(AlertComponent, "\u0275cmp", {
    enumerable: true,
    configurable: true,
    writable: true,
    value: i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.15", type: AlertComponent, selector: "lf-alert", inputs: { style: "style", showCloseButton: "showCloseButton" }, providers: [{ provide: PathBased, useExisting: AlertComponent }], usesInheritance: true, ngImport: i0, template: "<ng-container *mobxAutorun>\n  <div\n    class=\"alert {{ style ? 'alert-' + style : '' }}\"\n    role=\"alert\"\n    *ngIf=\"isVisible\"\n  >\n    <button\n      type=\"button\"\n      class=\"close\"\n      [title]=\"closeButtonTooltip\"\n      [attr.aria-label]=\"closeButtonTooltip\"\n      *ngIf=\"showCloseButton\"\n      (click)=\"hide()\"\n    >\n      <span aria-hidden=\"true\">&times;</span>\n    </button>\n    <ng-content></ng-content>\n  </div>\n</ng-container>\n", directives: [{ type: i6.MobxAutorunDirective, selector: "[mobxAutorun]", inputs: ["mobxAutorun"] }, { type: i7.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush })
});
__decorate([
    observable
], AlertComponent.prototype, "style", void 0);
__decorate([
    observable
], AlertComponent.prototype, "showCloseButton", void 0);
__decorate([
    computed
], AlertComponent.prototype, "closeButtonTooltip", null);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0, type: AlertComponent, decorators: [{
            type: Component,
            args: [{
                    selector: 'lf-alert',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [{ provide: PathBased, useExisting: AlertComponent }],
                    templateUrl: './alert.component.html',
                }]
        }], ctorParameters: function () { return [{ type: i1.PathBased, decorators: [{
                    type: Optional
                }, {
                    type: SkipSelf
                }, {
                    type: Inject,
                    args: [PathBased]
                }] }, { type: i1.LfStorage }, { type: i1.LfI18n }]; }, propDecorators: { style: [{
                type: Input
            }], showCloseButton: [{
                type: Input
            }], closeButtonTooltip: [] } });

/**
 * Abstract class that all components which "encapsulate" a storage value should
 * inherit.
 */
// tslint:disable-next-line: directive-class-suffix
class Value extends PathBased {
    constructor(parentPathBasedComponent, lfStorage, lfI18n) {
        super(parentPathBasedComponent, lfStorage, lfI18n);
        /**
         * Whether the component should render in "read-only" mode (this has no effect
         * if this component is within an already "read-only" component).
         */
        // tslint:disable-next-line:no-input-rename
        Object.defineProperty(this, "_isReadOnly", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: false
        });
        /**
         * Add an `lf-value` class to all value components.
         */
        Object.defineProperty(this, "_classLfValue", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: true
        });
        makeObservable(this);
    }
    /**
     * Label associated with this value.
     */
    get label() {
        return this.translate(I18N_VALUE_LABEL_KEY);
    }
    /**
     * Code associated with this value.
     */
    get code() {
        return this.translate(I18N_VALUE_CODE_KEY);
    }
    /**
     * Help message associated with this value.
     */
    get helpMessage() {
        return this.translate(I18N_VALUE_HELP_MESSAGE_KEY);
    }
    /**
     * Legend associated with this value.
     */
    get legend() {
        return this.translate(I18N_VALUE_LEGEND_KEY);
    }
    /**
     * Message used to ask the user to retry validating the value.
     */
    get retryValidateText() {
        return this.translate(I18N_VALUE_RETRY_VALIDATE_TEXT_KEY);
    }
    /**
     * Whether the component should render in "read-only" mode. Inherits the
     * "read-only" state of parent components (meaning that it's not possible to
     * have an "editable" component within a "read-only" one). Furthermore, if the
     * component's value is computed, the component will always be in "read-only"
     * mode.
     */
    get isReadOnly() {
        return ((this.parentPathBasedComponent !== null &&
            this.parentPathBasedComponent.isReadOnly) ||
            this.relativeStorage.isComputed() ||
            this._isReadOnly);
    }
}
Object.defineProperty(Value, "\u0275fac", {
    enumerable: true,
    configurable: true,
    writable: true,
    value: i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0, type: Value, deps: [{ token: i1.PathBased }, { token: i1.LfStorage }, { token: i1.LfI18n }], target: i0.ɵɵFactoryTarget.Directive })
});
Object.defineProperty(Value, "\u0275dir", {
    enumerable: true,
    configurable: true,
    writable: true,
    value: i0.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "12.2.15", type: Value, inputs: { _isReadOnly: ["isReadOnly", "_isReadOnly"] }, host: { properties: { "class.lf-value": "this._classLfValue" } }, usesInheritance: true, ngImport: i0 })
});
__decorate([
    observable
], Value.prototype, "_isReadOnly", void 0);
__decorate([
    computed
], Value.prototype, "label", null);
__decorate([
    computed
], Value.prototype, "code", null);
__decorate([
    computed
], Value.prototype, "helpMessage", null);
__decorate([
    computed
], Value.prototype, "legend", null);
__decorate([
    computed
], Value.prototype, "retryValidateText", null);
__decorate([
    computed
], Value.prototype, "isReadOnly", null);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0, type: Value, decorators: [{
            type: Directive
        }], ctorParameters: function () { return [{ type: i1.PathBased }, { type: i1.LfStorage }, { type: i1.LfI18n }]; }, propDecorators: { _isReadOnly: [{
                type: Input,
                args: ['isReadOnly']
            }], _classLfValue: [{
                type: HostBinding,
                args: ['class.lf-value']
            }], label: [], code: [], helpMessage: [], legend: [], retryValidateText: [], isReadOnly: [] } });

/**
 * Default issue code emitted for invalid date-ranges (where the start date is
 * after the end date).
 */
const INVALID_DATE_RANGE_CODE = 'LF_INVALID_DATE_RANGE';
/**
 * Type of issue emitted for invalid date-ranges.
 */
const INVALID_DATE_RANGE_TYPE = 'invalidDateRange';
/**
 * Creates a new date-range schema object.
 * @param options Options used to create the schema.
 * @returns Date-range schema.
 */
function dateRangeSchema(options = {}) {
    const initialState = options.initialState || {};
    // Date-range validation function
    function validateDateRange(ctx) {
        var _a, _b, _c;
        const value = ctx.get();
        if (compareDates(value[0], value[1]) > 0) {
            return {
                code: (_a = options.invalidDateRangeCode) !== null && _a !== void 0 ? _a : INVALID_DATE_RANGE_CODE,
                data: { type: INVALID_DATE_RANGE_TYPE },
            };
        }
        const minDate = ctx.getStateProperty('.', 'minDate');
        const maxDate = ctx.getStateProperty('.', 'maxDate');
        const code = minDate != null && compareDates(value[0], minDate) < 0
            ? (_b = options.minDateCode) !== null && _b !== void 0 ? _b : DATE_OUT_OF_BOUNDS_CODE
            : maxDate != null && compareDates(value[1], maxDate) > 0
                ? (_c = options.maxDateCode) !== null && _c !== void 0 ? _c : DATE_OUT_OF_BOUNDS_CODE
                : null;
        if (code != null) {
            return {
                code,
                data: { type: DATE_OUT_OF_BOUNDS_TYPE, value, minDate, maxDate },
            };
        }
    }
    // Skip adding validations when requested (because e.g. the date-range is
    // computed)
    if (!options.skipValidations) {
        // Set `minDate` and `maxDate` as data properties in the date-range.
        if (options.minDate) {
            initialState.minDate =
                typeof options.minDate === 'function'
                    ? (ctx) => options.minDate(ctx.relativeStorage('..'))
                    : options.minDate;
        }
        if (options.maxDate) {
            initialState.maxDate =
                typeof options.maxDate === 'function'
                    ? (ctx) => options.maxDate(ctx.relativeStorage('..'))
                    : options.maxDate;
        }
        // Add date-range validation
        if (isArrayLike(options.validate)) {
            options.validate.unshift(validateDateRange);
        }
        else if (options.validate !== undefined) {
            options.validate = [validateDateRange, options.validate];
        }
        else {
            options.validate = validateDateRange;
        }
    }
    return tupleSchema([dateSchema(options.startDateOptions), dateSchema(options.endDateOptions)], Object.assign(Object.assign({}, options), { initialState }));
}
/**
 * Returns whether a given schema is a date-range schema.
 * @param schema Schema to check.
 * @returns `true` when the provided schema is a date-range schema.
 */
function isDateRangeSchema(schema) {
    return (isTupleSchema(schema) &&
        schema.elementsSchemas.length === 2 &&
        isDateSchema(schema.elementsSchemas[0]) &&
        isDateSchema(schema.elementsSchemas[1]));
}

/**
 * Protocol prefix used for LF links.
 */
const LF_URL_PROTOCOL = 'lf:';
// This is deprecated and `LF_URL_PROTOCOL` should be used instead.
const LF_URL_PROTOCOL_OLD = 'lf://';
/**
 * Validation message directive.
 */
class ValidationIssueDirective extends PathBased {
    constructor(parentPathBasedComponent, lfStorage, lfI18n, lfRouter, markdownService) {
        super(parentPathBasedComponent, lfStorage, lfI18n);
        Object.defineProperty(this, "lfRouter", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: lfRouter
        });
        Object.defineProperty(this, "markdownService", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: markdownService
        });
        /**
         * Issue with message to display.
         */
        Object.defineProperty(this, "issue", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        makeObservable(this);
    }
    /**
     * HTML string with the issue message to display.
     */
    get issueMessageHTML() {
        var _a, _b;
        // Value as obtained from the i18n file
        const i18nValue = (_a = this.lfI18n.getFromPath(this.path, `${I18N_VALIDATIONS_KEY}.${this.issue.code}`, { callFunctionWithContext: false })) !== null && _a !== void 0 ? _a : 
        // If there is no i18n value for the code but the issue has a well known
        // type, then we use the message associated with the default code of said
        // type
        (((_b = this.issue.data) === null || _b === void 0 ? void 0 : _b.type) &&
            this.lfI18n.getFromPath(this.path, `${I18N_VALIDATIONS_KEY}.${ValidationIssueDirective.defaultCodeForType(this.issue.data.type)}`, { callFunctionWithContext: false }));
        // Obtain markdown message from the value
        return this.markdownService.compile(typeof i18nValue === 'function'
            ? i18nValue(this.lfStorage.relativeStorage(this.path), this.issue.data, this.lfI18n)
            : i18nValue != null
                ? i18nValue
                : this.issue.code, undefined, undefined, { renderer: this.lfLinksRenderer });
    }
    /**
     * Renderer capable of handling `lf://` links.
     */
    get lfLinksRenderer() {
        const renderer = new MarkedRenderer();
        const originalLink = renderer.link;
        renderer.link = (href, title, text) => {
            // Non-LF link
            if (!href || !href.startsWith(LF_URL_PROTOCOL)) {
                return originalLink.call(renderer, href, title, text);
            }
            // Support old protocol (`lf://`)
            if (href.startsWith(LF_URL_PROTOCOL_OLD)) {
                href = LF_URL_PROTOCOL + href.slice(LF_URL_PROTOCOL_OLD.length);
            }
            // Replace links with the "LF protocol" with the appropriate paths
            const path = resolvePath(this.path, href.slice(LF_URL_PROTOCOL.length));
            const route = this.lfRouter.navigateableRoute(path);
            if (href === text) {
                text = this.labelOf(path);
            }
            href = route && this.lfRouter.createUrlFromNavigateableRoute(route);
            const anchor = originalLink.call(renderer, href, title, text);
            return anchor.replace(/^<a/, `<a class="lfPathLink" data-path="${path}"`);
        };
        return renderer;
    }
    /**
     * Default issue code associated with issues of a certain type.
     * @param type Type of the issue.
     * @returns Default issue code.
     */
    static defaultCodeForType(type) {
        switch (type) {
            case IS_REQUIRED_TYPE:
                return IS_REQUIRED_CODE;
            case DISALLOWED_VALUE_TYPE:
                return DISALLOWED_VALUE_CODE;
            case DATE_OUT_OF_BOUNDS_TYPE:
                return DATE_OUT_OF_BOUNDS_CODE;
            case SIZE_OUT_OF_BOUNDS_TYPE:
                return SIZE_OUT_OF_BOUNDS_CODE;
            case NUMBER_OUT_OF_BOUNDS_TYPE:
                return NUMBER_OUT_OF_BOUNDS_CODE;
            case LENGTH_OUT_OF_BOUNDS_TYPE:
                return LENGTH_OUT_OF_BOUNDS_CODE;
            case INVALID_DATE_RANGE_TYPE:
                return INVALID_DATE_RANGE_CODE;
            default:
                return null;
        }
    }
    // Intercept clicks on links with class `lfPathLink` to use the router.
    // Adapted from Angular's `routerLink` implementation.
    _onClick(target, button, ctrlKey, metaKey, shiftKey) {
        if (button !== 0 ||
            ctrlKey ||
            metaKey ||
            shiftKey ||
            !target.classList.contains('lfPathLink') ||
            !target.dataset.path) {
            return true;
        }
        this.lfRouter.navigate(target.dataset.path, {
            queryParamsHandling: 'merge',
        });
        return false;
    }
    /**
     * Label associated with the given path.
     * @param path Path from which to fetch label.
     * @returns Label of given path.
     */
    labelOf(path) {
        return this.lfI18n.getFromPath(path, I18N_VALUE_LABEL_KEY) || path;
    }
}
Object.defineProperty(ValidationIssueDirective, "\u0275fac", {
    enumerable: true,
    configurable: true,
    writable: true,
    value: i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0, type: ValidationIssueDirective, deps: [{ token: PathBased, optional: true }, { token: i1.LfStorage }, { token: i1.LfI18n }, { token: i1.LfRouter }, { token: i2.MarkdownService }], target: i0.ɵɵFactoryTarget.Directive })
});
Object.defineProperty(ValidationIssueDirective, "\u0275dir", {
    enumerable: true,
    configurable: true,
    writable: true,
    value: i0.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "12.2.15", type: ValidationIssueDirective, selector: "lf-validation-issue, [lfValidationIssue]", inputs: { issue: "issue" }, host: { listeners: { "click": "_onClick($event.target,$event.button,$event.ctrlKey,$event.metaKey,$event.shiftKey)" }, properties: { "innerHTML": "this.issueMessageHTML" } }, exportAs: ["lfValidationIssue"], usesInheritance: true, ngImport: i0 })
});
__decorate([
    computed
], ValidationIssueDirective.prototype, "issueMessageHTML", null);
__decorate([
    computed
], ValidationIssueDirective.prototype, "lfLinksRenderer", null);
__decorate([
    observable
], ValidationIssueDirective.prototype, "issue", void 0);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0, type: ValidationIssueDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: 'lf-validation-issue, [lfValidationIssue]',
                    exportAs: 'lfValidationIssue',
                }]
        }], ctorParameters: function () { return [{ type: i1.PathBased, decorators: [{
                    type: Optional
                }, {
                    type: Inject,
                    args: [PathBased]
                }] }, { type: i1.LfStorage }, { type: i1.LfI18n }, { type: i1.LfRouter }, { type: i2.MarkdownService }]; }, propDecorators: { issueMessageHTML: [{
                type: HostBinding,
                args: ['innerHTML']
            }], lfLinksRenderer: [], issue: [{
                type: Input
            }], _onClick: [{
                type: HostListener,
                args: ['click', [
                        '$event.target',
                        '$event.button',
                        '$event.ctrlKey',
                        '$event.metaKey',
                        '$event.shiftKey',
                    ]]
            }] } });

/**
 * Validation panel component.
 */
class ValidationPanelComponent extends Toggleable {
    constructor(parentPathBasedComponent, lfStorage, lfI18n, lfRouter) {
        super(parentPathBasedComponent, lfStorage, lfI18n);
        Object.defineProperty(this, "lfRouter", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: lfRouter
        });
        /**
         * Path currently being viewed.
         */
        Object.defineProperty(this, "_currentPath", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        makeObservable(this);
    }
    get errorsText() {
        return this.translate(I18N_VALIDATION_PANEL_ERRORS_TEXT_KEY);
    }
    get warningsText() {
        return this.translate(I18N_VALIDATION_PANEL_WARNINGS_TEXT_KEY);
    }
    get noIssuesText() {
        return this.translate(I18N_VALIDATION_PANEL_NO_ISSUES_TEXT_KEY);
    }
    get focusButtonTooltip() {
        return this.translate(I18N_VALIDATION_PANEL_FOCUS_TEXT_KEY);
    }
    get nextButtonTooltip() {
        return this.translate(I18N_VALIDATION_PANEL_NEXT_BUTTON_TOOLTIP_KEY);
    }
    get prevButtonTooltip() {
        return this.translate(I18N_VALIDATION_PANEL_PREV_BUTTON_TOOLTIP_KEY);
    }
    get closeButtonTooltip() {
        return this.translate(I18N_CLOSE_BUTTON_TOOLTIP_KEY);
    }
    get isPending() {
        return this.relativeStorage.validationStatus() === PENDING;
    }
    get currentPath() {
        return this._currentPath && this._validationIssues[this._currentPath]
            ? this._currentPath
            : this._pages[0];
    }
    get currentLabel() {
        return this.currentPath && this.labelOf(this.currentPath);
    }
    get hasNext() {
        return this.nPages > 1;
    }
    get hasPrevious() {
        return this.nPages > 1;
    }
    get errors() {
        return ((this._validationIssues[this.currentPath] || []).filter((issue) => !issue.isWarning) || []);
    }
    get warnings() {
        return ((this._validationIssues[this.currentPath] || []).filter((issue) => issue.isWarning) || []);
    }
    get hasNoIssues() {
        return this.nPages === 0;
    }
    get panelType() {
        return this.isPending
            ? 'secondary'
            : this.errors.length > 0
                ? 'danger'
                : this.warnings.length > 0
                    ? 'warning'
                    : 'success';
    }
    get shouldDisableFocusButton() {
        return (this.lfStorage.validationMode === ValidationMode.MANUAL &&
            !this.lfStorage.has(this.currentPath));
    }
    get _pages() {
        return Object.keys(this._validationIssues);
    }
    get nPages() {
        return this._pages.length;
    }
    get currentPathIndex() {
        return this._pages.indexOf(this.currentPath);
    }
    get _validationIssues() {
        return this.relativeStorage.validationIssues() || {};
    }
    show() {
        super.show();
        this.navigateToCurrentPath();
    }
    triggerFocus() {
        this.navigateToCurrentPath();
    }
    next() {
        if (this.hasNext) {
            this._currentPath =
                this._pages[(this.currentPathIndex + 1) % this.nPages];
            this.navigateToCurrentPath();
        }
    }
    previous() {
        if (this.hasPrevious) {
            this._currentPath =
                this._pages[(this.currentPathIndex - 1 + this.nPages) % this.nPages];
            this.navigateToCurrentPath();
        }
    }
    /**
     * Label associated with the given path.
     * @param path Path from which to fetch label.
     * @returns Label of given path.
     */
    labelOf(path) {
        return this.lfI18n.getFromPath(path, I18N_VALUE_LABEL_KEY) || path;
    }
    navigateToCurrentPath() {
        if (this.currentPath) {
            // Check if the first route that matches the path is navigateable, if not
            // don't navigate
            const firstMatching = this.lfRouter.matchingRoutes(this.currentPath, {
                navigateToParent: true,
            })[0];
            const navigateable = firstMatching &&
                this.lfRouter.navigateableRouteFromMatchingRoutes([firstMatching]);
            if (navigateable) {
                this.lfRouter.navigateFromNavigateableRoute(navigateable, {
                    queryParamsHandling: 'merge',
                });
            }
            else {
                // Remove fragment TODO: Find a better way of doing it
                this.lfRouter.navigate('.', { queryParamsHandling: 'merge' });
            }
        }
    }
}
Object.defineProperty(ValidationPanelComponent, "\u0275fac", {
    enumerable: true,
    configurable: true,
    writable: true,
    value: i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0, type: ValidationPanelComponent, deps: [{ token: PathBased, optional: true }, { token: i1.LfStorage }, { token: i1.LfI18n }, { token: i1.LfRouter }], target: i0.ɵɵFactoryTarget.Component })
});
Object.defineProperty(ValidationPanelComponent, "\u0275cmp", {
    enumerable: true,
    configurable: true,
    writable: true,
    value: i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.15", type: ValidationPanelComponent, selector: "lf-validation-panel", usesInheritance: true, ngImport: i0, template: "<ng-container *mobxAutorun>\n  <div class=\"validation-panel-container\" *ngIf=\"isVisible\">\n    <div class=\"card border-{{ panelType }}\">\n      <div\n        class=\"card-header bg-{{ panelType }} text-white d-inline-flex\n               justify-content-between\"\n      >\n        <span class=\"header-title\">{{ currentLabel }}</span>\n        <div class=\"actions-bar d-inline-flex justify-content-between\">\n          <button\n            lf-button\n            class=\"panel-focus\"\n            size=\"sm\"\n            [title]=\"focusButtonTooltip\"\n            [attr.aria-label]=\"focusButtonTooltip\"\n            [style]=\"'outline-light'\"\n            (click)=\"triggerFocus()\"\n            [isDisabled]=\"shouldDisableFocusButton\"\n          >\n            <lf-icon icon=\"crosshairs\"></lf-icon>\n          </button>\n          <div class=\"panel-pages-number ml-4\" *ngIf=\"!hasNoIssues\">\n            {{ currentPathIndex + 1 }}/{{ nPages }}\n          </div>\n          <div class=\"btn-group mr-4 ml-2\">\n            <button\n              lf-button\n              class=\"panel-prev\"\n              size=\"sm\"\n              [title]=\"prevButtonTooltip\"\n              [attr.aria-label]=\"prevButtonTooltip\"\n              [style]=\"'outline-light'\"\n              [isDisabled]=\"!hasPrevious\"\n              (click)=\"previous()\"\n            >\n              <lf-icon icon=\"chevron-left\"></lf-icon>\n            </button>\n            <button\n              lf-button\n              class=\"panel-next\"\n              size=\"sm\"\n              [title]=\"nextButtonTooltip\"\n              [attr.aria-label]=\"nextButtonTooltip\"\n              [style]=\"'outline-light'\"\n              [isDisabled]=\"!hasNext\"\n              (click)=\"next()\"\n            >\n              <lf-icon icon=\"chevron-right\"></lf-icon>\n            </button>\n          </div>\n          <button\n            lf-button\n            class=\"panel-close\"\n            size=\"sm\"\n            [title]=\"closeButtonTooltip\"\n            [attr.aria-label]=\"closeButtonTooltip\"\n            [style]=\"'outline-light'\"\n            (click)=\"hide()\"\n          >\n            <lf-icon icon=\"times\"></lf-icon>\n          </button>\n        </div>\n      </div>\n      <div class=\"card-body bg-{{ panelType }}\">\n        <div *ngIf=\"isPending\" class=\"pending\"></div>\n        <ng-container *ngIf=\"!isPending && errors.length > 0\">\n          <strong>\n            <lf-icon icon=\"exclamation-circle\"></lf-icon>\n            {{ errorsText }}\n          </strong>\n          <ul>\n            <li\n              *ngFor=\"let error of errors\"\n              class=\"validation-issue\"\n              lfValidationIssue\n              [path]=\"currentPath\"\n              [issue]=\"error\"\n            ></li>\n          </ul>\n        </ng-container>\n        <ng-container *ngIf=\"!isPending && warnings.length > 0\">\n          <strong>\n            <lf-icon icon=\"exclamation-triangle\"></lf-icon>\n            {{ warningsText }}\n          </strong>\n          <ul>\n            <li\n              *ngFor=\"let warning of warnings\"\n              class=\"validation-issue\"\n              lfValidationIssue\n              [path]=\"currentPath\"\n              [issue]=\"warning\"\n            ></li>\n          </ul>\n        </ng-container>\n        <ng-container *ngIf=\"!isPending && hasNoIssues\">\n          {{ noIssuesText }}\n        </ng-container>\n      </div>\n    </div>\n  </div>\n</ng-container>\n", components: [{ type: ButtonComponent, selector: "button[lf-button], input[lf-button], a[lf-button]", inputs: ["style", "size", "type", "block", "dropdownToggle", "dropdownToggleSplit", "isDisabled", "isActive"] }, { type: IconComponent, selector: "lf-icon", inputs: ["icon", "size", "fixedWidth", "spin", "pulse", "ariaHidden"] }], directives: [{ type: i6.MobxAutorunDirective, selector: "[mobxAutorun]", inputs: ["mobxAutorun"] }, { type: i7.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { type: i7.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { type: ValidationIssueDirective, selector: "lf-validation-issue, [lfValidationIssue]", inputs: ["issue"], exportAs: ["lfValidationIssue"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush })
});
__decorate([
    observable
], ValidationPanelComponent.prototype, "_currentPath", void 0);
__decorate([
    computed
], ValidationPanelComponent.prototype, "errorsText", null);
__decorate([
    computed
], ValidationPanelComponent.prototype, "warningsText", null);
__decorate([
    computed
], ValidationPanelComponent.prototype, "noIssuesText", null);
__decorate([
    computed
], ValidationPanelComponent.prototype, "focusButtonTooltip", null);
__decorate([
    computed
], ValidationPanelComponent.prototype, "nextButtonTooltip", null);
__decorate([
    computed
], ValidationPanelComponent.prototype, "prevButtonTooltip", null);
__decorate([
    computed
], ValidationPanelComponent.prototype, "closeButtonTooltip", null);
__decorate([
    computed
], ValidationPanelComponent.prototype, "isPending", null);
__decorate([
    computed
], ValidationPanelComponent.prototype, "currentPath", null);
__decorate([
    computed
], ValidationPanelComponent.prototype, "currentLabel", null);
__decorate([
    computed
], ValidationPanelComponent.prototype, "hasNext", null);
__decorate([
    computed
], ValidationPanelComponent.prototype, "hasPrevious", null);
__decorate([
    computed
], ValidationPanelComponent.prototype, "errors", null);
__decorate([
    computed
], ValidationPanelComponent.prototype, "warnings", null);
__decorate([
    computed
], ValidationPanelComponent.prototype, "hasNoIssues", null);
__decorate([
    computed
], ValidationPanelComponent.prototype, "panelType", null);
__decorate([
    computed
], ValidationPanelComponent.prototype, "shouldDisableFocusButton", null);
__decorate([
    computed
], ValidationPanelComponent.prototype, "_pages", null);
__decorate([
    computed
], ValidationPanelComponent.prototype, "nPages", null);
__decorate([
    computed
], ValidationPanelComponent.prototype, "currentPathIndex", null);
__decorate([
    computed
], ValidationPanelComponent.prototype, "_validationIssues", null);
__decorate([
    action
], ValidationPanelComponent.prototype, "triggerFocus", null);
__decorate([
    action
], ValidationPanelComponent.prototype, "next", null);
__decorate([
    action
], ValidationPanelComponent.prototype, "previous", null);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0, type: ValidationPanelComponent, decorators: [{
            type: Component,
            args: [{
                    selector: 'lf-validation-panel',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    templateUrl: './validation-panel.component.html',
                }]
        }], ctorParameters: function () { return [{ type: i1.PathBased, decorators: [{
                    type: Optional
                }, {
                    type: Inject,
                    args: [PathBased]
                }] }, { type: i1.LfStorage }, { type: i1.LfI18n }, { type: i1.LfRouter }]; }, propDecorators: { _currentPath: [], errorsText: [], warningsText: [], noIssuesText: [], focusButtonTooltip: [], nextButtonTooltip: [], prevButtonTooltip: [], closeButtonTooltip: [], isPending: [], currentPath: [], currentLabel: [], hasNext: [], hasPrevious: [], errors: [], warnings: [], hasNoIssues: [], panelType: [], shouldDisableFocusButton: [], _pages: [], nPages: [], currentPathIndex: [], _validationIssues: [], triggerFocus: [], next: [], previous: [] } });

/**
 * Lf app component.
 */
class AppComponent extends Value {
    constructor(parentPathBasedComponent, lfStorage, lfI18n, lfRouter) {
        super(parentPathBasedComponent, lfStorage, lfI18n);
        Object.defineProperty(this, "lfRouter", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: lfRouter
        });
        Object.defineProperty(this, "validationPanel", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        Object.defineProperty(this, "_treeNavContainer", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        Object.defineProperty(this, "_mainContainer", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        Object.defineProperty(this, "_mainContent", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        // State of the tree nav visibility
        Object.defineProperty(this, "_isTreeNavVisible", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: false
        });
        // Whether the backdrop element should be in visible or invisible state
        Object.defineProperty(this, "_isBackdropVisible", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: false
        });
        // Whether the backdrop element should exist
        Object.defineProperty(this, "_shouldBackdropExist", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: false
        });
        // If the state is toggled too fast then the `translateX` value won't differ
        // from the initial one, meaning that a transition never occurs and
        // `transitionend` is never called. We keep track of the `translateX` values
        // and run `_hidden` "manually" when necessary
        Object.defineProperty(this, "lastTreeNavTranslateX", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        Object.defineProperty(this, "disposeOnRouterPathChange", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        Object.defineProperty(this, "onPressEsc", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        makeObservable(this);
    }
    get isTreeNavVisible() {
        return this._isTreeNavVisible;
    }
    // Current `translateX` value of the tree nav
    get treeNavTranslateX() {
        // Obtain `tx` from `'matrix(a, b, c, d, tx, ty)'`
        return +window
            .getComputedStyle(this._treeNavContainer.nativeElement)
            .getPropertyValue('transform')
            .split(',')[4];
    }
    ngOnInit() {
        if (this._path === undefined) {
            this._path = '/';
        }
        super.ngOnInit();
    }
    ngAfterViewInit() {
        // Hide tree nav when `Escape` is pressed
        this.onPressEsc = (evt) => {
            if (this.isTreeNavVisible && evt.key === 'Escape') {
                this.hideTreeNav();
            }
        };
        window.addEventListener('keyup', this.onPressEsc);
        // Scroll viewport to the top whenever the router path changes
        if (this.lfRouter !== null) {
            this.disposeOnRouterPathChange = observe(this.lfRouter, 'path', () => {
                this.scrollTo({ top: 0, left: 0 });
            });
        }
    }
    ngOnDestroy() {
        this.onPressEsc && window.removeEventListener('keyup', this.onPressEsc);
        this.disposeOnRouterPathChange && this.disposeOnRouterPathChange();
    }
    showTreeNav() {
        if (!this._isTreeNavVisible) {
            this._isTreeNavVisible = true;
            this._isBackdropVisible = true;
            this._shouldBackdropExist = true;
            this.lastTreeNavTranslateX = this.treeNavTranslateX;
        }
    }
    hideTreeNav() {
        if (this._isTreeNavVisible) {
            this._isTreeNavVisible = false;
            // When there was no time for an animation and `transitionend` isn't called
            if (this.lastTreeNavTranslateX === this.treeNavTranslateX) {
                this._onTreeNavTransitionEnd();
            }
        }
    }
    validate() {
        this.relativeStorage.setTouched('.', true);
        if (this.lfStorage.validationMode === ValidationMode.MANUAL) {
            this.lfStorage.validate();
        }
        this.validationPanel.show();
    }
    /**
     * Scroll the main content area.
     * @param options Options for the scrolling.
     */
    scrollTo(options) {
        // Depending on whether we're in mobile or desktop mode, the scrollable
        // element differs
        this._mainContainer.nativeElement.scrollTo(options);
        this._mainContent.nativeElement.scrollTo(options);
    }
    // Action to run after the tree nav finishes hiding (hide backdrop)
    _onTreeNavTransitionEnd() {
        if (!this.isTreeNavVisible && this._isBackdropVisible) {
            action('hideTreeNavBackdrop', () => (this._isBackdropVisible = false))();
        }
    }
    // Action to run after the backdrop finishes hiding (delete backdrop)
    _onBackdropTransitionEnd() {
        action('removeTreeNavBackdrop', () => (this._shouldBackdropExist = false))();
    }
    validatePath() {
        const schema = this.relativeStorage.schema();
        if (!isRecordSchema(schema) || isNullableSchema(schema)) {
            throw pathError(this.path, 'Schema must be of the "record" type and not "nullable"');
        }
    }
}
Object.defineProperty(AppComponent, "\u0275fac", {
    enumerable: true,
    configurable: true,
    writable: true,
    value: i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0, type: AppComponent, deps: [{ token: PathBased, optional: true, skipSelf: true }, { token: i1.LfStorage }, { token: i1.LfI18n }, { token: LfRouter, optional: true }], target: i0.ɵɵFactoryTarget.Component })
});
Object.defineProperty(AppComponent, "\u0275cmp", {
    enumerable: true,
    configurable: true,
    writable: true,
    value: i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.15", type: AppComponent, selector: "lf-app", providers: [{ provide: PathBased, useExisting: AppComponent }], viewQueries: [{ propertyName: "validationPanel", first: true, predicate: ValidationPanelComponent, descendants: true }, { propertyName: "_treeNavContainer", first: true, predicate: ["treeNavContainer"], descendants: true }, { propertyName: "_mainContainer", first: true, predicate: ["mainContainer"], descendants: true }, { propertyName: "_mainContent", first: true, predicate: ["mainContent"], descendants: true }], usesInheritance: true, ngImport: i0, template: "<ng-container *mobxAutorun>\n  <div class=\"d-flex flex-column h-100\">\n    <!-- Application header -->\n    <header id=\"lf-header\">\n      <ng-content select=\"lf-top-bar\"></ng-content>\n    </header>\n\n    <!-- Content -->\n    <div #mainContainer id=\"lf-main-container\" class=\"container-fluid\">\n      <div id=\"lf-main-row\" class=\"row\">\n        <!-- Container of the tree nav (collapsible from the `top-bar`) -->\n        <div\n          #treeNavContainer\n          id=\"lf-tree-nav-container\"\n          class=\"col-xl-2 col-md-3 col-sm-12\"\n          [class.show]=\"isTreeNavVisible\"\n          [class.animate]=\"_shouldBackdropExist\"\n          (transitionend)=\"_onTreeNavTransitionEnd()\"\n        >\n          <ng-content select=\"lf-tree-nav\"></ng-content>\n        </div>\n\n        <!-- Main content -->\n        <div\n          #mainContent\n          id=\"lf-main-content\"\n          class=\"col-xl-10 col-md-9 col-sm-12\"\n        >\n          <ng-content></ng-content>\n\n          <!-- Validation panel -->\n          <lf-validation-panel></lf-validation-panel>\n        </div>\n      </div>\n    </div>\n  </div>\n\n  <div\n    *ngIf=\"_shouldBackdropExist\"\n    class=\"modal-backdrop fade d-md-none\"\n    [class.show]=\"_isBackdropVisible\"\n    (click)=\"hideTreeNav()\"\n    (transitionend)=\"_onBackdropTransitionEnd()\"\n  ></div>\n</ng-container>\n", components: [{ type: ValidationPanelComponent, selector: "lf-validation-panel" }], directives: [{ type: i6.MobxAutorunDirective, selector: "[mobxAutorun]", inputs: ["mobxAutorun"] }, { type: i7.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush })
});
__decorate([
    observable
], AppComponent.prototype, "_isTreeNavVisible", void 0);
__decorate([
    observable
], AppComponent.prototype, "_isBackdropVisible", void 0);
__decorate([
    observable
], AppComponent.prototype, "_shouldBackdropExist", void 0);
__decorate([
    computed
], AppComponent.prototype, "isTreeNavVisible", null);
__decorate([
    action
], AppComponent.prototype, "showTreeNav", null);
__decorate([
    action
], AppComponent.prototype, "hideTreeNav", null);
__decorate([
    action
], AppComponent.prototype, "validate", null);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0, type: AppComponent, decorators: [{
            type: Component,
            args: [{
                    selector: 'lf-app',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [{ provide: PathBased, useExisting: AppComponent }],
                    templateUrl: './app.component.html',
                }]
        }], ctorParameters: function () { return [{ type: i1.PathBased, decorators: [{
                    type: Optional
                }, {
                    type: SkipSelf
                }, {
                    type: Inject,
                    args: [PathBased]
                }] }, { type: i1.LfStorage }, { type: i1.LfI18n }, { type: i1.LfRouter, decorators: [{
                    type: Optional
                }, {
                    type: Inject,
                    args: [LfRouter]
                }] }]; }, propDecorators: { validationPanel: [{
                type: ViewChild,
                args: [ValidationPanelComponent]
            }], _treeNavContainer: [{
                type: ViewChild,
                args: ['treeNavContainer']
            }], _mainContainer: [{
                type: ViewChild,
                args: ['mainContainer']
            }], _mainContent: [{
                type: ViewChild,
                args: ['mainContent']
            }], _isTreeNavVisible: [], _isBackdropVisible: [], _shouldBackdropExist: [], isTreeNavVisible: [], showTreeNav: [], hideTreeNav: [], validate: [] } });

/**
 * Lf tooltip component.
 */
class TooltipComponent {
    constructor() {
        Object.defineProperty(this, "help", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        Object.defineProperty(this, "placement", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: 'top'
        });
        Object.defineProperty(this, "delay", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: 0
        });
    }
}
Object.defineProperty(TooltipComponent, "\u0275fac", {
    enumerable: true,
    configurable: true,
    writable: true,
    value: i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0, type: TooltipComponent, deps: [], target: i0.ɵɵFactoryTarget.Component })
});
Object.defineProperty(TooltipComponent, "\u0275cmp", {
    enumerable: true,
    configurable: true,
    writable: true,
    value: i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.15", type: TooltipComponent, selector: "lf-tooltip", inputs: { help: "help", placement: "placement", delay: "delay" }, ngImport: i0, template: "<ng-container *mobxAutorun>\n  <span [tooltip]=\"help\" [placement]=\"placement\" [delay]=\"delay\">\n    <ng-content></ng-content>\n  </span>\n</ng-container>\n", directives: [{ type: i6.MobxAutorunDirective, selector: "[mobxAutorun]", inputs: ["mobxAutorun"] }, { type: i2$1.TooltipDirective, selector: "[tooltip], [tooltipHtml]", inputs: ["adaptivePosition", "placement", "triggers", "containerClass", "isDisabled", "delay", "tooltipAnimation", "tooltipFadeDuration", "isOpen", "tooltipHtml", "tooltip", "tooltipPlacement", "tooltipIsOpen", "tooltipEnable", "tooltipAppendToBody", "container", "tooltipClass", "tooltipContext", "tooltipPopupDelay", "tooltipTrigger", "boundariesElement"], outputs: ["tooltipChange", "tooltipStateChanged", "onShown", "onHidden"], exportAs: ["bs-tooltip"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush })
});
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0, type: TooltipComponent, decorators: [{
            type: Component,
            args: [{
                    selector: 'lf-tooltip',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    templateUrl: './tooltip.component.html',
                }]
        }], propDecorators: { help: [{
                type: Input
            }], placement: [{
                type: Input
            }], delay: [{
                type: Input
            }] } });

/**
 * LF component used to display the "top-bar" of an application.
 */
class TopBarComponent {
    constructor(lfStorage, lfRouter, lfI18n, lfFileStorage, _appComponent) {
        Object.defineProperty(this, "lfStorage", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: lfStorage
        });
        Object.defineProperty(this, "lfRouter", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: lfRouter
        });
        Object.defineProperty(this, "lfI18n", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: lfI18n
        });
        Object.defineProperty(this, "lfFileStorage", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: lfFileStorage
        });
        Object.defineProperty(this, "_appComponent", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: _appComponent
        });
        Object.defineProperty(this, "actions", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        makeObservable(this);
    }
    get retryValidationText() {
        return this.lfI18n.get(I18N_VALUE_RETRY_VALIDATE_TEXT_KEY);
    }
    get rootUrl() {
        try {
            return this.lfRouter.createUrl('/');
        }
        catch (err) {
            return '/';
        }
    }
    get appIsPending() {
        return (this.lfStorage.shouldShowPending() ||
            (this.lfFileStorage && this.lfFileStorage.isLoading));
    }
    get shouldShowAppRecompute() {
        return !!this.lfStorage.shouldShowRejected();
    }
    get isTreeNavVisible() {
        return this._appComponent.isTreeNavVisible;
    }
    recomputeAppStateProperties() {
        this.lfStorage.recomputeStateProperties();
    }
    showTreeNav() {
        this._appComponent.showTreeNav();
    }
}
Object.defineProperty(TopBarComponent, "\u0275fac", {
    enumerable: true,
    configurable: true,
    writable: true,
    value: i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0, type: TopBarComponent, deps: [{ token: i1.LfStorage }, { token: i1.LfRouter }, { token: LfI18n }, { token: LfFileStorage, optional: true }, { token: AppComponent }], target: i0.ɵɵFactoryTarget.Component })
});
Object.defineProperty(TopBarComponent, "\u0275cmp", {
    enumerable: true,
    configurable: true,
    writable: true,
    value: i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.15", type: TopBarComponent, selector: "lf-top-bar", inputs: { actions: "actions" }, ngImport: i0, template: "<ng-container *mobxAutorun>\n  <nav class=\"navbar navbar-expand-lg justify-content-between\">\n    <!-- Tree toggle + title + pending icon -->\n    <div class=\"navbar-brand\">\n      <!-- Small screen: show tree-nav button -->\n      <button\n        lf-button\n        class=\"tree-nav-show d-md-none\"\n        [style]=\"'outline-secondary'\"\n        (click)=\"showTreeNav()\"\n      >\n        <lf-icon icon=\"bars\"></lf-icon>\n      </button>\n\n      <!-- Title -->\n      <a\n        class=\"navbar-title\"\n        [routerLink]=\"rootUrl\"\n        queryParamsHandling=\"merge\"\n      >\n        <ng-content></ng-content>\n      </a>\n\n      <!-- Pending app validation -->\n      <div class=\"pending-app\" *ngIf=\"appIsPending\"></div>\n\n      <!-- Rejected app validation -->\n      <div\n        class=\"rejected-app\"\n        *ngIf=\"shouldShowAppRecompute\"\n        (click)=\"recomputeAppStateProperties()\"\n      >\n        <lf-tooltip [help]=\"retryValidationText\" placement=\"right\">\n          <lf-icon icon=\"warning\"></lf-icon>\n        </lf-tooltip>\n      </div>\n    </div>\n\n    <!-- Application actions -->\n    <lf-actions-menu [actions]=\"actions\" [alignMenusRight]=\"true\">\n    </lf-actions-menu>\n  </nav>\n</ng-container>\n", components: [{ type: ButtonComponent, selector: "button[lf-button], input[lf-button], a[lf-button]", inputs: ["style", "size", "type", "block", "dropdownToggle", "dropdownToggleSplit", "isDisabled", "isActive"] }, { type: IconComponent, selector: "lf-icon", inputs: ["icon", "size", "fixedWidth", "spin", "pulse", "ariaHidden"] }, { type: TooltipComponent, selector: "lf-tooltip", inputs: ["help", "placement", "delay"] }, { type: ActionsMenuComponent, selector: "lf-actions-menu", inputs: ["actions", "buttonsSize", "collapseSize", "actionsLabelCollapseSize", "alignMenusRight"] }], directives: [{ type: i6.MobxAutorunDirective, selector: "[mobxAutorun]", inputs: ["mobxAutorun"] }, { type: i7$1.RouterLinkWithHref, selector: "a[routerLink],area[routerLink]", inputs: ["routerLink", "target", "queryParams", "fragment", "queryParamsHandling", "preserveFragment", "skipLocationChange", "replaceUrl", "state", "relativeTo"] }, { type: i7.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush })
});
__decorate([
    observable.struct
], TopBarComponent.prototype, "actions", void 0);
__decorate([
    computed
], TopBarComponent.prototype, "retryValidationText", null);
__decorate([
    computed
], TopBarComponent.prototype, "rootUrl", null);
__decorate([
    computed
], TopBarComponent.prototype, "appIsPending", null);
__decorate([
    computed
], TopBarComponent.prototype, "shouldShowAppRecompute", null);
__decorate([
    computed
], TopBarComponent.prototype, "isTreeNavVisible", null);
__decorate([
    action
], TopBarComponent.prototype, "recomputeAppStateProperties", null);
__decorate([
    action
], TopBarComponent.prototype, "showTreeNav", null);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0, type: TopBarComponent, decorators: [{
            type: Component,
            args: [{
                    selector: 'lf-top-bar',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    templateUrl: './top-bar.component.html',
                }]
        }], ctorParameters: function () { return [{ type: i1.LfStorage }, { type: i1.LfRouter }, { type: i1.LfI18n, decorators: [{
                    type: Inject,
                    args: [LfI18n]
                }] }, { type: i1.LfFileStorage, decorators: [{
                    type: Optional
                }, {
                    type: Inject,
                    args: [LfFileStorage]
                }] }, { type: AppComponent, decorators: [{
                    type: Inject,
                    args: [AppComponent]
                }] }]; }, propDecorators: { actions: [{
                type: Input
            }], retryValidationText: [], rootUrl: [], appIsPending: [], shouldShowAppRecompute: [], isTreeNavVisible: [], recomputeAppStateProperties: [], showTreeNav: [] } });

/**
 * Content of an `lf-card`.
 */
class CardContentComponent extends PathBased {
    constructor(parentPathBasedComponent, lfStorage, lfI18n) {
        super(parentPathBasedComponent, lfStorage, lfI18n);
        /**
         * Type of the content.
         */
        Object.defineProperty(this, "contentType", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        makeObservable(this);
    }
    // Classes for each type of card content
    get _hostClassCardHeader() {
        return this.contentType === 'header';
    }
    get _hostClassCardBody() {
        return this.contentType === 'body';
    }
    get _hostClassCardFooter() {
        return this.contentType === 'footer';
    }
    get _hostClassCardTitle() {
        return this.contentType === 'title';
    }
    get _hostClassCardSubtitle() {
        return this.contentType === 'subtitle';
    }
    get _hostClassCardText() {
        return this.contentType === 'text';
    }
    get _hostClassCardLink() {
        return this.contentType === 'link';
    }
    get _hostClassCardImg() {
        return this.contentType === 'img';
    }
    get _hostClassCardImgOverlay() {
        return this.contentType === 'img-overlay';
    }
    get _hostClassCardImgTop() {
        return this.contentType === 'img-top';
    }
    get _hostClassCardImgBottom() {
        return this.contentType === 'img-bottom';
    }
}
Object.defineProperty(CardContentComponent, "\u0275fac", {
    enumerable: true,
    configurable: true,
    writable: true,
    value: i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0, type: CardContentComponent, deps: [{ token: PathBased, optional: true, skipSelf: true }, { token: i1.LfStorage }, { token: i1.LfI18n }], target: i0.ɵɵFactoryTarget.Component })
});
Object.defineProperty(CardContentComponent, "\u0275cmp", {
    enumerable: true,
    configurable: true,
    writable: true,
    value: i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.15", type: CardContentComponent, selector: "lf-card-content, [lf-card-content]", inputs: { contentType: "contentType" }, host: { properties: { "class.card-header": "this._hostClassCardHeader", "class.card-body": "this._hostClassCardBody", "class.card-footer": "this._hostClassCardFooter", "class.card-title": "this._hostClassCardTitle", "class.card-subtitle": "this._hostClassCardSubtitle", "class.card-text": "this._hostClassCardText", "class.card-link": "this._hostClassCardLink", "class.card-img": "this._hostClassCardImg", "class.card-img-overlay": "this._hostClassCardImgOverlay", "class.card-img-top": "this._hostClassCardImgTop", "class.card-img-bottom": "this._hostClassCardImgBottom" } }, providers: [{ provide: PathBased, useExisting: CardContentComponent }], usesInheritance: true, ngImport: i0, template: '<ng-container *mobxAutorun><ng-content></ng-content></ng-container>', isInline: true, directives: [{ type: i6.MobxAutorunDirective, selector: "[mobxAutorun]", inputs: ["mobxAutorun"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush })
});
__decorate([
    observable
], CardContentComponent.prototype, "contentType", void 0);
__decorate([
    computed
], CardContentComponent.prototype, "_hostClassCardHeader", null);
__decorate([
    computed
], CardContentComponent.prototype, "_hostClassCardBody", null);
__decorate([
    computed
], CardContentComponent.prototype, "_hostClassCardFooter", null);
__decorate([
    computed
], CardContentComponent.prototype, "_hostClassCardTitle", null);
__decorate([
    computed
], CardContentComponent.prototype, "_hostClassCardSubtitle", null);
__decorate([
    computed
], CardContentComponent.prototype, "_hostClassCardText", null);
__decorate([
    computed
], CardContentComponent.prototype, "_hostClassCardLink", null);
__decorate([
    computed
], CardContentComponent.prototype, "_hostClassCardImg", null);
__decorate([
    computed
], CardContentComponent.prototype, "_hostClassCardImgOverlay", null);
__decorate([
    computed
], CardContentComponent.prototype, "_hostClassCardImgTop", null);
__decorate([
    computed
], CardContentComponent.prototype, "_hostClassCardImgBottom", null);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0, type: CardContentComponent, decorators: [{
            type: Component,
            args: [{
                    selector: 'lf-card-content, [lf-card-content]',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [{ provide: PathBased, useExisting: CardContentComponent }],
                    template: '<ng-container *mobxAutorun><ng-content></ng-content></ng-container>',
                }]
        }], ctorParameters: function () { return [{ type: i1.PathBased, decorators: [{
                    type: Optional
                }, {
                    type: SkipSelf
                }, {
                    type: Inject,
                    args: [PathBased]
                }] }, { type: i1.LfStorage }, { type: i1.LfI18n }]; }, propDecorators: { contentType: [{
                type: Input
            }], _hostClassCardHeader: [{
                type: HostBinding,
                args: ['class.card-header']
            }], _hostClassCardBody: [{
                type: HostBinding,
                args: ['class.card-body']
            }], _hostClassCardFooter: [{
                type: HostBinding,
                args: ['class.card-footer']
            }], _hostClassCardTitle: [{
                type: HostBinding,
                args: ['class.card-title']
            }], _hostClassCardSubtitle: [{
                type: HostBinding,
                args: ['class.card-subtitle']
            }], _hostClassCardText: [{
                type: HostBinding,
                args: ['class.card-text']
            }], _hostClassCardLink: [{
                type: HostBinding,
                args: ['class.card-link']
            }], _hostClassCardImg: [{
                type: HostBinding,
                args: ['class.card-img']
            }], _hostClassCardImgOverlay: [{
                type: HostBinding,
                args: ['class.card-img-overlay']
            }], _hostClassCardImgTop: [{
                type: HostBinding,
                args: ['class.card-img-top']
            }], _hostClassCardImgBottom: [{
                type: HostBinding,
                args: ['class.card-img-bottom']
            }] } });

/**
 * Bootstrap card component, see options on how to further customise the card
 * with background and border utilities at [Bootstrap documentation](
 * https://getbootstrap.com/docs/4.1/components/card/#card-styles).
 */
class CardComponent extends PathBased {
    constructor(parentPathBasedComponent, lfStorage, lfI18n) {
        super(parentPathBasedComponent, lfStorage, lfI18n);
        /**
         * Always add the class `card` to LF cards.
         */
        Object.defineProperty(this, "_hostClassCard", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: true
        });
    }
}
Object.defineProperty(CardComponent, "\u0275fac", {
    enumerable: true,
    configurable: true,
    writable: true,
    value: i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0, type: CardComponent, deps: [{ token: PathBased, optional: true, skipSelf: true }, { token: i1.LfStorage }, { token: i1.LfI18n }], target: i0.ɵɵFactoryTarget.Component })
});
Object.defineProperty(CardComponent, "\u0275cmp", {
    enumerable: true,
    configurable: true,
    writable: true,
    value: i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.15", type: CardComponent, selector: "lf-card, [lf-card]", host: { properties: { "class.card": "this._hostClassCard" } }, providers: [{ provide: PathBased, useExisting: CardComponent }], usesInheritance: true, ngImport: i0, template: '<ng-container *mobxAutorun><ng-content></ng-content></ng-container>', isInline: true, directives: [{ type: i6.MobxAutorunDirective, selector: "[mobxAutorun]", inputs: ["mobxAutorun"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush })
});
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0, type: CardComponent, decorators: [{
            type: Component,
            args: [{
                    selector: 'lf-card, [lf-card]',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [{ provide: PathBased, useExisting: CardComponent }],
                    template: '<ng-container *mobxAutorun><ng-content></ng-content></ng-container>',
                }]
        }], ctorParameters: function () { return [{ type: i1.PathBased, decorators: [{
                    type: Optional
                }, {
                    type: SkipSelf
                }, {
                    type: Inject,
                    args: [PathBased]
                }] }, { type: i1.LfStorage }, { type: i1.LfI18n }]; }, propDecorators: { _hostClassCard: [{
                type: HostBinding,
                args: ['class.card']
            }] } });

/**
 * Abstract class used to represent typical "inline-able" values.
 */
// tslint:disable-next-line: directive-class-suffix
class InlineValue extends Value {
    constructor(parentPathBasedComponent, lfStorage, lfI18n, lfRouter) {
        super(parentPathBasedComponent, lfStorage, lfI18n);
        Object.defineProperty(this, "lfRouter", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: lfRouter
        });
        /**
         * Whether the component should be hidden when its value isn't required.
         * **NOT READY FOR USE**
         */
        // TODO: What about components that aren't nullable? Example: tables, text, we
        // should use minSize/minLength instead. Allow each component to implement its
        // own "isRequired" functionality?
        Object.defineProperty(this, "_hideWhenNotRequired", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: false
        });
        /**
         * Event emitter which emits an event whenever the component's DOM input is
         * focused.
         */
        Object.defineProperty(this, "focus", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: new EventEmitter()
        });
        /**
         * Event emitter which emits an event whenever the component's DOM input is
         * blurred.
         */
        Object.defineProperty(this, "blur", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: new EventEmitter()
        });
        /**
         * Add an `lf-inline-value` class to components.
         */
        Object.defineProperty(this, "_classLfInlineValue", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: true
        });
        /**
         * Target elements that should be the target of focus/blur events; the first
         * element of que query list is the one that will be focused on route change
         * or when demanded via `focus()`.
         */
        Object.defineProperty(this, "targets", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        /**
         * Disposer for the "auto-focus" of the field when it becomes active.
         */
        Object.defineProperty(this, "disposeOnActive", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        makeObservable(this);
    }
    /**
     * Whether this component should be displayed.
     */
    get shouldDisplay() {
        return (this.relativeStorage.has() &&
            (!this._hideWhenNotRequired ||
                (this.relativeStorage.validationMode === ValidationMode.AUTO
                    ? this.relativeStorage.getStateProperty('.', 'isRequired')
                    : this.relativeStorage.schema().isRequired) === true));
    }
    ngOnInit() {
        super.ngOnInit();
    }
    ngAfterViewInit() {
        if (this.lfRouter !== null) {
            // Auto-focus the field when this component's path is activated
            this.disposeOnActive = autorun(() => {
                if (this.lfRouter.isActiveWithFragment(this.path)) {
                    const res = this.onActivate &&
                        this.onActivate(this.lfRouter.pathWithFragment);
                    // Trigger the `focus` only when path matches exactly
                    if (res !== false &&
                        this.lfRouter.isActiveWithFragment(this.path, true)) {
                        asap(() => this.triggerFocus());
                    }
                }
            }, { name: 'fieldAutorunFocusOnActive' });
        }
    }
    ngOnDestroy() {
        super.ngOnDestroy();
        this.disposeOnActive && this.disposeOnActive();
    }
    /**
     * Scrolls this component into the center of the viewport and focuses it.
     */
    triggerFocus() {
        if (this.targets && this.targets.length > 0) {
            const target = this.targets.first.nativeElement;
            target.scrollIntoView({ block: 'center' });
            target.focus();
        }
    }
    /**
     * Action to run whenever a focusable part of the field is focused.
     * @param evt `focus` event.
     */
    _onFocus(evt) {
        this.focus.emit(evt);
    }
    /**
     * Action to run whenever a focusable part of the field is blurred.
     * @param evt `blur` event.
     * @param setTouched Whether to try and set the value as "touched". Defaults
     * to `true`.
     */
    _onBlur(evt, setTouched = true) {
        var _a;
        if (setTouched && !this.relativeStorage.isComputed()) {
            this.relativeStorage.setTouched();
        }
        // Remove the fragment when the path exactly matches the URL
        if ((_a = this.lfRouter) === null || _a === void 0 ? void 0 : _a.isActiveWithFragment(this.path, true)) {
            this.lfRouter.navigate('.', { queryParamsHandling: 'merge' });
        }
        this.blur.emit(evt);
    }
}
Object.defineProperty(InlineValue, "\u0275fac", {
    enumerable: true,
    configurable: true,
    writable: true,
    value: i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0, type: InlineValue, deps: [{ token: i1.PathBased }, { token: i1.LfStorage }, { token: i1.LfI18n }, { token: i1.LfRouter }], target: i0.ɵɵFactoryTarget.Directive })
});
Object.defineProperty(InlineValue, "\u0275dir", {
    enumerable: true,
    configurable: true,
    writable: true,
    value: i0.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "12.2.15", type: InlineValue, inputs: { _hideWhenNotRequired: "_hideWhenNotRequired" }, outputs: { focus: "focus", blur: "blur" }, host: { properties: { "class.lf-inline-value": "this._classLfInlineValue" } }, viewQueries: [{ propertyName: "targets", predicate: ["focusTarget"], descendants: true }], usesInheritance: true, ngImport: i0 })
});
__decorate([
    observable
], InlineValue.prototype, "_hideWhenNotRequired", void 0);
__decorate([
    computed
], InlineValue.prototype, "shouldDisplay", null);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0, type: InlineValue, decorators: [{
            type: Directive
        }], ctorParameters: function () { return [{ type: i1.PathBased }, { type: i1.LfStorage }, { type: i1.LfI18n }, { type: i1.LfRouter }]; }, propDecorators: { _hideWhenNotRequired: [{
                type: Input
            }], focus: [{
                type: Output
            }], blur: [{
                type: Output
            }], _classLfInlineValue: [{
                type: HostBinding,
                args: ['class.lf-inline-value']
            }], targets: [{
                type: ViewChildren,
                args: ['focusTarget']
            }], shouldDisplay: [] } });

/**
 * Class which represents a component whose value may be restricted by a set of
 * options.
 */
// tslint:disable-next-line: directive-class-suffix
class SelectionValue extends InlineValue {
    constructor(parentPathBasedComponent, lfStorage, lfI18n, lfRouter) {
        super(parentPathBasedComponent, lfStorage, lfI18n, lfRouter);
        makeObservable(this);
    }
    /**
     * Selectable options (possibly fetched asynchronously).
     */
    // Not `computed` due to `useState` (cannot be used within a `computed`)
    get options() {
        return this.translate(I18N_SELECTION_OPTIONS_KEY, { useState: true }) || [];
    }
    /**
     * Text to be shown when there are no options available.
     */
    get noOptionsText() {
        return this.translate(I18N_SELECTION_NO_OPTIONS_TEXT_KEY);
    }
    /**
     * Promise-status of the options.
     */
    get optionsStatus() {
        return this.translationStatus(I18N_SELECTION_OPTIONS_KEY);
    }
}
Object.defineProperty(SelectionValue, "\u0275fac", {
    enumerable: true,
    configurable: true,
    writable: true,
    value: i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0, type: SelectionValue, deps: [{ token: i1.PathBased }, { token: i1.LfStorage }, { token: i1.LfI18n }, { token: i1.LfRouter }], target: i0.ɵɵFactoryTarget.Directive })
});
Object.defineProperty(SelectionValue, "\u0275dir", {
    enumerable: true,
    configurable: true,
    writable: true,
    value: i0.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "12.2.15", type: SelectionValue, usesInheritance: true, ngImport: i0 })
});
__decorate([
    computed
], SelectionValue.prototype, "noOptionsText", null);
__decorate([
    computed
], SelectionValue.prototype, "optionsStatus", null);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0, type: SelectionValue, decorators: [{
            type: Directive
        }], ctorParameters: function () { return [{ type: i1.PathBased }, { type: i1.LfStorage }, { type: i1.LfI18n }, { type: i1.LfRouter }]; }, propDecorators: { noOptionsText: [], optionsStatus: [] } });

class HelpTooltipComponent {
    constructor() {
        Object.defineProperty(this, "help", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
    }
}
Object.defineProperty(HelpTooltipComponent, "\u0275fac", {
    enumerable: true,
    configurable: true,
    writable: true,
    value: i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0, type: HelpTooltipComponent, deps: [], target: i0.ɵɵFactoryTarget.Component })
});
Object.defineProperty(HelpTooltipComponent, "\u0275cmp", {
    enumerable: true,
    configurable: true,
    writable: true,
    value: i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.15", type: HelpTooltipComponent, selector: "lf-help-tooltip", inputs: { help: "help" }, ngImport: i0, template: "<lf-tooltip [help]=\"help\" boundary=\"window\">\n  <lf-icon icon=\"question-circle\"></lf-icon>\n</lf-tooltip>\n", components: [{ type: TooltipComponent, selector: "lf-tooltip", inputs: ["help", "placement", "delay"] }, { type: IconComponent, selector: "lf-icon", inputs: ["icon", "size", "fixedWidth", "spin", "pulse", "ariaHidden"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush })
});
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0, type: HelpTooltipComponent, decorators: [{
            type: Component,
            args: [{
                    selector: 'lf-help-tooltip',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    templateUrl: './help-tooltip.component.html',
                }]
        }], propDecorators: { help: [{
                type: Input
            }] } });

/**
 * LF modal component.
 */
class ModalComponent extends Toggleable {
    constructor(parentPathBasedComponent, lfStorage, lfI18n) {
        super(parentPathBasedComponent, lfStorage, lfI18n);
        /**
         * Size of the modal component. See available sizes at
         * [Bootstrap documentation](
         * https://getbootstrap.com/docs/4.0/components/modal/#optional-sizes).
         */
        Object.defineProperty(this, "size", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        /**
         * Whether to center the modal vertically on screen.
         */
        Object.defineProperty(this, "isCentered", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: false
        });
        /**
         * Whether to animate the modal component.
         */
        Object.defineProperty(this, "animate", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: true
        });
        /**
         * Whether to enable closing the modal by pressing the `Esc` key.
         */
        Object.defineProperty(this, "closeWithEsc", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: true
        });
        /**
         * Whether to show a dark background underneath the modal when it appears.
         */
        Object.defineProperty(this, "showBackdrop", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: true
        });
        /**
         * Whether to disable closing the modal by clicking on the backdrop.
         */
        Object.defineProperty(this, "ignoreBackdropClick", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: false
        });
        /**
         * If the modal contains `<input>`, `<select>`, or `<textarea>` elements
         * within, focus the first found element after the modal opens.
         */
        Object.defineProperty(this, "autoFocus", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: false
        });
        /**
         * Event emitter which emits an event whenever the modal finishes showing.
         */
        Object.defineProperty(this, "shown", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: new EventEmitter()
        });
        /**
         * Event emitter which emits an event whenever the modal finishes hiding.
         */
        Object.defineProperty(this, "hidden", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: new EventEmitter()
        });
        Object.defineProperty(this, "_modal", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        Object.defineProperty(this, "$modal", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        // Whether the modal is animating
        Object.defineProperty(this, "isAnimating", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        // Subscriptions
        Object.defineProperty(this, "disposeOnOptionsChange", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        Object.defineProperty(this, "onShowSubscription", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        Object.defineProperty(this, "onHideSubscription", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        makeObservable(this);
    }
    ngAfterViewInit() {
        this.createModal();
    }
    ngOnDestroy() {
        this.destroyModal();
        super.ngOnDestroy();
    }
    /**
     * Method to call on long modals when their content changes, which forces
     * their height to also change.
     */
    refresh() {
        this.$modal.modal('handleUpdate');
    }
    show() {
        return new Promise((resolve) => {
            super.show();
            if (this.isAnimating) {
                this.$modal.one('shown.bs.modal', resolve);
            }
            else {
                resolve();
            }
        });
    }
    hide() {
        return new Promise((resolve) => {
            super.hide();
            if (this.isAnimating) {
                this.$modal.one('hidden.bs.modal', resolve);
            }
            else {
                resolve();
            }
        });
    }
    toggle() {
        return this.isVisible ? this.hide() : this.show();
    }
    /**
     * Creates a new modal and starts listening to events.
     */
    createModal() {
        this.$modal = $(this._modal.nativeElement).modal({
            backdrop: this.showBackdrop && this.ignoreBackdropClick
                ? 'static'
                : this.showBackdrop,
            keyboard: this.closeWithEsc,
            show: this.isVisible,
        });
        // There seems to be no way of updating these settings, so the most we can
        // do is destroy and reconstruct the modal whenever they change. TODO:
        // Figure out a better approach for this, perhaps implement this
        // functionality ourselves
        this.disposeOnOptionsChange = reaction(() => [this.closeWithEsc, this.showBackdrop, this.ignoreBackdropClick], () => this.destroyModal().then(() => this.createModal()), { name: 'modalReactionOnOptionsChange' });
        // Set the component's state if the modal is shown unconventionally
        // (i.e. without calling `show()`)
        this.$modal.on('show.bs.modal', () => {
            this.isAnimating = true;
            if (!this.isVisible) {
                this.show();
            }
        });
        // Set the component's state if the modal is hidden unconventionally
        // (i.e. without calling `hide()`), this happens, for instance, when
        // pressing `Esc` or when pressing the area outside the modal
        this.$modal.on('hide.bs.modal', () => {
            this.isAnimating = true;
            if (this.isVisible) {
                this.hide();
            }
        });
        // Runs when the showing animation ends
        this.$modal.on('shown.bs.modal', () => {
            this.isAnimating = false;
            this.shown.emit();
            // `isVisible` may change faster than the animations occur, force the UI
            // state to match `isVisible`
            if (!this.isVisible) {
                this.hide();
            }
            // Focus the first input of the modal's body once it opens
            if (this.autoFocus) {
                const firstInput = $('.modal-body input, .modal-body select, .modal-body textarea', this.$modal).get(0);
                if (firstInput) {
                    firstInput.focus();
                }
            }
        });
        // Runs when the hiding animation ends
        this.$modal.on('hidden.bs.modal', () => {
            this.isAnimating = false;
            this.hidden.emit();
            // `isVisible` may change faster than the animations occur, force the UI
            // state to match `isVisible`
            if (this.isVisible) {
                this.show();
            }
        });
        // Open the modal when `show` is called
        this.onShowSubscription = this._show.subscribe(() => {
            if (!this.isAnimating) {
                this.$modal.modal('show');
            }
        });
        // Close the modal when `hide` is called
        this.onHideSubscription = this._hide.subscribe(() => {
            if (!this.isAnimating) {
                this.$modal.modal('hide');
            }
        });
    }
    /**
     * Unsubscribes from all events and destroys the modal (returns a promise that
     * resolves after the modal has been destroyed).
     * @returns Promise that resolves when the modal has been destroyed.
     */
    // FIXME: This returns a promise because we are forced to hide the modal prior
    // to removing it; otherwise a leftover backdrop will stay within the document
    // (this is probably an upstream Bootstrap bug)
    destroyModal() {
        this.disposeOnOptionsChange && this.disposeOnOptionsChange();
        if (this.$modal) {
            this.$modal.off('show.bs.modal');
            this.$modal.off('hide.bs.modal');
            this.$modal.off('shown.bs.modal');
            this.$modal.off('hidden.bs.modal');
        }
        this.onShowSubscription && this.onShowSubscription.unsubscribe();
        this.onHideSubscription && this.onHideSubscription.unsubscribe();
        if (this.isVisible) {
            return new Promise((resolve) => {
                // If we don't hide the modal prior to disposing of it, then a leftover
                // backdrop will stay in the document
                this.hide();
                this.$modal.one('hidden.bs.modal', () => {
                    $(this).modal('dispose');
                    resolve();
                });
            });
        }
        else {
            this.$modal.modal('dispose');
            return Promise.resolve();
        }
    }
}
Object.defineProperty(ModalComponent, "\u0275fac", {
    enumerable: true,
    configurable: true,
    writable: true,
    value: i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0, type: ModalComponent, deps: [{ token: PathBased, optional: true, skipSelf: true }, { token: i1.LfStorage }, { token: i1.LfI18n }], target: i0.ɵɵFactoryTarget.Component })
});
Object.defineProperty(ModalComponent, "\u0275cmp", {
    enumerable: true,
    configurable: true,
    writable: true,
    value: i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.15", type: ModalComponent, selector: "lf-modal", inputs: { size: "size", isCentered: "isCentered", animate: "animate", closeWithEsc: "closeWithEsc", showBackdrop: "showBackdrop", ignoreBackdropClick: "ignoreBackdropClick", autoFocus: "autoFocus" }, outputs: { shown: "shown", hidden: "hidden" }, providers: [{ provide: PathBased, useExisting: ModalComponent }], viewQueries: [{ propertyName: "_modal", first: true, predicate: ["modal"], descendants: true }], usesInheritance: true, ngImport: i0, template: "<ng-container *mobxAutorun>\n  <div\n    #modal\n    class=\"modal\"\n    [class.fade]=\"animate\"\n    tabindex=\"-1\"\n    role=\"dialog\"\n    aria-hidden=\"true\"\n  >\n    <div\n      class=\"modal-dialog {{ size ? 'modal-' + size : '' }}\"\n      [class.modal-dialog-centered]=\"isCentered\"\n    >\n      <div class=\"modal-content\" role=\"document\"><ng-content></ng-content></div>\n    </div>\n  </div>\n</ng-container>\n", directives: [{ type: i6.MobxAutorunDirective, selector: "[mobxAutorun]", inputs: ["mobxAutorun"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush })
});
__decorate([
    observable
], ModalComponent.prototype, "size", void 0);
__decorate([
    observable
], ModalComponent.prototype, "isCentered", void 0);
__decorate([
    observable
], ModalComponent.prototype, "animate", void 0);
__decorate([
    observable
], ModalComponent.prototype, "closeWithEsc", void 0);
__decorate([
    observable
], ModalComponent.prototype, "showBackdrop", void 0);
__decorate([
    observable
], ModalComponent.prototype, "ignoreBackdropClick", void 0);
__decorate([
    observable
], ModalComponent.prototype, "autoFocus", void 0);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0, type: ModalComponent, decorators: [{
            type: Component,
            args: [{
                    selector: 'lf-modal',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [{ provide: PathBased, useExisting: ModalComponent }],
                    templateUrl: './modal.component.html',
                }]
        }], ctorParameters: function () { return [{ type: i1.PathBased, decorators: [{
                    type: Optional
                }, {
                    type: SkipSelf
                }, {
                    type: Inject,
                    args: [PathBased]
                }] }, { type: i1.LfStorage }, { type: i1.LfI18n }]; }, propDecorators: { size: [{
                type: Input
            }], isCentered: [{
                type: Input
            }], animate: [{
                type: Input
            }], closeWithEsc: [{
                type: Input
            }], showBackdrop: [{
                type: Input
            }], ignoreBackdropClick: [{
                type: Input
            }], autoFocus: [{
                type: Input
            }], shown: [{
                type: Output
            }], hidden: [{
                type: Output
            }], _modal: [{
                type: ViewChild,
                args: ['modal']
            }] } });

/**
 * Component that represents the header of a Bootstrap modal.
 */
class ModalHeaderComponent {
    constructor(modalComponent) {
        Object.defineProperty(this, "modalComponent", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: modalComponent
        });
        /**
         * Whether to display a button to close the modal.
         */
        Object.defineProperty(this, "showCloseButton", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: true
        });
        // The modal header must always have the `modal-header` class.
        Object.defineProperty(this, "_hostClassModalHeader", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: true
        });
        makeObservable(this);
    }
    /**
     * Tooltip text used by the modal's close button.
     */
    get closeButtonTooltip() {
        return this.modalComponent.translate(I18N_CLOSE_BUTTON_TOOLTIP_KEY);
    }
    /**
     * Hides the modal.
     */
    hide() {
        this.modalComponent.hide();
    }
}
Object.defineProperty(ModalHeaderComponent, "\u0275fac", {
    enumerable: true,
    configurable: true,
    writable: true,
    value: i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0, type: ModalHeaderComponent, deps: [{ token: ModalComponent }], target: i0.ɵɵFactoryTarget.Component })
});
Object.defineProperty(ModalHeaderComponent, "\u0275cmp", {
    enumerable: true,
    configurable: true,
    writable: true,
    value: i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.15", type: ModalHeaderComponent, selector: "lf-modal-header, [lf-modal-header]", inputs: { showCloseButton: "showCloseButton" }, host: { properties: { "class.modal-header": "this._hostClassModalHeader" } }, ngImport: i0, template: "<ng-container *mobxAutorun>\n  <!-- Title -->\n  <h5 class=\"modal-title\"><ng-content></ng-content></h5>\n\n  <!-- Close button -->\n  <button\n    *ngIf=\"showCloseButton\"\n    type=\"button\"\n    class=\"close\"\n    [title]=\"closeButtonTooltip\"\n    [attr.aria-label]=\"closeButtonTooltip\"\n    (click)=\"hide()\"\n  >\n    <span aria-hidden=\"true\">&times;</span>\n  </button>\n</ng-container>\n", directives: [{ type: i6.MobxAutorunDirective, selector: "[mobxAutorun]", inputs: ["mobxAutorun"] }, { type: i7.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush })
});
__decorate([
    observable
], ModalHeaderComponent.prototype, "showCloseButton", void 0);
__decorate([
    computed
], ModalHeaderComponent.prototype, "closeButtonTooltip", null);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0, type: ModalHeaderComponent, decorators: [{
            type: Component,
            args: [{
                    selector: 'lf-modal-header, [lf-modal-header]',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    templateUrl: './modal-header.component.html',
                }]
        }], ctorParameters: function () { return [{ type: ModalComponent }]; }, propDecorators: { showCloseButton: [{
                type: Input
            }], _hostClassModalHeader: [{
                type: HostBinding,
                args: ['class.modal-header']
            }], closeButtonTooltip: [] } });

/**
 * Component that represents the body of a Bootstrap modal.
 */
class ModalBodyComponent {
    constructor() {
        Object.defineProperty(this, "_hostClassModalBody", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: true
        });
    }
}
Object.defineProperty(ModalBodyComponent, "\u0275fac", {
    enumerable: true,
    configurable: true,
    writable: true,
    value: i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0, type: ModalBodyComponent, deps: [], target: i0.ɵɵFactoryTarget.Component })
});
Object.defineProperty(ModalBodyComponent, "\u0275cmp", {
    enumerable: true,
    configurable: true,
    writable: true,
    value: i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.15", type: ModalBodyComponent, selector: "lf-modal-body, [lf-modal-body]", host: { properties: { "class.modal-body": "this._hostClassModalBody" } }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true })
});
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0, type: ModalBodyComponent, decorators: [{
            type: Component,
            args: [{
                    selector: 'lf-modal-body, [lf-modal-body]',
                    template: '<ng-content></ng-content>',
                }]
        }], propDecorators: { _hostClassModalBody: [{
                type: HostBinding,
                args: ['class.modal-body']
            }] } });

/**
 * Component that represents the footer of a Bootstrap modal.
 */
class ModalFooterComponent {
    constructor() {
        Object.defineProperty(this, "_hostClassModalFooter", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: true
        });
    }
}
Object.defineProperty(ModalFooterComponent, "\u0275fac", {
    enumerable: true,
    configurable: true,
    writable: true,
    value: i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0, type: ModalFooterComponent, deps: [], target: i0.ɵɵFactoryTarget.Component })
});
Object.defineProperty(ModalFooterComponent, "\u0275cmp", {
    enumerable: true,
    configurable: true,
    writable: true,
    value: i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.15", type: ModalFooterComponent, selector: "lf-modal-footer, [lf-modal-footer]", host: { properties: { "class.modal-footer": "this._hostClassModalFooter" } }, ngImport: i0, template: '<ng-content></ng-content>', isInline: true })
});
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0, type: ModalFooterComponent, decorators: [{
            type: Component,
            args: [{
                    selector: 'lf-modal-footer, [lf-modal-footer]',
                    template: '<ng-content></ng-content>',
                }]
        }], propDecorators: { _hostClassModalFooter: [{
                type: HostBinding,
                args: ['class.modal-footer']
            }] } });

/**
 * Component used to debug information about the state of a value.
 */
class ValueStateComponent extends PathBased {
    constructor(parentPathBasedComponent, lfStorage, lfI18n) {
        super(parentPathBasedComponent, lfStorage, lfI18n);
        /**
         * Whether the application is in production mode.
         */
        Object.defineProperty(this, "inProduction", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: process.env.NODE_ENV === 'production'
        });
        makeObservable(this);
    }
    /**
     * State properties where each "promise" is transformed into an object for
     * easier rendering as a JSON. Also hides the `$mobx` property.
     */
    get stateProperties() {
        const schema = this.relativeStorage.schema();
        const state = this.relativeStorage.getState();
        const value = this.relativeStorage.get();
        return Array.from(Object.keys(state.props)).reduce((obj, prop) => {
            let propValue = null;
            // When the value is `null`, other validations shouldn't be executed
            if (value !== null ||
                !isReservedStateProp(schema, prop) ||
                prop === 'isRequired' ||
                prop === 'validationIssues') {
                propValue = getStateProperty(schema, state, prop);
                if (isPromiseBasedObservable(propValue)) {
                    const res = propValue.value;
                    propValue = {
                        isPromise: true,
                        state: propValue.state,
                        value: res instanceof Error ? `Error(${res.message})` : res,
                    };
                }
            }
            obj[prop] = propValue;
            return obj;
        }, {});
    }
    /**
     * Whether the state properties contain at least one async property.
     */
    get hasAsyncProperties() {
        const props = this.stateProperties;
        return Object.keys(props).some((prop) => {
            const val = props[prop];
            return typeof val === 'object' && val && val.isPromise;
        });
    }
}
Object.defineProperty(ValueStateComponent, "\u0275fac", {
    enumerable: true,
    configurable: true,
    writable: true,
    value: i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0, type: ValueStateComponent, deps: [{ token: PathBased, optional: true }, { token: i1.LfStorage }, { token: i1.LfI18n }], target: i0.ɵɵFactoryTarget.Component })
});
Object.defineProperty(ValueStateComponent, "\u0275cmp", {
    enumerable: true,
    configurable: true,
    writable: true,
    value: i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.15", type: ValueStateComponent, selector: "lf-value-state", usesInheritance: true, ngImport: i0, template: "<!-- Show state properties when not in production -->\n<ng-container *ngIf=\"!inProduction\">\n  <ng-container *mobxAutorun>\n    <ng-container *ngIf=\"relativeStorage.has()\">\n      <!-- Icon/button used to toggle the state properties modal -->\n      <lf-icon class=\"value-state-icon\" icon=\"bug\" (click)=\"stateModal.show()\">\n      </lf-icon>\n\n      <!-- Modal displayed the path's information -->\n      <lf-modal #stateModal size=\"lg\">\n        <lf-modal-header>\n          <code>{{ path }}</code>\n        </lf-modal-header>\n        <lf-modal-body>\n          <h6>Value:</h6>\n          <pre>{{ relativeStorage.get() | json }}</pre>\n          <h6>State properties:</h6>\n          <pre>{{ stateProperties | json }}</pre>\n        </lf-modal-body>\n        <lf-modal-footer *ngIf=\"hasAsyncProperties\">\n          <button\n            lf-button\n            [style]=\"'outline-secondary'\"\n            size=\"sm\"\n            (click)=\"relativeStorage.recomputeStateProperties('.', true)\"\n          >\n            Recompute promises\n          </button>\n        </lf-modal-footer>\n      </lf-modal>\n    </ng-container>\n  </ng-container>\n</ng-container>\n", components: [{ type: IconComponent, selector: "lf-icon", inputs: ["icon", "size", "fixedWidth", "spin", "pulse", "ariaHidden"] }, { type: ModalComponent, selector: "lf-modal", inputs: ["size", "isCentered", "animate", "closeWithEsc", "showBackdrop", "ignoreBackdropClick", "autoFocus"], outputs: ["shown", "hidden"] }, { type: ModalHeaderComponent, selector: "lf-modal-header, [lf-modal-header]", inputs: ["showCloseButton"] }, { type: ModalBodyComponent, selector: "lf-modal-body, [lf-modal-body]" }, { type: ModalFooterComponent, selector: "lf-modal-footer, [lf-modal-footer]" }, { type: ButtonComponent, selector: "button[lf-button], input[lf-button], a[lf-button]", inputs: ["style", "size", "type", "block", "dropdownToggle", "dropdownToggleSplit", "isDisabled", "isActive"] }], directives: [{ type: i7.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { type: i6.MobxAutorunDirective, selector: "[mobxAutorun]", inputs: ["mobxAutorun"] }], pipes: { "json": i7.JsonPipe }, changeDetection: i0.ChangeDetectionStrategy.OnPush })
});
__decorate([
    computed
], ValueStateComponent.prototype, "stateProperties", null);
__decorate([
    computed
], ValueStateComponent.prototype, "hasAsyncProperties", null);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0, type: ValueStateComponent, decorators: [{
            type: Component,
            args: [{
                    selector: 'lf-value-state',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    templateUrl: './value-state.component.html',
                }]
        }], ctorParameters: function () { return [{ type: i1.PathBased, decorators: [{
                    type: Optional
                }, {
                    type: Inject,
                    args: [PathBased]
                }] }, { type: i1.LfStorage }, { type: i1.LfI18n }]; }, propDecorators: { stateProperties: [], hasAsyncProperties: [] } });

/**
 * Component used for selecting a list of options by using inputs of type
 * `checkbox`.
 */
class CheckboxGroupComponent extends SelectionValue {
    constructor(parentPathBasedComponent, lfStorage, lfI18n, lfRouter) {
        super(parentPathBasedComponent, lfStorage, lfI18n, lfRouter);
        /**
         * Whether the list of checkbox inputs should be displayed inline. The
         * component will still display in "block" mode in small screens.
         */
        Object.defineProperty(this, "displayInline", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: false
        });
        makeObservable(this);
    }
    /**
     * Whether to show the "is required" icon on the component.
     */
    get showIsRequired() {
        const minSize = this.relativeStorage.validationMode === ValidationMode.AUTO
            ? this.relativeStorage.getStateProperty('.', 'minSize')
            : this.relativeStorage.schema().minSize;
        return (typeof minSize === 'number' ? minSize : 0) > 0;
    }
    /**
     * Whether a given option is selected.
     * @param option Option to check if it is selected.
     */
    isSelected(option) {
        return this.relativeStorage
            .get()
            .some((el) => comparer.structural(el, option.value));
    }
    /**
     * Action to run whenever a checkbox `input` changes.
     * @param option Option that changed.
     */
    _onOptionChange(option, evt) {
        const checked = !!evt.target.checked;
        const isSelected = this.isSelected(option);
        if (isSelected && !checked) {
            this.relativeStorage.filter('.', (el) => !comparer.structural(el, option.value));
        }
        else if (!isSelected && checked) {
            this.relativeStorage.push('.', option.value);
        }
        this.relativeStorage.setDirty();
    }
    validatePath() {
        const schema = this.relativeStorage.schema();
        if (!isListSchema(schema) || isNullableSchema(schema)) {
            throw pathError(this.path, 'Schema must be of the "list" type and not "nullable"');
        }
    }
}
Object.defineProperty(CheckboxGroupComponent, "\u0275fac", {
    enumerable: true,
    configurable: true,
    writable: true,
    value: i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0, type: CheckboxGroupComponent, deps: [{ token: PathBased, optional: true }, { token: i1.LfStorage }, { token: i1.LfI18n }, { token: LfRouter, optional: true }], target: i0.ɵɵFactoryTarget.Component })
});
Object.defineProperty(CheckboxGroupComponent, "\u0275cmp", {
    enumerable: true,
    configurable: true,
    writable: true,
    value: i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.15", type: CheckboxGroupComponent, selector: "lf-checkbox-group", inputs: { displayInline: "displayInline" }, usesInheritance: true, ngImport: i0, template: "<ng-container *mobxAutorun>\n  <ng-container *ngIf=\"shouldDisplay\">\n    <!-- Label -->\n    <span *ngIf=\"label\" class=\"label\">{{ label }}</span>\n    <lf-help-tooltip *ngIf=\"helpMessage\" [help]=\"helpMessage\"></lf-help-tooltip>\n\n    <!-- Required icon -->\n    <lf-icon\n      class=\"is-required\"\n      icon=\"asterisk\"\n      *ngIf=\"showIsRequired && !isReadOnly\"\n    ></lf-icon>\n\n    <!-- Pending validation -->\n    <div\n      class=\"status pending\"\n      *ngIf=\"relativeStorage.shouldShowPending()\"\n    ></div>\n    <!-- Rejected validation -->\n    <div\n      class=\"status rejected\"\n      *ngIf=\"relativeStorage.shouldShowRejected()\"\n      (click)=\"relativeStorage.recomputeStateProperties()\"\n    >\n      <lf-tooltip [help]=\"retryValidateText\">\n        <lf-icon icon=\"warning\"></lf-icon>\n      </lf-tooltip>\n    </div>\n\n    <!-- (Debug) value state -->\n    <lf-value-state [path]=\"path\"></lf-value-state>\n\n    <!-- Input group -->\n    <div\n      class=\"lf-checkable-group input-group input-group-sm\"\n      [class.is-warning]=\"relativeStorage.shouldShowWarning()\"\n      [class.is-invalid]=\"relativeStorage.shouldShowError()\"\n    >\n      <!-- Code -->\n      <div *ngIf=\"code\" class=\"input-group-prepend\">\n        <div class=\"input-group-text\">{{ code }}</div>\n      </div>\n\n      <!-- Checkboxes -->\n      <div\n        class=\"lf-checkables form-control\"\n        [class.is-warning]=\"relativeStorage.shouldShowWarning()\"\n        [class.is-invalid]=\"relativeStorage.shouldShowError()\"\n        [class.is-readonly]=\"isReadOnly\"\n        [class.display-inline]=\"displayInline\"\n      >\n        <!-- Text for when there are no options -->\n        <div\n          *ngIf=\"optionsStatus !== 'pending' && options.length === 0\"\n          class=\"no-options\"\n        >\n          {{ noOptionsText }}\n        </div>\n\n        <!-- Pending options -->\n        <div *ngIf=\"optionsStatus === 'pending'\" class=\"pending-options\"></div>\n\n        <div\n          class=\"lf-checkable input-group input-group-sm\"\n          *ngFor=\"let option of options; let i = index\"\n        >\n          <!-- Code of each checkbox -->\n          <div *ngIf=\"option.code\" class=\"input-group-prepend\">\n            <div class=\"input-group-text\">{{ option.code }}</div>\n          </div>\n\n          <!-- Checkbox -->\n          <label\n            class=\"form-control custom-control custom-checkbox\"\n            [class.is-warning]=\"relativeStorage.shouldShowWarning()\"\n            [class.is-invalid]=\"relativeStorage.shouldShowError()\"\n            [class.is-readonly]=\"isReadOnly\"\n          >\n            <!-- Actual checkbox -->\n            <!--\n              Note that checkboxes don't support `readonly`, so we use\n              the `disabled` attribute\n            -->\n            <input\n              #focusTarget\n              type=\"checkbox\"\n              class=\"custom-control-input\"\n              [name]=\"path + '[' + i + ']'\"\n              [value]=\"i\"\n              [checked]=\"isSelected(option)\"\n              [disabled]=\"isReadOnly\"\n              (change)=\"_onOptionChange(option, $event)\"\n              (focus)=\"_onFocus($event)\"\n              (blur)=\"_onBlur($event)\"\n            />\n\n            <!-- Checkbox label -->\n            <span class=\"custom-control-label\">\n              {{ option.label }}\n              <lf-help-tooltip\n                *ngIf=\"option.helpMessage\"\n                [help]=\"option.helpMessage\"\n              ></lf-help-tooltip>\n            </span>\n          </label>\n        </div>\n      </div>\n    </div>\n\n    <!-- Legend -->\n    <div *ngIf=\"legend\" class=\"legend\">{{ legend }}</div>\n  </ng-container>\n</ng-container>\n", components: [{ type: HelpTooltipComponent, selector: "lf-help-tooltip", inputs: ["help"] }, { type: IconComponent, selector: "lf-icon", inputs: ["icon", "size", "fixedWidth", "spin", "pulse", "ariaHidden"] }, { type: TooltipComponent, selector: "lf-tooltip", inputs: ["help", "placement", "delay"] }, { type: ValueStateComponent, selector: "lf-value-state" }], directives: [{ type: i6.MobxAutorunDirective, selector: "[mobxAutorun]", inputs: ["mobxAutorun"] }, { type: i7.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { type: i7.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush })
});
__decorate([
    observable
], CheckboxGroupComponent.prototype, "displayInline", void 0);
__decorate([
    computed
], CheckboxGroupComponent.prototype, "showIsRequired", null);
__decorate([
    action
], CheckboxGroupComponent.prototype, "_onOptionChange", null);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0, type: CheckboxGroupComponent, decorators: [{
            type: Component,
            args: [{
                    selector: 'lf-checkbox-group',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    templateUrl: './checkbox-group.component.html',
                }]
        }], ctorParameters: function () { return [{ type: i1.PathBased, decorators: [{
                    type: Optional
                }, {
                    type: Inject,
                    args: [PathBased]
                }] }, { type: i1.LfStorage }, { type: i1.LfI18n }, { type: i1.LfRouter, decorators: [{
                    type: Optional
                }, {
                    type: Inject,
                    args: [LfRouter]
                }] }]; }, propDecorators: { displayInline: [{
                type: Input
            }], showIsRequired: [], _onOptionChange: [] } });

/**
 * LF checkbox component.
 */
class CheckboxComponent extends InlineValue {
    constructor(parentPathBasedComponent, lfStorage, lfI18n, lfRouter) {
        super(parentPathBasedComponent, lfStorage, lfI18n, lfRouter);
        makeObservable(this);
    }
    /**
     * Whether to show the "is required" icon on the component.
     */
    get showIsRequired() {
        if (!this.relativeStorage.isNullable()) {
            const allowedValues = this.relativeStorage.validationMode === ValidationMode.AUTO
                ? this.relativeStorage.getStateProperty('.', 'allowedValues')
                : this.relativeStorage.schema().allowedValues;
            return (isArrayLike(allowedValues) &&
                allowedValues.length === 1 &&
                allowedValues[0] === true);
        }
        return ((this.relativeStorage.validationMode === ValidationMode.AUTO
            ? this.relativeStorage.getStateProperty('.', 'isRequired')
            : this.relativeStorage.schema().isRequired) === true);
    }
    /**
     * Action to run whenever the value of the checkbox changes.
     * @param evt `change` event.
     */
    _onCheckboxChange(evt) {
        this.relativeStorage.set('.', !!evt.target.checked);
        this.relativeStorage.setDirty();
    }
    validatePath() {
        const schema = this.relativeStorage.schema();
        if (!isBooleanSchema(schema)) {
            throw pathError(this.path, 'Schema must be of the "boolean" type');
        }
    }
}
Object.defineProperty(CheckboxComponent, "\u0275fac", {
    enumerable: true,
    configurable: true,
    writable: true,
    value: i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0, type: CheckboxComponent, deps: [{ token: PathBased, optional: true }, { token: i1.LfStorage }, { token: i1.LfI18n }, { token: LfRouter, optional: true }], target: i0.ɵɵFactoryTarget.Component })
});
Object.defineProperty(CheckboxComponent, "\u0275cmp", {
    enumerable: true,
    configurable: true,
    writable: true,
    value: i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.15", type: CheckboxComponent, selector: "lf-checkbox", usesInheritance: true, ngImport: i0, template: "<ng-container *mobxAutorun>\n  <ng-container *ngIf=\"shouldDisplay\">\n    <!-- Required icon -->\n    <lf-icon\n      class=\"is-required\"\n      icon=\"asterisk\"\n      *ngIf=\"showIsRequired && !isReadOnly\"\n    ></lf-icon>\n\n    <!-- Pending validation -->\n    <div\n      class=\"status pending\"\n      *ngIf=\"relativeStorage.shouldShowPending()\"\n    ></div>\n    <!-- Rejected validation -->\n    <div\n      class=\"status rejected\"\n      *ngIf=\"relativeStorage.shouldShowRejected()\"\n      (click)=\"relativeStorage.recomputeStateProperties()\"\n    >\n      <lf-tooltip [help]=\"retryValidateText\">\n        <lf-icon icon=\"warning\"></lf-icon>\n      </lf-tooltip>\n    </div>\n\n    <!-- (Debug) value state -->\n    <lf-value-state [path]=\"path\"></lf-value-state>\n\n    <!-- Input group -->\n    <div\n      class=\"lf-checkable input-group input-group-sm\"\n      [class.is-warning]=\"relativeStorage.shouldShowWarning()\"\n      [class.is-invalid]=\"relativeStorage.shouldShowError()\"\n    >\n      <!-- Code -->\n      <div *ngIf=\"code\" class=\"input-group-prepend\">\n        <div class=\"input-group-text\">{{ code }}</div>\n      </div>\n\n      <!-- Checkbox -->\n      <label\n        class=\"form-control custom-control custom-checkbox\"\n        [class.is-warning]=\"relativeStorage.shouldShowWarning()\"\n        [class.is-invalid]=\"relativeStorage.shouldShowError()\"\n        [class.is-readonly]=\"isReadOnly\"\n      >\n        <!-- Actual checkbox -->\n        <!--\n          Note that checkboxes don't support `readonly`, so we use the\n          `disabled` attribute\n        -->\n        <input\n          #focusTarget\n          type=\"checkbox\"\n          class=\"custom-control-input\"\n          [name]=\"path\"\n          [checked]=\"relativeStorage.get()\"\n          [indeterminate]=\"relativeStorage.get() === null\"\n          (change)=\"_onCheckboxChange($event)\"\n          [disabled]=\"isReadOnly\"\n          (focus)=\"_onFocus($event)\"\n          (blur)=\"_onBlur($event)\"\n        />\n\n        <!-- Label -->\n        <span class=\"custom-control-label\">\n          <span *ngIf=\"label\" class=\"label\">{{ label }}</span>\n          <lf-help-tooltip\n            *ngIf=\"helpMessage\"\n            [help]=\"helpMessage\"\n          ></lf-help-tooltip>\n        </span>\n      </label>\n    </div>\n\n    <!-- Legend -->\n    <div *ngIf=\"legend\" class=\"legend\">{{ legend }}</div>\n  </ng-container>\n</ng-container>\n", components: [{ type: IconComponent, selector: "lf-icon", inputs: ["icon", "size", "fixedWidth", "spin", "pulse", "ariaHidden"] }, { type: TooltipComponent, selector: "lf-tooltip", inputs: ["help", "placement", "delay"] }, { type: ValueStateComponent, selector: "lf-value-state" }, { type: HelpTooltipComponent, selector: "lf-help-tooltip", inputs: ["help"] }], directives: [{ type: i6.MobxAutorunDirective, selector: "[mobxAutorun]", inputs: ["mobxAutorun"] }, { type: i7.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush })
});
__decorate([
    computed
], CheckboxComponent.prototype, "showIsRequired", null);
__decorate([
    action
], CheckboxComponent.prototype, "_onCheckboxChange", null);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0, type: CheckboxComponent, decorators: [{
            type: Component,
            args: [{
                    selector: 'lf-checkbox',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    templateUrl: './checkbox.component.html',
                }]
        }], ctorParameters: function () { return [{ type: i1.PathBased, decorators: [{
                    type: Optional
                }, {
                    type: Inject,
                    args: [PathBased]
                }] }, { type: i1.LfStorage }, { type: i1.LfI18n }, { type: i1.LfRouter, decorators: [{
                    type: Optional
                }, {
                    type: Inject,
                    args: [LfRouter]
                }] }]; }, propDecorators: { showIsRequired: [], _onCheckboxChange: [] } });

/**
 * Converts a date representing a certain day in local time to a date that
 * represents that same day in UTC. Used to fix:
 * https://github.com/valor-software/ngx-bootstrap/issues/3609
 * @param date Date to convert.
 * @returns Date in UTC.
 */
function localDateToUTC(date) {
    return new Date(Date.UTC(date.getFullYear(), date.getMonth(), date.getDate()));
}
/**
 * Whether the provided value is an instance of `Date`.
 * @param value Value to check if it is a date.
 * @returns Whether the provided value is a date.
 */
function isDate(value) {
    return (value instanceof Date ||
        (typeof value === 'object' &&
            Object.prototype.toString.call(value) === '[object Date]'));
}

/**
 * Automatically change `ngx-bootstrap` locale based on current language.
 */
class BsLocaleChanger {
    constructor(bsLocaleService, lfI18n) {
        Object.defineProperty(this, "bsLocaleService", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: bsLocaleService
        });
        Object.defineProperty(this, "lfI18n", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: lfI18n
        });
        observe(this.lfI18n, 'currentLanguage', () => {
            this.bsLocaleService.use(this.lfI18n.get(I18N_BS_LOCALE_KEY) || 'en');
        }, true);
    }
}
Object.defineProperty(BsLocaleChanger, "\u0275fac", {
    enumerable: true,
    configurable: true,
    writable: true,
    value: i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0, type: BsLocaleChanger, deps: [{ token: i9.BsLocaleService }, { token: i1.LfI18n }], target: i0.ɵɵFactoryTarget.Injectable })
});
Object.defineProperty(BsLocaleChanger, "\u0275prov", {
    enumerable: true,
    configurable: true,
    writable: true,
    value: i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0, type: BsLocaleChanger, providedIn: 'root' })
});
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0, type: BsLocaleChanger, decorators: [{
            type: Injectable,
            args: [{ providedIn: 'root' }]
        }], ctorParameters: function () { return [{ type: i9.BsLocaleService }, { type: i1.LfI18n }]; } });

/**
 * LF date-range component.
 */
class DateRangeComponent extends InlineValue {
    constructor(parentPathBasedComponent, lfStorage, lfI18n, lfRouter, _bsLocaleChanger) {
        super(parentPathBasedComponent, lfStorage, lfI18n, lfRouter);
        /**
         * Date-range picker directive.
         */
        Object.defineProperty(this, "_bsDateRangePicker", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        // Disposers
        Object.defineProperty(this, "disposeBsConfigObserve", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        makeObservable(this);
    }
    /**
     * Format for a single date.
     */
    get dateFormat() {
        return this.translate(I18N_DATE_FORMAT_KEY);
    }
    /**
     * Separator used between the dates in the date-range.
     */
    get separator() {
        return this.translate(I18N_DATE_RANGE_SEPARATOR_KEY) || '-';
    }
    /**
     * Placeholder of the `input` field.
     */
    get placeholder() {
        const datePlaceholder = this.translate(I18N_DATE_PLACEHOLDER_KEY);
        return datePlaceholder
            ? `${datePlaceholder}${this.separator}${datePlaceholder}`
            : '';
    }
    /**
     * Whether to show the "is required" icon on the component.
     */
    get showIsRequired() {
        return ((this.relativeStorage.validationMode === ValidationMode.AUTO
            ? this.relativeStorage.getStateProperty('.', 'isRequired')
            : this.relativeStorage.schema().isRequired) === true);
    }
    /**
     * Minimum allowed date.
     */
    get minDate() {
        const minDate = this.relativeStorage.validationMode === ValidationMode.AUTO
            ? this.relativeStorage.getStateProperty('.', 'minDate')
            : this.relativeStorage.schema().minDate;
        return isDate(minDate) ? minDate : undefined;
    }
    /**
     * Maximum allowed date.
     */
    get maxDate() {
        const maxDate = this.relativeStorage.validationMode === ValidationMode.AUTO
            ? this.relativeStorage.getStateProperty('.', 'maxDate')
            : this.relativeStorage.schema().maxDate;
        return isDate(maxDate) ? maxDate : undefined;
    }
    /**
     * Configuration to use by Bootstrap datepicker.
     */
    get bsConfig() {
        return {
            containerClass: 'theme-default',
            rangeInputFormat: this.dateFormat,
            rangeSeparator: this.separator,
        };
    }
    ngOnInit() {
        super.ngOnInit();
        this.disposeBsConfigObserve = observe(this, 'bsConfig', () => {
            asap(() => {
                this._bsDateRangePicker.setConfig();
                this._bsDateRangePicker.bsValueChange.emit(this.relativeStorage.has() ? this.relativeStorage.get() : null);
            });
        }, true);
    }
    ngOnDestroy() {
        super.ngOnDestroy();
        this.disposeBsConfigObserve && this.disposeBsConfigObserve();
    }
    /**
     * Action to run whenever the date range is modified via the Bootstrap
     * datepicker UI.
     * @param dateRange Tuple representing the range.
     */
    _onDateRangePickerChange(dateRange) {
        // XXX: We convert the dates to UTC due to:
        // https://github.com/valor-software/ngx-bootstrap/issues/3609
        const value = dateRange && dateRange[0] && dateRange[1]
            ? [localDateToUTC(dateRange[0]), localDateToUTC(dateRange[1])]
            : null;
        // FIXME: This function is being called as soon as the component loads, thus
        // the comparison against the current date range (which shouldn't be
        // needed).
        const currentValue = this.relativeStorage.get();
        if (!comparer.structural(currentValue, value)) {
            this.relativeStorage.set('.', value);
            this.relativeStorage.setDirty('.', true);
        }
    }
    _onFocus(evt) {
        super._onFocus(evt);
        this._bsDateRangePicker.show();
    }
    /**
     * Set touched when the date picker is hidden rather than on blur (it is
     * possible to change the value via the popup without actually focusing the
     * input; besides, otherwise the input may go invalid when the user selects
     * the first date of the range, but before the second).
     */
    _onDateRangePickerHidden() {
        if (!this.relativeStorage.isComputed()) {
            this.relativeStorage.setTouched('.', true);
        }
    }
    validatePath() {
        const schema = this.relativeStorage.schema();
        if (!isDateRangeSchema(schema) || !isNullableSchema(schema)) {
            throw pathError(this.path, 'Schema must be of the "date-range" type and "nullable"');
        }
    }
}
Object.defineProperty(DateRangeComponent, "\u0275fac", {
    enumerable: true,
    configurable: true,
    writable: true,
    value: i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0, type: DateRangeComponent, deps: [{ token: PathBased, optional: true }, { token: i1.LfStorage }, { token: i1.LfI18n }, { token: LfRouter, optional: true }, { token: BsLocaleChanger }], target: i0.ɵɵFactoryTarget.Component })
});
Object.defineProperty(DateRangeComponent, "\u0275cmp", {
    enumerable: true,
    configurable: true,
    writable: true,
    value: i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.15", type: DateRangeComponent, selector: "lf-date-range", viewQueries: [{ propertyName: "_bsDateRangePicker", first: true, predicate: ["drp"], descendants: true }], usesInheritance: true, ngImport: i0, template: "<ng-container *mobxAutorun>\n  <ng-container *ngIf=\"shouldDisplay\">\n    <!-- Label -->\n    <span *ngIf=\"label\" class=\"label\">{{ label }}</span>\n    <lf-help-tooltip *ngIf=\"helpMessage\" [help]=\"helpMessage\"></lf-help-tooltip>\n\n    <!-- Required icon -->\n    <lf-icon\n      class=\"is-required\"\n      icon=\"asterisk\"\n      *ngIf=\"showIsRequired && !isReadOnly\"\n    ></lf-icon>\n\n    <!-- Pending validation -->\n    <div\n      class=\"status pending\"\n      *ngIf=\"relativeStorage.shouldShowPending()\"\n    ></div>\n    <!-- Rejected validation -->\n    <div\n      class=\"status rejected\"\n      *ngIf=\"relativeStorage.shouldShowRejected()\"\n      (click)=\"relativeStorage.recomputeStateProperties()\"\n    >\n      <lf-tooltip [help]=\"retryValidateText\">\n        <lf-icon icon=\"warning\"></lf-icon>\n      </lf-tooltip>\n    </div>\n\n    <!-- (Debug) value state -->\n    <lf-value-state [path]=\"path\"></lf-value-state>\n\n    <!-- Input group -->\n    <div\n      class=\"input-group input-group-sm\"\n      [class.is-warning]=\"relativeStorage.shouldShowWarning()\"\n      [class.is-invalid]=\"relativeStorage.shouldShowError()\"\n    >\n      <!-- Code -->\n      <div *ngIf=\"code\" class=\"input-group-prepend\">\n        <div class=\"input-group-text\">{{ code }}</div>\n      </div>\n\n      <!-- Input -->\n      <!--\n        We disable the directive's `triggers` since it doesn't work well on\n        focus (using \"focus\" as a trigger will cause the menu to disappear if it\n        was already shown since the trigger calls `toggle`). Instead we manually\n        call `show` on focus.\n      -->\n      <input\n        #focusTarget\n        bsDaterangepicker\n        #drp=\"bsDaterangepicker\"\n        triggers=\"\"\n        [bsConfig]=\"bsConfig\"\n        [bsValue]=\"relativeStorage.get()\"\n        [isDisabled]=\"isReadOnly\"\n        (bsValueChange)=\"_onDateRangePickerChange($event)\"\n        (onHidden)=\"_onDateRangePickerHidden()\"\n        type=\"text\"\n        class=\"form-control date-input text-right\"\n        [class.is-warning]=\"relativeStorage.shouldShowWarning()\"\n        [class.is-invalid]=\"relativeStorage.shouldShowError()\"\n        [class.is-readonly]=\"isReadOnly\"\n        [name]=\"path\"\n        [minDate]=\"minDate\"\n        [maxDate]=\"maxDate\"\n        [placeholder]=\"placeholder\"\n        [readonly]=\"isReadOnly\"\n        autocomplete=\"off\"\n        (focus)=\"_onFocus($event)\"\n        (blur)=\"_onBlur($event, false)\"\n      />\n\n      <!-- Date icon -->\n      <div class=\"input-group-append\" (click)=\"drp.toggle()\">\n        <div class=\"input-group-text\">\n          <lf-icon icon=\"calendar\"></lf-icon>\n        </div>\n      </div>\n    </div>\n\n    <!-- Legend -->\n    <div *ngIf=\"legend\" class=\"legend\">{{ legend }}</div>\n  </ng-container>\n</ng-container>\n", components: [{ type: HelpTooltipComponent, selector: "lf-help-tooltip", inputs: ["help"] }, { type: IconComponent, selector: "lf-icon", inputs: ["icon", "size", "fixedWidth", "spin", "pulse", "ariaHidden"] }, { type: TooltipComponent, selector: "lf-tooltip", inputs: ["help", "placement", "delay"] }, { type: ValueStateComponent, selector: "lf-value-state" }], directives: [{ type: i6.MobxAutorunDirective, selector: "[mobxAutorun]", inputs: ["mobxAutorun"] }, { type: i7.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { type: i9.BsDaterangepickerInputDirective, selector: "input[bsDaterangepicker]" }, { type: i9.BsDaterangepickerDirective, selector: "[bsDaterangepicker]", inputs: ["placement", "triggers", "outsideClick", "container", "outsideEsc", "isDisabled", "isOpen", "bsValue", "bsConfig", "minDate", "maxDate", "dateCustomClasses", "daysDisabled", "datesDisabled", "datesEnabled"], outputs: ["bsValueChange", "onShown", "onHidden"], exportAs: ["bsDaterangepicker"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush })
});
__decorate([
    computed
], DateRangeComponent.prototype, "dateFormat", null);
__decorate([
    computed
], DateRangeComponent.prototype, "separator", null);
__decorate([
    computed
], DateRangeComponent.prototype, "placeholder", null);
__decorate([
    computed
], DateRangeComponent.prototype, "showIsRequired", null);
__decorate([
    computed
], DateRangeComponent.prototype, "minDate", null);
__decorate([
    computed
], DateRangeComponent.prototype, "maxDate", null);
__decorate([
    computed
], DateRangeComponent.prototype, "bsConfig", null);
__decorate([
    action
], DateRangeComponent.prototype, "_onDateRangePickerChange", null);
__decorate([
    action
], DateRangeComponent.prototype, "_onDateRangePickerHidden", null);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0, type: DateRangeComponent, decorators: [{
            type: Component,
            args: [{
                    selector: 'lf-date-range',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    templateUrl: './date-range.component.html',
                }]
        }], ctorParameters: function () { return [{ type: i1.PathBased, decorators: [{
                    type: Optional
                }, {
                    type: Inject,
                    args: [PathBased]
                }] }, { type: i1.LfStorage }, { type: i1.LfI18n }, { type: i1.LfRouter, decorators: [{
                    type: Optional
                }, {
                    type: Inject,
                    args: [LfRouter]
                }] }, { type: BsLocaleChanger }]; }, propDecorators: { _bsDateRangePicker: [{
                type: ViewChild,
                args: ['drp']
            }], dateFormat: [], separator: [], placeholder: [], showIsRequired: [], minDate: [], maxDate: [], bsConfig: [], _onDateRangePickerChange: [], _onDateRangePickerHidden: [] } });

/**
 * LF date component.
 */
class DateComponent extends InlineValue {
    constructor(parentPathBasedComponent, lfStorage, lfI18n, lfRouter, _bsLocaleChanger) {
        super(parentPathBasedComponent, lfStorage, lfI18n, lfRouter);
        /**
         * Datepicker directive.
         */
        Object.defineProperty(this, "_bsDatePicker", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        // Disposers
        Object.defineProperty(this, "disposeBsConfigObserve", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        makeObservable(this);
    }
    /**
     * Format of the date.
     */
    get dateFormat() {
        return this.translate(I18N_DATE_FORMAT_KEY) || 'YYYY-MM-DD';
    }
    /**
     * Placeholder of the `input` field.
     */
    get placeholder() {
        return this.translate(I18N_DATE_PLACEHOLDER_KEY) || '';
    }
    /**
     * Whether to show the "is required" icon on the component.
     */
    get showIsRequired() {
        return ((this.relativeStorage.validationMode === ValidationMode.AUTO
            ? this.relativeStorage.getStateProperty('.', 'isRequired')
            : this.relativeStorage.schema().isRequired) === true);
    }
    /**
     * Minimum allowed date.
     */
    get minDate() {
        const minDate = this.relativeStorage.validationMode === ValidationMode.AUTO
            ? this.relativeStorage.getStateProperty('.', 'minDate')
            : this.relativeStorage.schema().minDate;
        return isDate(minDate) ? minDate : undefined;
    }
    /**
     * Maximum allowed date.
     */
    get maxDate() {
        const maxDate = this.relativeStorage.validationMode === ValidationMode.AUTO
            ? this.relativeStorage.getStateProperty('.', 'maxDate')
            : this.relativeStorage.schema().maxDate;
        return isDate(maxDate) ? maxDate : undefined;
    }
    /**
     * Config for the `BsDatepicker`.
     */
    get bsConfig() {
        return {
            containerClass: 'theme-default',
            dateInputFormat: this.dateFormat,
        };
    }
    ngOnInit() {
        super.ngOnInit();
        this.disposeBsConfigObserve = observe(this, 'bsConfig', () => {
            asap(() => {
                this._bsDatePicker.setConfig();
                this._bsDatePicker.bsValueChange.emit(this.relativeStorage.has() ? this.relativeStorage.get() : null);
            });
        }, true);
    }
    ngOnDestroy() {
        super.ngOnDestroy();
        this.disposeBsConfigObserve && this.disposeBsConfigObserve();
    }
    /**
     * Action to run whenever the date `input` changes.
     * @param date Date to set.
     */
    _onDatePickerChange(date) {
        // XXX: We convert the date to UTC due to:
        // https://github.com/valor-software/ngx-bootstrap/issues/3609
        date = !date || isNaN(+date) ? null : localDateToUTC(date);
        // FIXME: This function is being called as soon as the component loads, thus
        // the comparison against the current date (which shouldn't be needed).
        const currentDate = this.relativeStorage.get();
        if (!comparer.structural(currentDate, date)) {
            this.relativeStorage.set('.', date);
            this.relativeStorage.setDirty();
        }
    }
    _onFocus(evt) {
        super._onFocus(evt);
        this._bsDatePicker.show();
    }
    /**
     * Set touched when the date picker is hidden rather than on blur (it is
     * possible to change the value via the popup without actually focusing the
     * input).
     */
    _onDatePickerHidden() {
        if (!this.relativeStorage.isComputed()) {
            this.relativeStorage.setTouched();
        }
    }
    validatePath() {
        const schema = this.relativeStorage.schema();
        if (!isDateSchema(schema) || !isNullableSchema(schema)) {
            throw pathError(this.path, 'Schema must be of the "date" type and "nullable"');
        }
    }
}
Object.defineProperty(DateComponent, "\u0275fac", {
    enumerable: true,
    configurable: true,
    writable: true,
    value: i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0, type: DateComponent, deps: [{ token: PathBased, optional: true }, { token: i1.LfStorage }, { token: i1.LfI18n }, { token: LfRouter, optional: true }, { token: BsLocaleChanger }], target: i0.ɵɵFactoryTarget.Component })
});
Object.defineProperty(DateComponent, "\u0275cmp", {
    enumerable: true,
    configurable: true,
    writable: true,
    value: i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.15", type: DateComponent, selector: "lf-date", viewQueries: [{ propertyName: "_bsDatePicker", first: true, predicate: ["dp"], descendants: true }], usesInheritance: true, ngImport: i0, template: "<ng-container *mobxAutorun>\n  <ng-container *ngIf=\"shouldDisplay\">\n    <!-- Label -->\n    <span *ngIf=\"label\" class=\"label\">{{ label }}</span>\n    <lf-help-tooltip *ngIf=\"helpMessage\" [help]=\"helpMessage\"></lf-help-tooltip>\n\n    <!-- Required icon -->\n    <lf-icon\n      class=\"is-required\"\n      icon=\"asterisk\"\n      *ngIf=\"showIsRequired && !isReadOnly\"\n    ></lf-icon>\n\n    <!-- Pending validation -->\n    <div\n      class=\"status pending\"\n      *ngIf=\"relativeStorage.shouldShowPending()\"\n    ></div>\n    <!-- Rejected validation -->\n    <div\n      class=\"status rejected\"\n      *ngIf=\"relativeStorage.shouldShowRejected()\"\n      (click)=\"relativeStorage.recomputeStateProperties()\"\n    >\n      <lf-tooltip [help]=\"retryValidateText\">\n        <lf-icon icon=\"warning\"></lf-icon>\n      </lf-tooltip>\n    </div>\n\n    <!-- (Debug) value state -->\n    <lf-value-state [path]=\"path\"></lf-value-state>\n\n    <!-- Input group -->\n    <div\n      class=\"input-group input-group-sm\"\n      [class.is-warning]=\"relativeStorage.shouldShowWarning()\"\n      [class.is-invalid]=\"relativeStorage.shouldShowError()\"\n    >\n      <!-- Code -->\n      <div *ngIf=\"code\" class=\"input-group-prepend\">\n        <div class=\"input-group-text\">{{ code }}</div>\n      </div>\n\n      <!-- Input -->\n      <!--\n        We disable the directive's `triggers` since it doesn't work well on\n        focus (using \"focus\" as a trigger will cause the menu to disappear if it\n        was already shown since the trigger calls `toggle`). Instead we manually\n        call `show` on focus.\n      -->\n      <input\n        #focusTarget\n        bsDatepicker\n        #dp=\"bsDatepicker\"\n        triggers=\"\"\n        [bsConfig]=\"bsConfig\"\n        [bsValue]=\"relativeStorage.get()\"\n        [isDisabled]=\"isReadOnly\"\n        (bsValueChange)=\"_onDatePickerChange($event)\"\n        (onHidden)=\"_onDatePickerHidden()\"\n        type=\"text\"\n        class=\"form-control date-input text-right\"\n        [class.is-warning]=\"relativeStorage.shouldShowWarning()\"\n        [class.is-invalid]=\"relativeStorage.shouldShowError()\"\n        [class.is-readonly]=\"isReadOnly\"\n        [name]=\"path\"\n        [minDate]=\"minDate\"\n        [maxDate]=\"maxDate\"\n        [placeholder]=\"placeholder\"\n        [readonly]=\"isReadOnly\"\n        autocomplete=\"off\"\n        (focus)=\"_onFocus($event)\"\n        (blur)=\"_onBlur($event, false)\"\n      />\n\n      <!-- Date icon -->\n      <div class=\"input-group-append\" (click)=\"dp.toggle()\">\n        <div class=\"input-group-text\"><lf-icon icon=\"calendar\"></lf-icon></div>\n      </div>\n    </div>\n\n    <!-- Legend -->\n    <div *ngIf=\"legend\" class=\"legend\">{{ legend }}</div>\n  </ng-container>\n</ng-container>\n", components: [{ type: HelpTooltipComponent, selector: "lf-help-tooltip", inputs: ["help"] }, { type: IconComponent, selector: "lf-icon", inputs: ["icon", "size", "fixedWidth", "spin", "pulse", "ariaHidden"] }, { type: TooltipComponent, selector: "lf-tooltip", inputs: ["help", "placement", "delay"] }, { type: ValueStateComponent, selector: "lf-value-state" }], directives: [{ type: i6.MobxAutorunDirective, selector: "[mobxAutorun]", inputs: ["mobxAutorun"] }, { type: i7.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { type: i9.BsDatepickerInputDirective, selector: "input[bsDatepicker]" }, { type: i9.BsDatepickerDirective, selector: "[bsDatepicker]", inputs: ["placement", "triggers", "outsideClick", "container", "outsideEsc", "isDisabled", "isOpen", "bsValue", "minDate", "maxDate", "minMode", "daysDisabled", "datesDisabled", "datesEnabled", "dateCustomClasses", "dateTooltipTexts", "bsConfig"], outputs: ["bsValueChange", "onShown", "onHidden"], exportAs: ["bsDatepicker"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush })
});
__decorate([
    computed
], DateComponent.prototype, "dateFormat", null);
__decorate([
    computed
], DateComponent.prototype, "placeholder", null);
__decorate([
    computed
], DateComponent.prototype, "showIsRequired", null);
__decorate([
    computed
], DateComponent.prototype, "minDate", null);
__decorate([
    computed
], DateComponent.prototype, "maxDate", null);
__decorate([
    computed
], DateComponent.prototype, "bsConfig", null);
__decorate([
    action
], DateComponent.prototype, "_onDatePickerChange", null);
__decorate([
    action
], DateComponent.prototype, "_onDatePickerHidden", null);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0, type: DateComponent, decorators: [{
            type: Component,
            args: [{
                    selector: 'lf-date',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    templateUrl: './date.component.html',
                }]
        }], ctorParameters: function () { return [{ type: i1.PathBased, decorators: [{
                    type: Optional
                }, {
                    type: Inject,
                    args: [PathBased]
                }] }, { type: i1.LfStorage }, { type: i1.LfI18n }, { type: i1.LfRouter, decorators: [{
                    type: Optional
                }, {
                    type: Inject,
                    args: [LfRouter]
                }] }, { type: BsLocaleChanger }]; }, propDecorators: { _bsDatePicker: [{
                type: ViewChild,
                args: ['dp']
            }], dateFormat: [], placeholder: [], showIsRequired: [], minDate: [], maxDate: [], bsConfig: [], _onDatePickerChange: [], _onDatePickerHidden: [] } });

/**
 * Component used for selecting files.
 */
class FileComponent extends InlineValue {
    constructor(parentPathBasedComponent, lfStorage, lfI18n, lfRouter, lfFileHolder) {
        super(parentPathBasedComponent, lfStorage, lfI18n, lfRouter);
        Object.defineProperty(this, "lfFileHolder", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: lfFileHolder
        });
        /**
         * One or more unique file type specifiers describing file types to allow.
         */
        Object.defineProperty(this, "accept", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: ''
        });
        /**
         * Minimum allowed file size in bytes.
         */
        Object.defineProperty(this, "minSize", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        /**
         * Maximum allowed file size in bytes.
         */
        Object.defineProperty(this, "maxSize", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        // Unique id per component, used for the label to target the file input
        Object.defineProperty(this, "_id", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: `lf-file-input-${FileComponent.idCounter++}`
        });
        Object.defineProperty(this, "_selectedFile", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: null
        });
        // Disposers
        Object.defineProperty(this, "disposeObserveValue", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        Object.defineProperty(this, "disposeOnMinMaxSizeChange", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        makeObservable(this);
    }
    /**
     * "Choose file" placeholder text.
     */
    get choosePlaceholder() {
        return this.translate(I18N_FILE_CHOOSE_PLACEHOLDER_KEY);
    }
    /**
     * "Browse" text.
     */
    get browseText() {
        return this.translate(I18N_FILE_BROWSE_TEXT_KEY);
    }
    /**
     * "No file chosen" text.
     */
    get noneChosenText() {
        return this.translate(I18N_FILE_NONE_CHOSEN_KEY);
    }
    /**
     * "Clear" button tooltip.
     */
    get clearButtonTooltip() {
        return this.translate(I18N_FILE_CLEAR_BUTTON_TOOLTIP_KEY);
    }
    /**
     * Whether to show the "is required" icon on the component.
     */
    get showIsRequired() {
        return ((this.relativeStorage.validationMode === ValidationMode.AUTO
            ? this.relativeStorage.getStateProperty('.', 'isRequired')
            : this.relativeStorage.schema().isRequired) === true);
    }
    get value() {
        return this.relativeStorage.has() ? this.relativeStorage.get() : undefined;
    }
    ngAfterViewInit() {
        super.ngAfterViewInit();
        // Update the selected file when the value changes. If the file is in the
        // file holder then we switch to it, otherwise we set the file as `null`,
        // since it doesn't exist
        this.disposeObserveValue = observe(this, 'value', ({ newValue }) => {
            const file = this.lfFileHolder.get(this.relativeStorage.currentPath);
            if (file && newValue === file.name) {
                this._selectedFile = file;
            }
            else {
                this.setFile(null);
            }
        }, true);
        // Remove selected file when a file was selected but the `minSize`/`maxSize`
        // changed and made the selected file invalid
        this.disposeOnMinMaxSizeChange = reaction(() => [this.value, this.minSize, this.maxSize], () => {
            const file = this.lfFileHolder.get(this.relativeStorage.currentPath);
            if (file && !this.hasValidSize(file)) {
                this.setFile(null);
            }
        }, { name: 'fileReactionOnMinMaxSizeChange' });
    }
    ngOnDestroy() {
        this.disposeObserveValue && this.disposeObserveValue();
        this.disposeOnMinMaxSizeChange && this.disposeOnMinMaxSizeChange();
        super.ngOnDestroy();
    }
    /**
     * Action to run on every `input` event of the file input.
     * @param evt `input` event.
     */
    _onInput(evt) {
        this.setFile(evt.target.files[0] || null);
        this.relativeStorage.setDirty();
    }
    _onClickClear(evt) {
        evt.preventDefault();
        this.setFile(null);
    }
    validatePath() {
        const schema = this.relativeStorage.schema();
        if (!isStringSchema(schema) || !isNullableSchema(schema)) {
            throw pathError(this.path, 'Schema must be of the "string" type and "nullable"');
        }
    }
    setFile(file) {
        const fileInput = this.targets.first.nativeElement;
        // Disallow files with wrong sizes
        if (!this.hasValidSize(file)) {
            // Access file input via `#focusTarget`
            fileInput.value = '';
            file = null;
        }
        this._selectedFile = file;
        // Set file in file holder service
        if (file != null) {
            this.lfFileHolder.set(this.relativeStorage.currentPath, file);
        }
        else {
            this.lfFileHolder.delete(this.relativeStorage.currentPath);
            fileInput.value = '';
        }
        this.relativeStorage.set('.', (file === null || file === void 0 ? void 0 : file.name) || null);
    }
    hasValidSize(file) {
        var _a, _b;
        return (!file ||
            (file.size >= ((_a = this.minSize) !== null && _a !== void 0 ? _a : 0) &&
                file.size <= ((_b = this.maxSize) !== null && _b !== void 0 ? _b : Infinity)));
    }
}
Object.defineProperty(FileComponent, "idCounter", {
    enumerable: true,
    configurable: true,
    writable: true,
    value: 0
});
Object.defineProperty(FileComponent, "\u0275fac", {
    enumerable: true,
    configurable: true,
    writable: true,
    value: i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0, type: FileComponent, deps: [{ token: PathBased, optional: true }, { token: i1.LfStorage }, { token: i1.LfI18n }, { token: LfRouter, optional: true }, { token: i1.LfFileHolder }], target: i0.ɵɵFactoryTarget.Component })
});
Object.defineProperty(FileComponent, "\u0275cmp", {
    enumerable: true,
    configurable: true,
    writable: true,
    value: i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.15", type: FileComponent, selector: "lf-file", inputs: { accept: "accept", minSize: "minSize", maxSize: "maxSize" }, usesInheritance: true, ngImport: i0, template: "<ng-container *mobxAutorun>\n  <ng-container *ngIf=\"shouldDisplay\">\n    <!-- Label -->\n    <span *ngIf=\"label\" class=\"label\">{{ label }}</span>\n    <lf-help-tooltip *ngIf=\"helpMessage\" [help]=\"helpMessage\"></lf-help-tooltip>\n\n    <!-- Required icon -->\n    <lf-icon\n      class=\"is-required\"\n      icon=\"asterisk\"\n      *ngIf=\"showIsRequired && !isReadOnly\"\n    ></lf-icon>\n\n    <!-- Pending validation -->\n    <div\n      class=\"status pending\"\n      *ngIf=\"relativeStorage.shouldShowPending()\"\n    ></div>\n    <!-- Rejected validation -->\n    <div\n      class=\"status rejected\"\n      *ngIf=\"relativeStorage.shouldShowRejected()\"\n      (click)=\"relativeStorage.recomputeStateProperties()\"\n    >\n      <lf-tooltip [help]=\"retryValidateText\">\n        <lf-icon icon=\"warning\"></lf-icon>\n      </lf-tooltip>\n    </div>\n\n    <!-- (Debug) value state -->\n    <lf-value-state [path]=\"path\"></lf-value-state>\n\n    <!-- Input group -->\n    <div\n      class=\"input-group input-group-sm\"\n      [class.is-warning]=\"relativeStorage.shouldShowWarning()\"\n      [class.is-invalid]=\"relativeStorage.shouldShowError()\"\n    >\n      <!-- Code -->\n      <div *ngIf=\"code\" class=\"input-group-prepend\">\n        <div class=\"input-group-text\">{{ code }}</div>\n      </div>\n\n      <!-- File input -->\n      <div class=\"custom-file\" [title]=\"_selectedFile?.name || noneChosenText\">\n        <input\n          #focusTarget\n          type=\"file\"\n          [accept]=\"accept\"\n          [id]=\"_id\"\n          class=\"custom-file-input\"\n          [attr.aria-describedby]=\"_id\"\n          [class.is-warning]=\"relativeStorage.shouldShowWarning()\"\n          [class.is-invalid]=\"relativeStorage.shouldShowError()\"\n          [class.is-readonly]=\"isReadOnly\"\n          [name]=\"path\"\n          [disabled]=\"isReadOnly\"\n          (input)=\"_onInput($event)\"\n          (focus)=\"_onFocus($event)\"\n          (blur)=\"_onBlur($event)\"\n        />\n        <label\n          class=\"custom-file-label\"\n          [attr.for]=\"_id\"\n          [attr.data-browse]=\"browseText\"\n        >\n          <span\n            class=\"custom-file-label-content\"\n            [class.placeholder]=\"!_selectedFile\"\n            >{{ _selectedFile?.name || choosePlaceholder }}</span\n          >\n\n          <!-- Clear button -->\n          <button\n            *ngIf=\"_selectedFile && !isReadOnly\"\n            type=\"button\"\n            class=\"close\"\n            [title]=\"clearButtonTooltip\"\n            [attr.aria-label]=\"clearButtonTooltip\"\n            (click)=\"_onClickClear($event)\"\n          >\n            <span aria-hidden=\"true\">\u00D7</span>\n          </button>\n\n          <!-- Browse text -->\n          <div class=\"browse-text\">{{ browseText }}</div>\n        </label>\n      </div>\n    </div>\n\n    <!-- Legend -->\n    <div *ngIf=\"legend\" class=\"legend\">{{ legend }}</div>\n  </ng-container>\n</ng-container>\n", components: [{ type: HelpTooltipComponent, selector: "lf-help-tooltip", inputs: ["help"] }, { type: IconComponent, selector: "lf-icon", inputs: ["icon", "size", "fixedWidth", "spin", "pulse", "ariaHidden"] }, { type: TooltipComponent, selector: "lf-tooltip", inputs: ["help", "placement", "delay"] }, { type: ValueStateComponent, selector: "lf-value-state" }], directives: [{ type: i6.MobxAutorunDirective, selector: "[mobxAutorun]", inputs: ["mobxAutorun"] }, { type: i7.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush })
});
__decorate([
    observable
], FileComponent.prototype, "accept", void 0);
__decorate([
    observable
], FileComponent.prototype, "minSize", void 0);
__decorate([
    observable
], FileComponent.prototype, "maxSize", void 0);
__decorate([
    observable
], FileComponent.prototype, "_selectedFile", void 0);
__decorate([
    computed
], FileComponent.prototype, "choosePlaceholder", null);
__decorate([
    computed
], FileComponent.prototype, "browseText", null);
__decorate([
    computed
], FileComponent.prototype, "noneChosenText", null);
__decorate([
    computed
], FileComponent.prototype, "clearButtonTooltip", null);
__decorate([
    computed
], FileComponent.prototype, "showIsRequired", null);
__decorate([
    computed
], FileComponent.prototype, "value", null);
__decorate([
    action
], FileComponent.prototype, "_onInput", null);
__decorate([
    action
], FileComponent.prototype, "setFile", null);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0, type: FileComponent, decorators: [{
            type: Component,
            args: [{
                    selector: 'lf-file',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    templateUrl: './file.component.html',
                }]
        }], ctorParameters: function () { return [{ type: i1.PathBased, decorators: [{
                    type: Optional
                }, {
                    type: Inject,
                    args: [PathBased]
                }] }, { type: i1.LfStorage }, { type: i1.LfI18n }, { type: i1.LfRouter, decorators: [{
                    type: Optional
                }, {
                    type: Inject,
                    args: [LfRouter]
                }] }, { type: i1.LfFileHolder }]; }, propDecorators: { accept: [{
                type: Input
            }], minSize: [{
                type: Input
            }], maxSize: [{
                type: Input
            }], _selectedFile: [], choosePlaceholder: [], browseText: [], noneChosenText: [], clearButtonTooltip: [], showIsRequired: [], value: [], _onInput: [], setFile: [] } });

/**
 * LF form component.
 */
class FormComponent extends Value {
    constructor(parentPathBasedComponent, lfStorage, lfI18n) {
        super(parentPathBasedComponent, lfStorage, lfI18n);
        /**
         * Modal used to show the form's help message.
         */
        Object.defineProperty(this, "_helpModal", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        /**
         * Modal used to ask for confirmation when attempting to remove the form.
         */
        Object.defineProperty(this, "_removeModal", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        makeObservable(this);
    }
    /**
     * Text used for the "help" action.
     */
    get helpActionText() {
        return this.translate(I18N_FORM_HELP_ACTION_TEXT_KEY);
    }
    /**
     * Text used for the "remove" action.
     */
    get removeActionText() {
        return this.translate(I18N_FORM_REMOVE_ACTION_TEXT_KEY);
    }
    /**
     * Message displayed to the user to confirm removal of the form.
     */
    get ensureRemoveText() {
        return this.translate(I18N_FORM_ENSURE_REMOVE_TEXT_KEY);
    }
    /**
     * Text for the "cancel" button in the removal modal.
     */
    get cancelRemoveButtonText() {
        return this.translate(I18N_FORM_CANCEL_REMOVE_BUTTON_TEXT_KEY);
    }
    /**
     * Text for the "confirm" button in the removal modal.
     */
    get confirmRemoveButtonText() {
        return this.translate(I18N_FORM_CONFIRM_REMOVE_BUTTON_TEXT_KEY);
    }
    /**
     * Whether this form can be removed (if it is `nullable` or its parent is a
     * list or map).
     */
    get isRemovable() {
        return (this.relativeStorage.isNullable() || this.relativeStorage.isRemovable());
    }
    /**
     * Form-related actions shown on the top of the form.
     */
    get _formActions() {
        const actions = [];
        // Help action
        if (this.helpMessage !== undefined) {
            actions.push({
                text: this.helpActionText,
                class: 'help',
                style: 'outline-primary',
                icon: 'question-circle',
                callback: () => this.showHelpModal(),
            });
        }
        // Remove form action
        if (this.isRemovable) {
            actions.push({
                text: this.removeActionText,
                class: 'remove-form',
                style: 'outline-danger',
                icon: 'trash',
                callback: () => this.showRemoveModal(),
            });
        }
        return actions;
    }
    /**
     * Removes this form by either setting it to `null` (when it is `nullable` or
     * removing it from its parent list or map).
     */
    remove() {
        if (this.relativeStorage.isNullable()) {
            this.relativeStorage.set('.', null);
        }
        else {
            this.relativeStorage.remove();
        }
    }
    _cancelRemove() {
        this._removeModal.hide();
    }
    _confirmRemove() {
        return __awaiter(this, void 0, void 0, function* () {
            yield this._removeModal.hide();
            this.remove();
        });
    }
    showHelpModal() {
        this._helpModal.show();
    }
    showRemoveModal() {
        this._removeModal.show();
    }
}
Object.defineProperty(FormComponent, "\u0275fac", {
    enumerable: true,
    configurable: true,
    writable: true,
    value: i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0, type: FormComponent, deps: [{ token: PathBased, optional: true, skipSelf: true }, { token: i1.LfStorage }, { token: i1.LfI18n }], target: i0.ɵɵFactoryTarget.Component })
});
Object.defineProperty(FormComponent, "\u0275cmp", {
    enumerable: true,
    configurable: true,
    writable: true,
    value: i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.15", type: FormComponent, selector: "lf-form", providers: [{ provide: PathBased, useExisting: FormComponent }], viewQueries: [{ propertyName: "_helpModal", first: true, predicate: ["helpModal"], descendants: true }, { propertyName: "_removeModal", first: true, predicate: ["removeModal"], descendants: true }], usesInheritance: true, ngImport: i0, template: "<ng-container *mobxAutorun>\n  <form\n    *ngIf=\"relativeStorage.has() && relativeStorage.get() !== null\"\n    class=\"container\"\n    [name]=\"path\"\n    (submit)=\"$event.preventDefault()\"\n  >\n    <!-- Form title -->\n    <div class=\"form-title-container\">\n      <h1 class=\"form-title\">{{ label }}</h1>\n      <!-- Form actions -->\n      <lf-actions-menu\n        class=\"form-actions\"\n        [actions]=\"_formActions\"\n        buttonsSize=\"sm\"\n        [alignMenusRight]=\"true\"\n      >\n      </lf-actions-menu>\n    </div>\n\n    <!-- Form content -->\n    <ng-content></ng-content>\n  </form>\n\n  <!-- Help modal -->\n  <lf-modal #helpModal class=\"help-modal\" size=\"lg\" *ngIf=\"helpMessage\">\n    <lf-modal-header>{{ helpActionText }}</lf-modal-header>\n    <lf-modal-body [innerHTML]=\"helpMessage\"></lf-modal-body>\n  </lf-modal>\n\n  <!-- Modal to confirm form deletion -->\n  <lf-modal *ngIf=\"isRemovable\" #removeModal class=\"remove-modal\">\n    <lf-modal-header>{{ removeActionText }}</lf-modal-header>\n    <lf-modal-body>\n      <p>{{ ensureRemoveText }}</p>\n    </lf-modal-body>\n    <lf-modal-footer>\n      <button\n        lf-button\n        class=\"cancel-remove\"\n        [style]=\"'outline-secondary'\"\n        size=\"sm\"\n        (click)=\"_cancelRemove()\"\n      >\n        {{ cancelRemoveButtonText }}\n      </button>\n      <button\n        lf-button\n        class=\"confirm-remove\"\n        [style]=\"'outline-danger'\"\n        size=\"sm\"\n        (click)=\"_confirmRemove()\"\n      >\n        {{ confirmRemoveButtonText }}\n      </button>\n    </lf-modal-footer>\n  </lf-modal>\n</ng-container>\n", components: [{ type: ActionsMenuComponent, selector: "lf-actions-menu", inputs: ["actions", "buttonsSize", "collapseSize", "actionsLabelCollapseSize", "alignMenusRight"] }, { type: ModalComponent, selector: "lf-modal", inputs: ["size", "isCentered", "animate", "closeWithEsc", "showBackdrop", "ignoreBackdropClick", "autoFocus"], outputs: ["shown", "hidden"] }, { type: ModalHeaderComponent, selector: "lf-modal-header, [lf-modal-header]", inputs: ["showCloseButton"] }, { type: ModalBodyComponent, selector: "lf-modal-body, [lf-modal-body]" }, { type: ModalFooterComponent, selector: "lf-modal-footer, [lf-modal-footer]" }, { type: ButtonComponent, selector: "button[lf-button], input[lf-button], a[lf-button]", inputs: ["style", "size", "type", "block", "dropdownToggle", "dropdownToggleSplit", "isDisabled", "isActive"] }], directives: [{ type: i6.MobxAutorunDirective, selector: "[mobxAutorun]", inputs: ["mobxAutorun"] }, { type: i7.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush })
});
__decorate([
    computed
], FormComponent.prototype, "helpActionText", null);
__decorate([
    computed
], FormComponent.prototype, "removeActionText", null);
__decorate([
    computed
], FormComponent.prototype, "ensureRemoveText", null);
__decorate([
    computed
], FormComponent.prototype, "cancelRemoveButtonText", null);
__decorate([
    computed
], FormComponent.prototype, "confirmRemoveButtonText", null);
__decorate([
    computed
], FormComponent.prototype, "isRemovable", null);
__decorate([
    computed
], FormComponent.prototype, "_formActions", null);
__decorate([
    action
], FormComponent.prototype, "remove", null);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0, type: FormComponent, decorators: [{
            type: Component,
            args: [{
                    selector: 'lf-form',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [{ provide: PathBased, useExisting: FormComponent }],
                    templateUrl: './form.component.html',
                }]
        }], ctorParameters: function () { return [{ type: i1.PathBased, decorators: [{
                    type: Optional
                }, {
                    type: SkipSelf
                }, {
                    type: Inject,
                    args: [PathBased]
                }] }, { type: i1.LfStorage }, { type: i1.LfI18n }]; }, propDecorators: { _helpModal: [{
                type: ViewChild,
                args: ['helpModal']
            }], _removeModal: [{
                type: ViewChild,
                args: ['removeModal']
            }], helpActionText: [], removeActionText: [], ensureRemoveText: [], cancelRemoveButtonText: [], confirmRemoveButtonText: [], isRemovable: [], _formActions: [], remove: [] } });

/**
 * LF number component.
 */
class NumberComponent extends InlineValue {
    constructor(parentPathBasedComponent, lfStorage, lfI18n, lfRouter) {
        super(parentPathBasedComponent, lfStorage, lfI18n, lfRouter);
        /**
         * Number of decimal digits to show.
         */
        Object.defineProperty(this, "scale", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: 0
        });
        /**
         * Number of digits to show on the left side of the number.
         */
        Object.defineProperty(this, "leadingZeroes", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: 1
        });
        /**
         * Numeric input instance associated with the component.
         */
        Object.defineProperty(this, "numericInput", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        // Disposers
        Object.defineProperty(this, "targetsChangeSubscription", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        Object.defineProperty(this, "disposeObserveOptions", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        Object.defineProperty(this, "disposeObserveValue", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        makeObservable(this);
    }
    /**
     * Number's prefix.
     */
    get prefix() {
        return this.translate(I18N_NUMBER_PREFIX_KEY);
    }
    /**
     * Number's suffix.
     */
    get suffix() {
        return this.translate(I18N_NUMBER_SUFFIX_KEY);
    }
    /**
     * Number's decimal separator.
     */
    get decimalSeparator() {
        return this.translate(I18N_NUMBER_DECIMAL_SEPARATOR_KEY);
    }
    /**
     * Number's thousands separator.
     */
    get thousandsSeparator() {
        return this.translate(I18N_NUMBER_THOUSANDS_SEPARATOR_KEY);
    }
    get value() {
        return this.relativeStorage.has() ? this.relativeStorage.get() : undefined;
    }
    get formattedValue() {
        var _a, _b;
        return ((_b = (_a = this.numericInput) === null || _a === void 0 ? void 0 : _a.format(this.value === undefined ? null : this.value)) !== null && _b !== void 0 ? _b : '');
    }
    /**
     * Whether to show the "is required" icon on the component.
     */
    get showIsRequired() {
        return ((this.relativeStorage.validationMode === ValidationMode.AUTO
            ? this.relativeStorage.getStateProperty('.', 'isRequired')
            : this.relativeStorage.schema().isRequired) === true);
    }
    get min() {
        if (!this.relativeStorage.has()) {
            return undefined;
        }
        const min = this.relativeStorage.validationMode === ValidationMode.AUTO
            ? this.relativeStorage.getStateProperty('.', 'min')
            : this.relativeStorage.schema().min;
        return typeof min === 'number' ? min : undefined;
    }
    get max() {
        if (!this.relativeStorage.has()) {
            return undefined;
        }
        const max = this.relativeStorage.validationMode === ValidationMode.AUTO
            ? this.relativeStorage.getStateProperty('.', 'max')
            : this.relativeStorage.schema().max;
        return typeof max === 'number' ? max : undefined;
    }
    /**
     * Numeric input options.
     */
    get numericInputOptions() {
        const isInt = !!this.relativeStorage.schema().isInteger;
        const min = this.min == null ? -Infinity : this.min;
        const max = this.max == null ? Infinity : this.max;
        return {
            numericRepresentation: isInt ? 'int' : 'float',
            scale: this.scale || 0,
            leadingZeroes: this.leadingZeroes || 1,
            min: isInt ? Math.max(min, Number.MIN_SAFE_INTEGER) : min,
            max: isInt ? Math.min(max, Number.MAX_SAFE_INTEGER) : max,
            prefix: this.prefix || '',
            suffix: this.suffix || '',
            decimalSeparator: this.decimalSeparator || '.',
            thousandsSeparator: this.thousandsSeparator || '',
        };
    }
    ngAfterViewInit() {
        super.ngAfterViewInit();
        // Create a new numeric input instance and recreate it whenever the
        // `<input>` element is recreated
        this.numericInput = this.newNumericInput();
        this.targetsChangeSubscription = this.targets.changes.subscribe(() => {
            var _a;
            (_a = this.numericInput) === null || _a === void 0 ? void 0 : _a.destroy();
            this.numericInput = this.newNumericInput();
        });
        // Update the numeric input's options whenever they change
        this.disposeObserveOptions = observe(this, 'numericInputOptions', ({ newValue }) => { var _a; return (_a = this.numericInput) === null || _a === void 0 ? void 0 : _a.setOptions(newValue, this.value); });
        // Update the numeric input whenever the storage value changes
        this.disposeObserveValue = observe(this, 'value', ({ newValue }) => {
            if (this.numericInput && newValue !== this.numericInput.toNumber()) {
                this.numericInput.update(newValue == null ? null : newValue);
            }
        }, true);
    }
    ngOnDestroy() {
        this.targetsChangeSubscription &&
            this.targetsChangeSubscription.unsubscribe();
        this.disposeObserveOptions && this.disposeObserveOptions();
        this.disposeObserveValue && this.disposeObserveValue();
        this.numericInput && this.numericInput.destroy();
        super.ngOnDestroy();
    }
    /**
     * Action to run on every `input` event of the text input.
     */
    _onInput() {
        this.relativeStorage.setDirty();
    }
    validatePath() {
        const schema = this.relativeStorage.schema();
        if (!isNumberSchema(schema) || !isNullableSchema(schema)) {
            throw pathError(this.path, 'Schema must be of the "number" type and "nullable"');
        }
    }
    newNumericInput() {
        if (this.targets.length > 0) {
            return new NumericInput(this.targets.first.nativeElement, Object.assign(Object.assign({}, this.numericInputOptions), { onUpdate: (_, numberValue) => this.relativeStorage.has() &&
                    !this.relativeStorage.isComputed() &&
                    this.relativeStorage.set('.', numberValue) }));
        }
    }
}
Object.defineProperty(NumberComponent, "\u0275fac", {
    enumerable: true,
    configurable: true,
    writable: true,
    value: i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0, type: NumberComponent, deps: [{ token: PathBased, optional: true }, { token: i1.LfStorage }, { token: i1.LfI18n }, { token: LfRouter, optional: true }], target: i0.ɵɵFactoryTarget.Component })
});
Object.defineProperty(NumberComponent, "\u0275cmp", {
    enumerable: true,
    configurable: true,
    writable: true,
    value: i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.15", type: NumberComponent, selector: "lf-number", inputs: { scale: "scale", leadingZeroes: "leadingZeroes" }, usesInheritance: true, ngImport: i0, template: "<ng-container *mobxAutorun>\n  <ng-container *ngIf=\"shouldDisplay\">\n    <!-- Label -->\n    <span *ngIf=\"label\" class=\"label\">{{ label }}</span>\n    <lf-help-tooltip *ngIf=\"helpMessage\" [help]=\"helpMessage\"></lf-help-tooltip>\n\n    <!-- Required icon -->\n    <lf-icon\n      class=\"is-required\"\n      icon=\"asterisk\"\n      *ngIf=\"showIsRequired && !isReadOnly\"\n    ></lf-icon>\n\n    <!-- Pending validation -->\n    <div\n      class=\"status pending\"\n      *ngIf=\"relativeStorage.shouldShowPending()\"\n    ></div>\n    <!-- Rejected validation -->\n    <div\n      class=\"status rejected\"\n      *ngIf=\"relativeStorage.shouldShowRejected()\"\n      (click)=\"relativeStorage.recomputeStateProperties()\"\n    >\n      <lf-tooltip [help]=\"retryValidateText\">\n        <lf-icon icon=\"warning\"></lf-icon>\n      </lf-tooltip>\n    </div>\n\n    <!-- (Debug) value state -->\n    <lf-value-state [path]=\"path\"></lf-value-state>\n\n    <!-- Input group -->\n    <div\n      class=\"input-group input-group-sm\"\n      [class.is-warning]=\"relativeStorage.shouldShowWarning()\"\n      [class.is-invalid]=\"relativeStorage.shouldShowError()\"\n    >\n      <!-- Code -->\n      <div *ngIf=\"code\" class=\"input-group-prepend\">\n        <div class=\"input-group-text\">{{ code }}</div>\n      </div>\n\n      <!-- Input -->\n      <input\n        #focusTarget\n        type=\"text\"\n        class=\"form-control text-right\"\n        [class.is-warning]=\"relativeStorage.shouldShowWarning()\"\n        [class.is-invalid]=\"relativeStorage.shouldShowError()\"\n        [class.is-readonly]=\"isReadOnly\"\n        [name]=\"path\"\n        [value]=\"formattedValue\"\n        [readonly]=\"isReadOnly\"\n        autocomplete=\"off\"\n        (input)=\"_onInput()\"\n        (focus)=\"_onFocus($event)\"\n        (blur)=\"_onBlur($event)\"\n      />\n    </div>\n\n    <!-- Legend -->\n    <div *ngIf=\"legend\" class=\"legend\">{{ legend }}</div>\n  </ng-container>\n</ng-container>\n", components: [{ type: HelpTooltipComponent, selector: "lf-help-tooltip", inputs: ["help"] }, { type: IconComponent, selector: "lf-icon", inputs: ["icon", "size", "fixedWidth", "spin", "pulse", "ariaHidden"] }, { type: TooltipComponent, selector: "lf-tooltip", inputs: ["help", "placement", "delay"] }, { type: ValueStateComponent, selector: "lf-value-state" }], directives: [{ type: i6.MobxAutorunDirective, selector: "[mobxAutorun]", inputs: ["mobxAutorun"] }, { type: i7.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush })
});
__decorate([
    observable
], NumberComponent.prototype, "scale", void 0);
__decorate([
    observable
], NumberComponent.prototype, "leadingZeroes", void 0);
__decorate([
    computed
], NumberComponent.prototype, "prefix", null);
__decorate([
    computed
], NumberComponent.prototype, "suffix", null);
__decorate([
    computed
], NumberComponent.prototype, "decimalSeparator", null);
__decorate([
    computed
], NumberComponent.prototype, "thousandsSeparator", null);
__decorate([
    computed
], NumberComponent.prototype, "value", null);
__decorate([
    computed
], NumberComponent.prototype, "formattedValue", null);
__decorate([
    computed
], NumberComponent.prototype, "showIsRequired", null);
__decorate([
    computed
], NumberComponent.prototype, "min", null);
__decorate([
    computed
], NumberComponent.prototype, "max", null);
__decorate([
    computed
], NumberComponent.prototype, "numericInputOptions", null);
__decorate([
    action
], NumberComponent.prototype, "_onInput", null);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0, type: NumberComponent, decorators: [{
            type: Component,
            args: [{
                    selector: 'lf-number',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    templateUrl: './number.component.html',
                }]
        }], ctorParameters: function () { return [{ type: i1.PathBased, decorators: [{
                    type: Optional
                }, {
                    type: Inject,
                    args: [PathBased]
                }] }, { type: i1.LfStorage }, { type: i1.LfI18n }, { type: i1.LfRouter, decorators: [{
                    type: Optional
                }, {
                    type: Inject,
                    args: [LfRouter]
                }] }]; }, propDecorators: { scale: [{
                type: Input
            }], leadingZeroes: [{
                type: Input
            }], prefix: [], suffix: [], decimalSeparator: [], thousandsSeparator: [], value: [], formattedValue: [], showIsRequired: [], min: [], max: [], numericInputOptions: [], _onInput: [] } });

/**
 * Abstract class used to represent components where a single option is selected
 * from a set of options.
 */
// tslint:disable-next-line: directive-class-suffix
class SingleSelectionValue extends SelectionValue {
    constructor(parentPathBasedComponent, lfStorage, lfI18n, lfRouter) {
        super(parentPathBasedComponent, lfStorage, lfI18n, lfRouter);
        makeObservable(this);
    }
    /**
     * Whether to show the "is required" icon on the component.
     */
    get showIsRequired() {
        return (this.relativeStorage.isNullable() &&
            (this.relativeStorage.validationMode === ValidationMode.AUTO
                ? this.relativeStorage.getStateProperty('.', 'isRequired')
                : this.relativeStorage.schema().isRequired) === true);
    }
    /**
     * Index of the selected option; `-1` when none of the available options is
     * selected.
     */
    // Not `computed` since `options` cannot be accessed within a `computed` value
    get selectedOptionIndex() {
        const val = this.relativeStorage.get();
        return this.options.findIndex((opt) => comparer.structural(val, opt.value));
    }
}
Object.defineProperty(SingleSelectionValue, "\u0275fac", {
    enumerable: true,
    configurable: true,
    writable: true,
    value: i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0, type: SingleSelectionValue, deps: [{ token: i1.PathBased }, { token: i1.LfStorage }, { token: i1.LfI18n }, { token: i1.LfRouter }], target: i0.ɵɵFactoryTarget.Directive })
});
Object.defineProperty(SingleSelectionValue, "\u0275dir", {
    enumerable: true,
    configurable: true,
    writable: true,
    value: i0.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "12.2.15", type: SingleSelectionValue, usesInheritance: true, ngImport: i0 })
});
__decorate([
    computed
], SingleSelectionValue.prototype, "showIsRequired", null);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0, type: SingleSelectionValue, decorators: [{
            type: Directive
        }], ctorParameters: function () { return [{ type: i1.PathBased }, { type: i1.LfStorage }, { type: i1.LfI18n }, { type: i1.LfRouter }]; }, propDecorators: { showIsRequired: [] } });

/**
 * Component used for selecting from a list of options by using inputs of type
 * `radio`.
 */
class RadioComponent extends SingleSelectionValue {
    constructor(parentPathBasedComponent, lfStorage, lfI18n, lfRouter) {
        super(parentPathBasedComponent, lfStorage, lfI18n, lfRouter);
        /**
         * Whether the list of radio inputs should be displayed inline. The component
         * will still display in "block" mode in small screens.
         */
        Object.defineProperty(this, "displayInline", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: false
        });
        makeObservable(this);
    }
    /**
     * Action to run whenever the value of the `radio` input changes.
     * @param evt `change` event.
     */
    _onRadioChange(evt) {
        this.relativeStorage.set('.', this.options[evt.target.value].value);
        this.relativeStorage.setDirty();
    }
}
Object.defineProperty(RadioComponent, "\u0275fac", {
    enumerable: true,
    configurable: true,
    writable: true,
    value: i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0, type: RadioComponent, deps: [{ token: PathBased, optional: true }, { token: i1.LfStorage }, { token: i1.LfI18n }, { token: LfRouter, optional: true }], target: i0.ɵɵFactoryTarget.Component })
});
Object.defineProperty(RadioComponent, "\u0275cmp", {
    enumerable: true,
    configurable: true,
    writable: true,
    value: i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.15", type: RadioComponent, selector: "lf-radio", inputs: { displayInline: "displayInline" }, usesInheritance: true, ngImport: i0, template: "<ng-container *mobxAutorun>\n  <ng-container *ngIf=\"shouldDisplay\">\n    <!-- Label -->\n    <span *ngIf=\"label\" class=\"label\">{{ label }}</span>\n    <lf-help-tooltip *ngIf=\"helpMessage\" [help]=\"helpMessage\"></lf-help-tooltip>\n\n    <!-- Required icon -->\n    <lf-icon\n      class=\"is-required\"\n      icon=\"asterisk\"\n      *ngIf=\"showIsRequired && !isReadOnly\"\n    ></lf-icon>\n\n    <!-- Pending validation -->\n    <div\n      class=\"status pending\"\n      *ngIf=\"relativeStorage.shouldShowPending()\"\n    ></div>\n    <!-- Rejected validation -->\n    <div\n      class=\"status rejected\"\n      *ngIf=\"relativeStorage.shouldShowRejected()\"\n      (click)=\"relativeStorage.recomputeStateProperties()\"\n    >\n      <lf-tooltip [help]=\"retryValidateText\">\n        <lf-icon icon=\"warning\"></lf-icon>\n      </lf-tooltip>\n    </div>\n\n    <!-- (Debug) value state -->\n    <lf-value-state [path]=\"path\"></lf-value-state>\n\n    <!-- Input group -->\n    <div\n      class=\"lf-checkable-group input-group input-group-sm\"\n      [class.is-warning]=\"relativeStorage.shouldShowWarning()\"\n      [class.is-invalid]=\"relativeStorage.shouldShowError()\"\n    >\n      <!-- Code -->\n      <div *ngIf=\"code\" class=\"input-group-prepend\">\n        <div class=\"input-group-text\">{{ code }}</div>\n      </div>\n\n      <!-- Radios -->\n      <div\n        class=\"lf-checkables form-control\"\n        [class.is-warning]=\"relativeStorage.shouldShowWarning()\"\n        [class.is-invalid]=\"relativeStorage.shouldShowError()\"\n        [class.is-readonly]=\"isReadOnly\"\n        [class.display-inline]=\"displayInline\"\n      >\n        <!-- Text for when there are no options -->\n        <div\n          *ngIf=\"optionsStatus !== 'pending' && options.length === 0\"\n          class=\"no-options\"\n        >\n          {{ noOptionsText }}\n        </div>\n\n        <!-- Pending options -->\n        <div *ngIf=\"optionsStatus === 'pending'\" class=\"pending-options\"></div>\n\n        <div\n          class=\"lf-checkable input-group input-group-sm\"\n          *ngFor=\"let option of options; let i = index\"\n        >\n          <!-- Code of each radio -->\n          <div *ngIf=\"option.code\" class=\"input-group-prepend\">\n            <div class=\"input-group-text\">{{ option.code }}</div>\n          </div>\n\n          <!-- Radio -->\n          <label\n            class=\"form-control custom-control custom-radio\"\n            [class.is-warning]=\"relativeStorage.shouldShowWarning()\"\n            [class.is-invalid]=\"relativeStorage.shouldShowError()\"\n            [class.is-readonly]=\"isReadOnly\"\n          >\n            <!-- Actual radio -->\n            <!--\n              Note that radios don't support `readonly`, so we use the\n              `disabled` attribute\n            -->\n            <input\n              #focusTarget\n              type=\"radio\"\n              class=\"custom-control-input\"\n              [name]=\"path\"\n              [value]=\"i\"\n              [checked]=\"selectedOptionIndex === i\"\n              [disabled]=\"isReadOnly\"\n              (change)=\"_onRadioChange($event)\"\n              (focus)=\"_onFocus($event)\"\n              (blur)=\"_onBlur($event)\"\n            />\n\n            <!-- Radio label -->\n            <span class=\"custom-control-label\">\n              <span>{{ option.label }}</span>\n              <lf-help-tooltip\n                *ngIf=\"option.helpMessage\"\n                [help]=\"option.helpMessage\"\n              ></lf-help-tooltip>\n            </span>\n          </label>\n        </div>\n      </div>\n    </div>\n\n    <!-- Legend -->\n    <div *ngIf=\"legend\" class=\"legend\">{{ legend }}</div>\n  </ng-container>\n</ng-container>\n", components: [{ type: HelpTooltipComponent, selector: "lf-help-tooltip", inputs: ["help"] }, { type: IconComponent, selector: "lf-icon", inputs: ["icon", "size", "fixedWidth", "spin", "pulse", "ariaHidden"] }, { type: TooltipComponent, selector: "lf-tooltip", inputs: ["help", "placement", "delay"] }, { type: ValueStateComponent, selector: "lf-value-state" }], directives: [{ type: i6.MobxAutorunDirective, selector: "[mobxAutorun]", inputs: ["mobxAutorun"] }, { type: i7.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { type: i7.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush })
});
__decorate([
    observable
], RadioComponent.prototype, "displayInline", void 0);
__decorate([
    action
], RadioComponent.prototype, "_onRadioChange", null);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0, type: RadioComponent, decorators: [{
            type: Component,
            args: [{
                    selector: 'lf-radio',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    templateUrl: './radio.component.html',
                }]
        }], ctorParameters: function () { return [{ type: i1.PathBased, decorators: [{
                    type: Optional
                }, {
                    type: Inject,
                    args: [PathBased]
                }] }, { type: i1.LfStorage }, { type: i1.LfI18n }, { type: i1.LfRouter, decorators: [{
                    type: Optional
                }, {
                    type: Inject,
                    args: [LfRouter]
                }] }]; }, propDecorators: { displayInline: [{
                type: Input
            }], _onRadioChange: [] } });

/**
 * Component used for selecting from a list of options in a dropdown `<select>`
 * menu.
 */
class SelectComponent extends SingleSelectionValue {
    constructor(parentPathBasedComponent, lfStorage, lfI18n, lfRouter) {
        super(parentPathBasedComponent, lfStorage, lfI18n, lfRouter);
        makeObservable(this);
    }
    /**
     * Action to run whenever the `<select>` values changes.
     * @param evt `change` event.
     */
    _onSelectChange(evt) {
        this.relativeStorage.set('.', this.options[+evt.target.value].value);
        this.relativeStorage.setDirty();
    }
}
Object.defineProperty(SelectComponent, "\u0275fac", {
    enumerable: true,
    configurable: true,
    writable: true,
    value: i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0, type: SelectComponent, deps: [{ token: PathBased, optional: true }, { token: i1.LfStorage }, { token: i1.LfI18n }, { token: LfRouter, optional: true }], target: i0.ɵɵFactoryTarget.Component })
});
Object.defineProperty(SelectComponent, "\u0275cmp", {
    enumerable: true,
    configurable: true,
    writable: true,
    value: i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.15", type: SelectComponent, selector: "lf-select", usesInheritance: true, ngImport: i0, template: "<ng-container *mobxAutorun>\n  <ng-container *ngIf=\"shouldDisplay\">\n    <!-- Label -->\n    <span *ngIf=\"label\" class=\"label\">{{ label }}</span>\n    <lf-help-tooltip *ngIf=\"helpMessage\" [help]=\"helpMessage\"></lf-help-tooltip>\n\n    <!-- Required icon -->\n    <lf-icon\n      class=\"is-required\"\n      icon=\"asterisk\"\n      *ngIf=\"showIsRequired && !isReadOnly\"\n    ></lf-icon>\n\n    <!-- Pending validation -->\n    <div\n      class=\"status pending\"\n      *ngIf=\"relativeStorage.shouldShowPending() || optionsStatus === 'pending'\"\n    ></div>\n    <!-- Rejected validation -->\n    <div\n      class=\"status rejected\"\n      *ngIf=\"\n        relativeStorage.shouldShowRejected() || optionsStatus === 'rejected'\n      \"\n      (click)=\"relativeStorage.recomputeStateProperties()\"\n    >\n      <lf-tooltip [help]=\"retryValidateText\">\n        <lf-icon icon=\"warning\"></lf-icon>\n      </lf-tooltip>\n    </div>\n\n    <!-- (Debug) value state -->\n    <lf-value-state [path]=\"path\"></lf-value-state>\n\n    <!-- Input group -->\n    <div\n      class=\"input-group input-group-sm\"\n      [class.is-warning]=\"relativeStorage.shouldShowWarning()\"\n      [class.is-invalid]=\"relativeStorage.shouldShowError()\"\n    >\n      <!-- Code -->\n      <div *ngIf=\"code\" class=\"input-group-prepend\">\n        <div class=\"input-group-text\">{{ code }}</div>\n      </div>\n\n      <!-- Select element -->\n      <!--\n        Note that selects don't support `readonly`, so we use the `disabled`\n        attribute; we add an `is-readonly` class to style it differently\n      -->\n      <select\n        #focusTarget\n        class=\"form-control form-control-sm custom-select\"\n        [class.is-warning]=\"relativeStorage.shouldShowWarning()\"\n        [class.is-invalid]=\"relativeStorage.shouldShowError()\"\n        [class.is-readonly]=\"isReadOnly\"\n        [name]=\"path\"\n        [disabled]=\"isReadOnly\"\n        (change)=\"_onSelectChange($event)\"\n        (focus)=\"_onFocus($event)\"\n        (blur)=\"_onBlur($event)\"\n      >\n        <!-- Default option -->\n        <option\n          [selected]=\"selectedOptionIndex === -1\"\n          disabled\n          hidden\n        ></option>\n\n        <!-- Disabled option for when there are no options -->\n        <option *ngIf=\"options.length === 0\" disabled>\n          {{ noOptionsText }}\n        </option>\n\n        <!-- User defined options -->\n        <option\n          *ngFor=\"let option of options; let i = index\"\n          [value]=\"i\"\n          [selected]=\"selectedOptionIndex === i\"\n          [disabled]=\"option.isDisabled\"\n        >\n          <!-- Option code -->\n          <ng-container *ngIf=\"option.code\">{{ option.code }}.</ng-container>\n\n          <!-- Option label -->\n          {{ option.label }}\n        </option>\n      </select>\n    </div>\n\n    <!-- Legend -->\n    <div *ngIf=\"legend\" class=\"legend\">{{ legend }}</div>\n  </ng-container>\n</ng-container>\n", components: [{ type: HelpTooltipComponent, selector: "lf-help-tooltip", inputs: ["help"] }, { type: IconComponent, selector: "lf-icon", inputs: ["icon", "size", "fixedWidth", "spin", "pulse", "ariaHidden"] }, { type: TooltipComponent, selector: "lf-tooltip", inputs: ["help", "placement", "delay"] }, { type: ValueStateComponent, selector: "lf-value-state" }], directives: [{ type: i6.MobxAutorunDirective, selector: "[mobxAutorun]", inputs: ["mobxAutorun"] }, { type: i7.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { type: i7.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush })
});
__decorate([
    action
], SelectComponent.prototype, "_onSelectChange", null);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0, type: SelectComponent, decorators: [{
            type: Component,
            args: [{
                    selector: 'lf-select',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    templateUrl: './select.component.html',
                }]
        }], ctorParameters: function () { return [{ type: i1.PathBased, decorators: [{
                    type: Optional
                }, {
                    type: Inject,
                    args: [PathBased]
                }] }, { type: i1.LfStorage }, { type: i1.LfI18n }, { type: i1.LfRouter, decorators: [{
                    type: Optional
                }, {
                    type: Inject,
                    args: [LfRouter]
                }] }]; }, propDecorators: { _onSelectChange: [] } });

/**
 * Width of the selection column (in `px`).
 */
const SELECTION_COLUMN_WIDTH = 25.6;
/**
 * LF table component.
 *
 * Example usage:
 * ```html
 * <lf-table path="/path/to/table">
 *   <lf-table-header>
 *     <lf-table-column id="field1"></lf-table-column>
 *     <lf-table-column id="field2"></lf-table-column>
 *   </lf-table-header>
 *
 *   <ng-template #lfTableRowTemplate let-id="id">
 *     <tr lf-table-row [path]="id">
 *       <td lf-table-cell><lf-text path="field1"></lf-text></td>
 *       <td lf-table-cell><lf-number path="field2"></lf-number></td>
 *     </tr>
 *   </ng-template>
 * </lf-table>
 * ```
 */
class TableComponent extends InlineValue {
    constructor(parentPathBasedComponent, lfStorage, lfI18n, lfRouter, scrollbarUtils, viewportRuler) {
        super(parentPathBasedComponent, lfStorage, lfI18n, lfRouter);
        Object.defineProperty(this, "scrollbarUtils", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: scrollbarUtils
        });
        Object.defineProperty(this, "viewportRuler", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: viewportRuler
        });
        /**
         * Height (in `px`) of a single row (virtual scroll settings). All rows must
         * have the same height.
         */
        Object.defineProperty(this, "rowHeight", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: 42
        });
        /**
         * Maximum number of visible rows at any given time.
         */
        Object.defineProperty(this, "maxVisibleRows", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: 10
        });
        /**
         * Size of the virtual scroll's template cache
         * (`cdkVirtualForTemplateCacheSize` input of Angular CDK's virtual for
         * directive).
         */
        Object.defineProperty(this, "virtualScrollTemplateCacheSize", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: 20
        });
        /**
         * Whether to allow addition of new rows.
         */
        Object.defineProperty(this, "allowRowAddition", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: true
        });
        /**
         * Whether to allow removal of rows.
         */
        Object.defineProperty(this, "allowRowRemoval", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: true
        });
        // Table header
        Object.defineProperty(this, "_tableHeader", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        // Templates
        Object.defineProperty(this, "_rowTemplate", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        Object.defineProperty(this, "_noRowsTemplate", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        // Scrollable elements
        Object.defineProperty(this, "_scrollableHeader", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        Object.defineProperty(this, "_scrollableBody", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        // Whether the table's body has horizontal overflow
        Object.defineProperty(this, "hasHorizontalOverflow", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        // Selected rows
        Object.defineProperty(this, "selectedRows", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: new Map()
        });
        // Identifier of the row that was last selected/unselected; used to implement
        // selections while pressing shift (behaviour similar to how Gmail operates)
        Object.defineProperty(this, "lastSelectedId", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: null
        });
        // Position of the scrollable element after the latest scroll
        Object.defineProperty(this, "lastScrollPosition", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: [0, 0]
        });
        // Disposers/subscriptions
        Object.defineProperty(this, "disposeObserveScrollables", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        Object.defineProperty(this, "scrollSubscription", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        Object.defineProperty(this, "disposeObservePath", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        Object.defineProperty(this, "disposeObserveValue", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        Object.defineProperty(this, "disposeObserveBodyHeight", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        Object.defineProperty(this, "viewportSubscription", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        makeObservable(this);
    }
    get _addRowText() {
        return this.translate(I18N_TABLE_ADD_ROW_ACTION_TEXT_KEY);
    }
    get _removeRowsText() {
        return this.translate(I18N_TABLE_REMOVE_ROWS_ACTION_TEXT_KEY);
    }
    get _noRowsText() {
        return this.translate(I18N_TABLE_NO_ROWS_TEXT_KEY);
    }
    get _columnLabels() {
        return this.translate(I18N_TABLE_COLUMN_LABELS_KEY);
    }
    /**
     * Schema of this table's value.
     */
    get _schema() {
        return this.relativeStorage.schema();
    }
    /**
     * Table's value.
     */
    get _value() {
        return this.relativeStorage.get().slice();
    }
    /**
     * Whether to show the "is required" icon on the component.
     */
    get _showIsRequired() {
        const minSize = this.relativeStorage.validationMode === ValidationMode.AUTO
            ? this.relativeStorage.getStateProperty('.', 'minSize')
            : this.relativeStorage.schema().minSize;
        return (typeof minSize === 'number' ? minSize : 0) > 0;
    }
    /**
     * Table actions.
     */
    get _tableActions() {
        const actions = [];
        // Remove rows action
        if (this.allowsRowRemoval && !this.noRowsSelected) {
            actions.push({
                text: this._removeRowsText,
                class: 'remove-rows',
                style: 'outline-danger',
                icon: 'trash',
                callback: () => this._onClickRemoveRows(),
            });
        }
        // New row action
        const maxSize = this.relativeStorage.validationMode === ValidationMode.AUTO
            ? this.relativeStorage.getStateProperty('.', 'maxSize')
            : this.relativeStorage.schema().maxSize;
        if (this.allowsRowAddition &&
            (typeof maxSize !== 'number' || this._value.length < maxSize)) {
            actions.push({
                text: this._addRowText,
                class: 'add-row',
                style: 'outline-primary',
                icon: 'plus-circle',
                callback: () => this._onClickNewRow(),
            });
        }
        return actions;
    }
    /**
     * Height (in px) that the scrollable body element should have.
     */
    get _scrollableBodyHeight() {
        return (Math.min(this._value.length, this.maxVisibleRows) * this.rowHeight +
            this.horizontalScrollbarHeight);
    }
    /**
     * Whether new rows can be added to the table (takes into consideration if the
     * table is in "read only" mode).
     */
    get allowsRowAddition() {
        return !this.isReadOnly && this.allowRowAddition;
    }
    /**
     * Whether rows can be removed from the table (takes into consideration if the
     * table is in "read only" mode).
     */
    get allowsRowRemoval() {
        return !this.isReadOnly && this.allowRowRemoval;
    }
    /**
     * Number of rows that have been selected.
     */
    get numberOfRowsSelected() {
        return this.selectedRows.size;
    }
    /**
     * Whether all rows are selected.
     */
    get allRowsSelected() {
        return this.selectedRows.size === this._value.length;
    }
    /**
     * Whether no rows are selected.
     */
    get noRowsSelected() {
        return this.selectedRows.size === 0;
    }
    /**
     * Track either by index or reference, depending on the type of value for list
     * schemas; or by row id, when dealing with table schemas.
     */
    get _trackBy() {
        if (isListSchema(this._schema)) {
            const elementsType = this._schema.elementsSchema.type;
            return ['boolean', 'number', 'string'].indexOf(elementsType) === -1
                ? (_, el) => el
                : (i) => i;
        }
        else {
            return (_, row) => getRowId(row);
        }
    }
    /**
     * Width (in px) of the vertical scroll bar, when existent (`0` otherwise).
     */
    get verticalScrollbarWidth() {
        return this._value.length > this.maxVisibleRows
            ? this.scrollbarUtils.verticalScrollbarWidth
            : 0;
    }
    /**
     * Height (in px) of the horizontal scroll bar, when existent (`0` otherwise).
     */
    get horizontalScrollbarHeight() {
        return this.hasHorizontalOverflow
            ? this.scrollbarUtils.horizontalScrollbarHeight
            : 0;
    }
    ngAfterViewInit() {
        super.ngAfterViewInit();
        this.disposeObserveScrollables = reaction(() => [this._scrollableBody, this._scrollableHeader], ([scrollableBody, scrollableHeader]) => {
            var _a;
            (_a = this.scrollSubscription) === null || _a === void 0 ? void 0 : _a.unsubscribe();
            if (scrollableBody && scrollableHeader) {
                // React to scrolling on the scrollable body. Adapted from:
                // https://github.com/angular/components/blob/master/src/cdk/scrolling/virtual-scroll-viewport.ts
                const scrollableBodyEl = scrollableBody.elementRef.nativeElement;
                const scrollableHeaderEl = scrollableHeader === null || scrollableHeader === void 0 ? void 0 : scrollableHeader.nativeElement;
                this.scrollSubscription = scrollableBody
                    .elementScrolled()
                    .pipe(auditTime(0, typeof requestAnimationFrame !== 'undefined'
                    ? animationFrameScheduler
                    : asapScheduler))
                    .subscribe(() => {
                    // Save last scroll position to restore scroll position when
                    // needed
                    this.lastScrollPosition = [
                        scrollableBodyEl.scrollTop,
                        scrollableBodyEl.scrollLeft,
                    ];
                    // Sync header scroll with body scroll
                    scrollableHeaderEl &&
                        (scrollableHeaderEl.scrollLeft = scrollableBodyEl.scrollLeft);
                });
            }
        });
        // Set the table's scroll position whenever the path changes (and when the
        // component is first initialised)
        this.disposeObservePath = observe(this, 'path', ({ oldValue, newValue }) => {
            // Save old scroll value
            if (oldValue) {
                this.lfStorage.setStateProperty(oldValue, this.scrollPositionStatePropName(oldValue), this.lastScrollPosition);
            }
            // Use previous scroll values
            const savedScrollPosition = this.lfStorage.getStateProperty(newValue, this.scrollPositionStatePropName(newValue)) || [0, 0];
            if (!comparer.shallow(this.lastScrollPosition, savedScrollPosition)) {
                this.lastScrollPosition = savedScrollPosition;
                asap(() => {
                    var _a;
                    return (_a = this._scrollableBody) === null || _a === void 0 ? void 0 : _a.scrollTo({
                        top: savedScrollPosition[0],
                        left: savedScrollPosition[1],
                    });
                });
            }
        }, true);
        // Remove "selected rows" of non-existent rows (because they were removed
        // by an outside operation, such as loading from a file)
        this.disposeObserveValue = observe(this, '_value', () => {
            for (const id of Array.from(this.selectedRows.keys())) {
                if (!this.relativeStorage.has(`${id}`)) {
                    this.selectedRows.delete(id);
                }
            }
        });
        // Refresh the virtual scroll viewport whenever its height changes
        this.disposeObserveBodyHeight = observe(this, '_scrollableBodyHeight', () => {
            var _a;
            (_a = this._scrollableBody) === null || _a === void 0 ? void 0 : _a.checkViewportSize();
            this.checkHasHorizontalOverflow();
        });
        // Update the status of the horizontal overflow whenever the window viewport
        // size changes
        this.viewportSubscription = this.viewportRuler.change().subscribe(() => {
            this.checkHasHorizontalOverflow();
        });
        asap(() => this.checkHasHorizontalOverflow()); // Update on start-up
    }
    ngOnDestroy() {
        var _a, _b, _c, _d, _e, _f;
        super.ngOnDestroy();
        // Save scroll value
        this.lfStorage.setStateProperty(this.path, this.scrollPositionStatePropName(this.path), this.lastScrollPosition);
        (_a = this.disposeObserveScrollables) === null || _a === void 0 ? void 0 : _a.call(this);
        (_b = this.scrollSubscription) === null || _b === void 0 ? void 0 : _b.unsubscribe();
        (_c = this.disposeObservePath) === null || _c === void 0 ? void 0 : _c.call(this);
        (_d = this.disposeObserveValue) === null || _d === void 0 ? void 0 : _d.call(this);
        (_e = this.disposeObserveBodyHeight) === null || _e === void 0 ? void 0 : _e.call(this);
        (_f = this.viewportSubscription) === null || _f === void 0 ? void 0 : _f.unsubscribe();
    }
    _columnLabel(columnId) {
        return this._columnLabels && this._columnLabels[columnId];
    }
    /**
     * Minimum width (in px) that the table should have.
     * @param includeScrollbarColumn Whether the scrollbar column should be
     * included in the computation (should be set to `true` for the header table).
     * @returns Minimum width that the table should have.
     */
    _tableMinWidth(includeScrollbarColumn) {
        return (this._tableHeader.tableMinWidth +
            (this.allowsRowRemoval ? SELECTION_COLUMN_WIDTH : 0) +
            (includeScrollbarColumn ? this.verticalScrollbarWidth : 0));
    }
    /**
     * Maximum width (in px) that the table should have.
     * @param includeScrollbarColumn Whether the scrollbar column should be
     * included in the computation (should be set to `true` for the header table).
     * @returns Maximum width that the table should have.
     */
    _tableMaxWidth(includeScrollbarColumn) {
        return (this._tableHeader.tableMaxWidth +
            (this.allowsRowRemoval ? SELECTION_COLUMN_WIDTH : 0) +
            (includeScrollbarColumn ? this.verticalScrollbarWidth : 0));
    }
    /**
     * Widths (as strings with correct units) of each column of the table.
     * @param includeScrollbarColumn Whether the scrollbar column should be
     * included (should be set to `true` for the header table).
     * @returns Widths of each column of the table.
     */
    _columnWidths(includeScrollbarColumn) {
        return (this.allowsRowRemoval ? [SELECTION_COLUMN_WIDTH + 'px'] : []).concat(this._tableHeader.columnWidths.concat(includeScrollbarColumn ? [this.verticalScrollbarWidth + 'px'] : []));
    }
    /**
     * Adds a new row to the table.
     */
    addNewRow() {
        this.relativeStorage.push('.', undefined);
        // Scroll to bottom (shows newly inserted row)
        asap(() => this.scrollToIndex(this._value.length - 1));
    }
    /**
     * Gets the selection status of the row with the provided id.
     * @param id Id of the row for which to check selection status.
     * @returns Whether the row with the provided id is selected.
     */
    getRowSelectedStatus(id) {
        return this.allowsRowRemoval && this.selectedRows.has(id);
    }
    /**
     * Sets the selection status of the row with the provided id.
     * @param id Id of the row on which to set selection status.
     * @param selectedStatus `true` to set selected, `false` to set unselected.
     */
    setRowSelectedStatus(id, selectedStatus) {
        if (!this.relativeStorage.has(`${id}`)) {
            throw pathError(this.path, `Invalid id: ${id}`);
        }
        if (selectedStatus) {
            this.selectedRows.set(id, true);
        }
        else {
            this.selectedRows.delete(id);
        }
        this.lastSelectedId = id;
    }
    /**
     * Sets the selection status of all rows from the last row that has had its
     * selection status set to the row with the provided id.
     * @param id Id of the row until which to set selection status.
     * @param selectedStatus `true` to set selected, `false` to set unselected.
     */
    setRowSelectedStatusFromLastSelected(id, selectedStatus) {
        if (!this.relativeStorage.has(`${id}`)) {
            throw pathError(this.path, `Invalid id: ${id}`);
        }
        const lastSelectedId = this.lastSelectedId === null ||
            !this.relativeStorage.has(`${this.lastSelectedId}`)
            ? id
            : this.lastSelectedId;
        let idx;
        let lastSelectedIdx;
        const isTable = isTableSchema(this._schema);
        if (isTable) {
            idx = this._value.findIndex((row) => getRowId(row) === id);
            lastSelectedIdx =
                id === lastSelectedId
                    ? idx
                    : this._value.findIndex((row) => getRowId(row) === lastSelectedId);
        }
        else {
            idx = id;
            lastSelectedIdx = lastSelectedId;
        }
        for (let i = Math.min(lastSelectedIdx, idx), l = Math.max(lastSelectedIdx, idx); i <= l; ++i) {
            const iId = isTable ? getRowId(this._value[i]) : i;
            if (selectedStatus) {
                this.selectedRows.set(iId, true);
            }
            else {
                this.selectedRows.delete(iId);
            }
        }
        this.lastSelectedId = id;
    }
    /**
     * Unselects all rows.
     */
    unselectAllRows() {
        // Doing this seems to be way faster than calling `selectedRows.clear()`
        // with, for example, 200000 rows
        this.selectedRows = new Map();
    }
    /**
     * Sets the selection status of all rows.
     * @param selectedStatus `true` to set selected, `false` to set unselected.
     */
    setAllRowsSelectedStatus(selectedStatus) {
        if (selectedStatus) {
            const isTable = isTableSchema(this._schema);
            this._value.forEach((el, i) => {
                const id = isTable ? getRowId(el) : i;
                this.selectedRows.set(id, true);
            });
        }
        else {
            this.unselectAllRows();
        }
    }
    /**
     * Toggles the status of all rows (if they are all selected, then they all
     * become unselected, otherwise they all become selected).
     */
    toggleAllRowsSelectedStatus() {
        this.setAllRowsSelectedStatus(!this.allRowsSelected);
    }
    /**
     * Removes all selected rows.
     */
    removeSelectedRows() {
        const isTable = isTableSchema(this._schema);
        this.relativeStorage.set('.', this._value.filter((el, i) => {
            const id = isTable ? getRowId(el) : i;
            return !this.selectedRows.has(id);
        }));
        this.unselectAllRows();
        this.lastSelectedId = null;
    }
    /**
     * Scrolls to the row with the provided id.
     * @param id Identifier of the row to scroll to.
     */
    scrollToId(id) {
        if (!this.relativeStorage.has(`${id}`)) {
            throw pathError(this.path, `Invalid id: ${id}`);
        }
        const index = isListSchema(this._schema)
            ? id
            : this._value.findIndex((row) => getRowId(row) === id);
        this.scrollToIndex(index);
    }
    /**
     * Scrolls to row with the provided index.
     * @param index Index of the row to scroll to.
     */
    scrollToIndex(index) {
        var _a;
        (_a = this._scrollableBody) === null || _a === void 0 ? void 0 : _a.scrollToIndex(index);
    }
    /**
     * Identifier of the given element with the given index.
     * @param el Element for which to get identifier.
     * @param index Index of the element in the value.
     * @returns Identifier for the given element at the given index.
     */
    _id(el, index) {
        return isListSchema(this._schema) ? index : getRowId(el);
    }
    /**
     * Action to run when the "remove rows" button is clicked.
     */
    _onClickRemoveRows() {
        this.removeSelectedRows();
        this.relativeStorage.setDirty();
    }
    /**
     * Action to run when the "new row" button is clicked.
     */
    _onClickNewRow() {
        this.addNewRow();
        this.relativeStorage.setDirty();
    }
    validatePath() {
        const schema = this.relativeStorage.schema();
        if ((!isListSchema(schema) && !isTableSchema(schema)) ||
            isNullableSchema(schema)) {
            throw pathError(this.path, 'Schema must be of the "list" or "table" type and not "nullable"');
        }
    }
    // Scroll to the activated row when one is activated.
    onActivate(activatedPath) {
        const relevantPart = this.lfStorage
            .pathInfo(activatedPath)
            .find(({ path }) => path.length > this.path.length);
        const id = relevantPart && relevantPart.id;
        if (id !== undefined && this.relativeStorage.has(`${id}`)) {
            this.scrollToId(id);
        }
    }
    /**
     * State property name used to save the position of the scroll within the
     * table.
     * @param path Path of table.
     * @returns State property name.
     */
    scrollPositionStatePropName(path) {
        // Add the path to the name of the property when the value is a child of a
        // computed value (since children states are shared with the parent computed
        // value)
        return `lfTableScrollPosition${this.relativeStorage.isComputed(appendToPath(path, '..'))
            ? `[${path}]`
            : ''}`;
    }
    /**
     * Update the status of the "horizontal overflow".
     */
    checkHasHorizontalOverflow() {
        this.hasHorizontalOverflow =
            !!this._scrollableBody &&
                this.scrollbarUtils.hasHorizontalOverflow(this._scrollableBody.elementRef.nativeElement);
    }
}
Object.defineProperty(TableComponent, "\u0275fac", {
    enumerable: true,
    configurable: true,
    writable: true,
    value: i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0, type: TableComponent, deps: [{ token: PathBased, optional: true, skipSelf: true }, { token: i1.LfStorage }, { token: i1.LfI18n }, { token: LfRouter, optional: true }, { token: i2$2.ScrollbarUtils }, { token: i3.ViewportRuler }], target: i0.ɵɵFactoryTarget.Component })
});
Object.defineProperty(TableComponent, "\u0275cmp", {
    enumerable: true,
    configurable: true,
    writable: true,
    value: i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.15", type: TableComponent, selector: "lf-table", inputs: { rowHeight: "rowHeight", maxVisibleRows: "maxVisibleRows", virtualScrollTemplateCacheSize: "virtualScrollTemplateCacheSize", allowRowAddition: "allowRowAddition", allowRowRemoval: "allowRowRemoval" }, providers: [{ provide: PathBased, useExisting: TableComponent }], queries: [{ propertyName: "_tableHeader", first: true, predicate: TableHeaderDirective, descendants: true }, { propertyName: "_rowTemplate", first: true, predicate: ["lfTableRowTemplate"], descendants: true }, { propertyName: "_noRowsTemplate", first: true, predicate: ["lfTableNoRowsTemplate"], descendants: true }], viewQueries: [{ propertyName: "_scrollableHeader", first: true, predicate: ["scrollableHeader"], descendants: true }, { propertyName: "_scrollableBody", first: true, predicate: ["scrollableBody"], descendants: true }], usesInheritance: true, ngImport: i0, template: "<ng-container *mobxAutorun>\n  <ng-container *ngIf=\"shouldDisplay\">\n    <div class=\"row label\">\n      <!-- Code + label -->\n      <div class=\"code-label-container\">\n        <!-- Code -->\n        <div\n          *ngIf=\"code\"\n          class=\"input-group input-group-sm code-container mr-2\"\n          [class.is-warning]=\"relativeStorage.shouldShowWarning()\"\n          [class.is-invalid]=\"relativeStorage.shouldShowError()\"\n        >\n          <div class=\"input-group-prepend\">\n            <div class=\"input-group-text code\">{{ code }}</div>\n          </div>\n        </div>\n\n        <!-- Label -->\n        <span *ngIf=\"label\" class=\"label-text\">{{ label }}</span>\n        <lf-help-tooltip\n          *ngIf=\"helpMessage\"\n          [help]=\"helpMessage\"\n        ></lf-help-tooltip>\n      </div>\n\n      <!-- Table actions -->\n      <lf-actions-menu\n        class=\"table-actions text-right\"\n        [actions]=\"_tableActions\"\n        buttonsSize=\"sm\"\n        [alignMenusRight]=\"true\"\n      >\n      </lf-actions-menu>\n    </div>\n\n    <!-- Required icon -->\n    <lf-icon\n      class=\"is-required\"\n      icon=\"asterisk\"\n      *ngIf=\"_showIsRequired && !isReadOnly\"\n    ></lf-icon>\n\n    <!-- Pending validation -->\n    <div\n      class=\"status pending\"\n      *ngIf=\"relativeStorage.shouldShowPending()\"\n    ></div>\n    <!-- Rejected validation -->\n    <div\n      class=\"status rejected\"\n      *ngIf=\"relativeStorage.shouldShowRejected()\"\n      (click)=\"relativeStorage.recomputeStateProperties()\"\n    >\n      <lf-tooltip [help]=\"retryValidateText\">\n        <lf-icon icon=\"warning\"></lf-icon>\n      </lf-tooltip>\n    </div>\n\n    <!-- (Debug) value state -->\n    <lf-value-state [path]=\"path\"></lf-value-state>\n\n    <!-- Container of whole table -->\n    <div\n      #targetElement\n      class=\"table-container\"\n      [class.is-warning]=\"relativeStorage.shouldShowWarning()\"\n      [class.is-invalid]=\"relativeStorage.shouldShowError()\"\n    >\n      <!-- Header table container (scrollable horizontally) -->\n      <div #scrollableHeader class=\"scrollable-header\" *ngIf=\"_tableHeader\">\n        <table\n          class=\"table table-sm header-table\"\n          [style.minWidth]=\"_tableMinWidth(true) + 'px'\"\n          [style.maxWidth]=\"_tableMaxWidth(true) + 'px'\"\n        >\n          <!-- Table columns -->\n          <colgroup>\n            <col\n              *ngFor=\"let width of _columnWidths(true)\"\n              [attr.width]=\"width\"\n            />\n          </colgroup>\n\n          <!-- Table header -->\n          <thead>\n            <tr *ngFor=\"let row of _tableHeader.rows; let first = first\">\n              <!-- Selection column -->\n              <th\n                *ngIf=\"first && allowsRowRemoval\"\n                class=\"table-cell-select\"\n                [attr.rowSpan]=\"_tableHeader.numberOfRows\"\n              >\n                <label\n                  class=\"select-all-checkbox custom-control custom-checkbox\"\n                >\n                  <input\n                    type=\"checkbox\"\n                    class=\"custom-control-input\"\n                    [disabled]=\"_value.length === 0\"\n                    [checked]=\"allRowsSelected && _value.length > 0\"\n                    [indeterminate]=\"!allRowsSelected && !noRowsSelected\"\n                    (click)=\"toggleAllRowsSelectedStatus()\"\n                  />\n                  <span class=\"custom-control-label\"></span>\n                </label>\n              </th>\n              <!-- User defined columns -->\n              <th\n                *ngFor=\"let column of row\"\n                [attr.rowSpan]=\"column.rowSpan\"\n                [attr.colSpan]=\"column.colSpan\"\n              >\n                <!-- TODO: Allow help messages/templates? -->\n                <ng-container *ngIf=\"column.id\">{{\n                  _columnLabel(column.id)\n                }}</ng-container>\n              </th>\n              <!-- Scrollbar compensation column -->\n              <th *ngIf=\"first\" [attr.rowSpan]=\"_tableHeader.numberOfRows\"></th>\n            </tr>\n          </thead>\n        </table>\n      </div>\n\n      <!-- Body table container (scrollable content) -->\n      <cdk-virtual-scroll-viewport\n        #scrollableBody\n        class=\"scrollable-body\"\n        [itemSize]=\"rowHeight\"\n        [style.height]=\"_scrollableBodyHeight + 'px'\"\n      >\n        <table\n          class=\"table table-sm body-table\"\n          [style.minWidth]=\"_tableHeader && _tableMinWidth(false) + 'px'\"\n          [style.maxWidth]=\"_tableHeader && _tableMaxWidth(false) + 'px'\"\n        >\n          <!-- Table columns (except scrollbar column) -->\n          <colgroup *ngIf=\"_tableHeader\">\n            <col\n              *ngFor=\"let width of _columnWidths(false)\"\n              [attr.width]=\"width\"\n            />\n          </colgroup>\n\n          <!-- Table body -->\n          <tbody>\n            <!-- Row -->\n            <ng-container\n              *cdkVirtualFor=\"\n                let item of _value;\n                let index = index;\n                let count = count;\n                let first = first;\n                let last = last;\n                let even = even;\n                let odd = odd;\n                templateCacheSize: virtualScrollTemplateCacheSize;\n                trackBy: _trackBy\n              \"\n              [ngTemplateOutlet]=\"_rowTemplate\"\n              [ngTemplateOutletContext]=\"{\n                $implicit: item,\n                id: _id(item, index),\n                index: index,\n                count: count,\n                first: first,\n                last: last,\n                even: even,\n                odd: odd\n              }\"\n            ></ng-container>\n          </tbody>\n        </table>\n      </cdk-virtual-scroll-viewport>\n\n      <!-- No items -->\n      <div *ngIf=\"_value.length === 0\" class=\"no-rows\">\n        <ng-container *ngIf=\"!_noRowsTemplate\">\n          {{ _noRowsText }}\n        </ng-container>\n        <ng-container\n          *ngIf=\"_noRowsTemplate\"\n          [ngTemplateOutlet]=\"_noRowsTemplate\"\n        >\n        </ng-container>\n      </div>\n    </div>\n\n    <!-- Legend -->\n    <div *ngIf=\"legend\" class=\"legend\">{{ legend }}</div>\n  </ng-container>\n</ng-container>\n", components: [{ type: HelpTooltipComponent, selector: "lf-help-tooltip", inputs: ["help"] }, { type: ActionsMenuComponent, selector: "lf-actions-menu", inputs: ["actions", "buttonsSize", "collapseSize", "actionsLabelCollapseSize", "alignMenusRight"] }, { type: IconComponent, selector: "lf-icon", inputs: ["icon", "size", "fixedWidth", "spin", "pulse", "ariaHidden"] }, { type: TooltipComponent, selector: "lf-tooltip", inputs: ["help", "placement", "delay"] }, { type: ValueStateComponent, selector: "lf-value-state" }, { type: i3.CdkVirtualScrollViewport, selector: "cdk-virtual-scroll-viewport", inputs: ["orientation", "appendOnly"], outputs: ["scrolledIndexChange"] }], directives: [{ type: i6.MobxAutorunDirective, selector: "[mobxAutorun]", inputs: ["mobxAutorun"] }, { type: i7.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { type: i7.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { type: i3.CdkFixedSizeVirtualScroll, selector: "cdk-virtual-scroll-viewport[itemSize]", inputs: ["itemSize", "minBufferPx", "maxBufferPx"] }, { type: i3.CdkVirtualForOf, selector: "[cdkVirtualFor][cdkVirtualForOf]", inputs: ["cdkVirtualForOf", "cdkVirtualForTrackBy", "cdkVirtualForTemplate", "cdkVirtualForTemplateCacheSize"] }, { type: i7.NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush })
});
__decorate([
    observable
], TableComponent.prototype, "rowHeight", void 0);
__decorate([
    observable
], TableComponent.prototype, "maxVisibleRows", void 0);
__decorate([
    observable
], TableComponent.prototype, "allowRowAddition", void 0);
__decorate([
    observable
], TableComponent.prototype, "allowRowRemoval", void 0);
__decorate([
    observable
], TableComponent.prototype, "_scrollableHeader", void 0);
__decorate([
    observable
], TableComponent.prototype, "_scrollableBody", void 0);
__decorate([
    observable
], TableComponent.prototype, "hasHorizontalOverflow", void 0);
__decorate([
    observable
], TableComponent.prototype, "selectedRows", void 0);
__decorate([
    computed
], TableComponent.prototype, "_addRowText", null);
__decorate([
    computed
], TableComponent.prototype, "_removeRowsText", null);
__decorate([
    computed
], TableComponent.prototype, "_noRowsText", null);
__decorate([
    computed
], TableComponent.prototype, "_columnLabels", null);
__decorate([
    computed
], TableComponent.prototype, "_schema", null);
__decorate([
    computed
], TableComponent.prototype, "_value", null);
__decorate([
    computed
], TableComponent.prototype, "_showIsRequired", null);
__decorate([
    computed.struct
], TableComponent.prototype, "_tableActions", null);
__decorate([
    computed
], TableComponent.prototype, "_scrollableBodyHeight", null);
__decorate([
    computed
], TableComponent.prototype, "allowsRowAddition", null);
__decorate([
    computed
], TableComponent.prototype, "allowsRowRemoval", null);
__decorate([
    computed
], TableComponent.prototype, "numberOfRowsSelected", null);
__decorate([
    computed
], TableComponent.prototype, "allRowsSelected", null);
__decorate([
    computed
], TableComponent.prototype, "noRowsSelected", null);
__decorate([
    computed
], TableComponent.prototype, "_trackBy", null);
__decorate([
    computed
], TableComponent.prototype, "verticalScrollbarWidth", null);
__decorate([
    computed
], TableComponent.prototype, "horizontalScrollbarHeight", null);
__decorate([
    action
], TableComponent.prototype, "addNewRow", null);
__decorate([
    action
], TableComponent.prototype, "setRowSelectedStatus", null);
__decorate([
    action
], TableComponent.prototype, "setRowSelectedStatusFromLastSelected", null);
__decorate([
    action
], TableComponent.prototype, "unselectAllRows", null);
__decorate([
    action
], TableComponent.prototype, "setAllRowsSelectedStatus", null);
__decorate([
    action
], TableComponent.prototype, "toggleAllRowsSelectedStatus", null);
__decorate([
    action
], TableComponent.prototype, "removeSelectedRows", null);
__decorate([
    action
], TableComponent.prototype, "_onClickRemoveRows", null);
__decorate([
    action
], TableComponent.prototype, "_onClickNewRow", null);
__decorate([
    action
], TableComponent.prototype, "onActivate", null);
__decorate([
    action
], TableComponent.prototype, "checkHasHorizontalOverflow", null);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0, type: TableComponent, decorators: [{
            type: Component,
            args: [{
                    selector: 'lf-table',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [{ provide: PathBased, useExisting: TableComponent }],
                    templateUrl: './table.component.html',
                }]
        }], ctorParameters: function () { return [{ type: i1.PathBased, decorators: [{
                    type: Optional
                }, {
                    type: SkipSelf
                }, {
                    type: Inject,
                    args: [PathBased]
                }] }, { type: i1.LfStorage }, { type: i1.LfI18n }, { type: i1.LfRouter, decorators: [{
                    type: Optional
                }, {
                    type: Inject,
                    args: [LfRouter]
                }] }, { type: i2$2.ScrollbarUtils }, { type: i3.ViewportRuler }]; }, propDecorators: { rowHeight: [{
                type: Input
            }], maxVisibleRows: [{
                type: Input
            }], virtualScrollTemplateCacheSize: [{
                type: Input
            }], allowRowAddition: [{
                type: Input
            }], allowRowRemoval: [{
                type: Input
            }], _tableHeader: [{
                type: ContentChild,
                args: [TableHeaderDirective]
            }], _rowTemplate: [{
                type: ContentChild,
                args: ['lfTableRowTemplate']
            }], _noRowsTemplate: [{
                type: ContentChild,
                args: ['lfTableNoRowsTemplate']
            }], _scrollableHeader: [{
                type: ViewChild,
                args: ['scrollableHeader']
            }], _scrollableBody: [{
                type: ViewChild,
                args: ['scrollableBody']
            }], hasHorizontalOverflow: [], selectedRows: [], _addRowText: [], _removeRowsText: [], _noRowsText: [], _columnLabels: [], _schema: [], _value: [], _showIsRequired: [], _tableActions: [], _scrollableBodyHeight: [], allowsRowAddition: [], allowsRowRemoval: [], numberOfRowsSelected: [], allRowsSelected: [], noRowsSelected: [], _trackBy: [], verticalScrollbarWidth: [], horizontalScrollbarHeight: [], addNewRow: [], setRowSelectedStatus: [], setRowSelectedStatusFromLastSelected: [], unselectAllRows: [], setAllRowsSelectedStatus: [], toggleAllRowsSelectedStatus: [], removeSelectedRows: [], _onClickRemoveRows: [], _onClickNewRow: [], onActivate: [], checkHasHorizontalOverflow: [] } });

/**
 * LF table-cell component.
 */
class TableCellComponent {
    constructor(parentTableComponent) {
        Object.defineProperty(this, "parentTableComponent", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: parentTableComponent
        });
        makeObservable(this);
    }
    /**
     * Height of the cell.
     */
    get _hostStyleHeight() {
        return this.parentTableComponent.rowHeight + 'px';
    }
}
Object.defineProperty(TableCellComponent, "\u0275fac", {
    enumerable: true,
    configurable: true,
    writable: true,
    value: i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0, type: TableCellComponent, deps: [{ token: TableComponent }], target: i0.ɵɵFactoryTarget.Component })
});
Object.defineProperty(TableCellComponent, "\u0275cmp", {
    enumerable: true,
    configurable: true,
    writable: true,
    value: i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.15", type: TableCellComponent, selector: "td[lf-table-cell], th[lf-table-cell]", host: { properties: { "style.height": "this._hostStyleHeight" } }, ngImport: i0, template: "<ng-container *mobxAutorun>\n  <div class=\"table-cell-container\">\n    <div class=\"table-cell-inner\"><ng-content></ng-content></div>\n  </div>\n</ng-container>\n", directives: [{ type: i6.MobxAutorunDirective, selector: "[mobxAutorun]", inputs: ["mobxAutorun"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush })
});
__decorate([
    computed
], TableCellComponent.prototype, "_hostStyleHeight", null);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0, type: TableCellComponent, decorators: [{
            type: Component,
            args: [{
                    // tslint:disable-next-line:component-selector
                    selector: 'td[lf-table-cell], th[lf-table-cell]',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    templateUrl: './table-cell.component.html',
                }]
        }], ctorParameters: function () { return [{ type: TableComponent }]; }, propDecorators: { _hostStyleHeight: [{
                type: HostBinding,
                args: ['style.height']
            }] } });

/**
 * LF table-row component.
 */
class TableRowComponent extends Value {
    constructor(parentPathBasedComponent, // Verified `OnInit`
    lfStorage, lfI18n) {
        super(parentPathBasedComponent, lfStorage, lfI18n);
        Object.defineProperty(this, "parentPathBasedComponent", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: parentPathBasedComponent
        });
        makeObservable(this);
    }
    /**
     * Whether the row can be removed.
     */
    get allowsRemoval() {
        return this.parentPathBasedComponent.allowsRowRemoval;
    }
    /**
     * Whether the row is selected (adds an `is-selected` class to the row).
     */
    get isSelected() {
        return this.parentPathBasedComponent.getRowSelectedStatus(this.relativeStorage.currentId);
    }
    /**
     * Class that should be added to the row when the row should show as having an
     * error.
     */
    get _classIsInvalid() {
        return !!(this.relativeStorage.has() && this.relativeStorage.shouldShowError());
    }
    /**
     * Class that should be added to the row when the row should show as having a
     * warning.
     */
    get _classIsWarning() {
        return !!(this.relativeStorage.has() && this.relativeStorage.shouldShowWarning());
    }
    ngOnInit() {
        super.ngOnInit();
        // Table rows must be children of tables
        if (!(this.parentPathBasedComponent instanceof TableComponent)) {
            throw pathError(this.path, 'This component must be a child of a `TableComponent`');
        }
    }
    /**
     * Sets the row's selection status.
     * @param selectedStatus `true` to set selected, `false` to set unselected.
     */
    setSelectedStatus(selectedStatus) {
        this.parentPathBasedComponent.setRowSelectedStatus(this.relativeStorage.currentId, selectedStatus);
    }
    /**
     * Sets the row selection status of all rows from the last row that has had
     * its selection status set to this row.
     * @param selectedStatus `true` to set selected, `false` to set unselected.
     */
    setSelectedStatusFromLastSelected(selectedStatus) {
        this.parentPathBasedComponent.setRowSelectedStatusFromLastSelected(this.relativeStorage.currentId, selectedStatus);
    }
    /**
     * Action to run when the selection checkbox label is clicked: added as a fix
     * for Firefox, where `shift+click` on the label won't trigger a click on the
     * `input`; as such we manually call the event.
     * @param event Click event.
     * @param checkboxElement Element on which the even should be called instead.
     */
    _onLabelClick(event, checkboxElement) {
        this._onSelectionCheckboxClick(event);
        checkboxElement.focus();
        event.preventDefault();
    }
    /**
     * Action to run when the selection checkbox is clicked.
     * @param event Click event.
     */
    _onSelectionCheckboxClick(event) {
        if (event.shiftKey) {
            this.setSelectedStatusFromLastSelected(!this.isSelected);
        }
        else {
            this.setSelectedStatus(!this.isSelected);
        }
        event.stopPropagation(); // Don't call the label event
    }
}
Object.defineProperty(TableRowComponent, "\u0275fac", {
    enumerable: true,
    configurable: true,
    writable: true,
    value: i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0, type: TableRowComponent, deps: [{ token: PathBased, optional: true, skipSelf: true }, { token: i1.LfStorage }, { token: i1.LfI18n }], target: i0.ɵɵFactoryTarget.Component })
});
Object.defineProperty(TableRowComponent, "\u0275cmp", {
    enumerable: true,
    configurable: true,
    writable: true,
    value: i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.15", type: TableRowComponent, selector: "tr[lf-table-row]", host: { properties: { "class.is-selected": "this.isSelected", "class.is-invalid": "this._classIsInvalid", "class.is-warning": "this._classIsWarning" } }, providers: [{ provide: PathBased, useExisting: TableRowComponent }], usesInheritance: true, ngImport: i0, template: "<ng-container *mobxAutorun>\n  <ng-container *ngIf=\"relativeStorage.has()\">\n    <!-- Cell used to hold a checkbox that marks the row as selected -->\n    <td lf-table-cell *ngIf=\"allowsRemoval\" class=\"table-cell-select\">\n      <label\n        class=\"custom-control custom-checkbox\"\n        (click)=\"_onLabelClick($event, checkboxElement)\"\n      >\n        <input\n          #checkboxElement\n          type=\"checkbox\"\n          class=\"custom-control-input\"\n          [checked]=\"isSelected\"\n          (click)=\"_onSelectionCheckboxClick($event)\"\n        />\n        <span class=\"custom-control-label\"></span>\n      </label>\n    </td>\n    <!-- User defined cells -->\n    <ng-content select=\"th[lf-table-cell], td[lf-table-cell]\"></ng-content>\n  </ng-container>\n</ng-container>\n", components: [{ type: TableCellComponent, selector: "td[lf-table-cell], th[lf-table-cell]" }], directives: [{ type: i6.MobxAutorunDirective, selector: "[mobxAutorun]", inputs: ["mobxAutorun"] }, { type: i7.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush })
});
__decorate([
    computed
], TableRowComponent.prototype, "allowsRemoval", null);
__decorate([
    computed
], TableRowComponent.prototype, "isSelected", null);
__decorate([
    computed
], TableRowComponent.prototype, "_classIsInvalid", null);
__decorate([
    computed
], TableRowComponent.prototype, "_classIsWarning", null);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0, type: TableRowComponent, decorators: [{
            type: Component,
            args: [{
                    // tslint:disable-next-line: component-selector
                    selector: 'tr[lf-table-row]',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [{ provide: PathBased, useExisting: TableRowComponent }],
                    templateUrl: './table-row.component.html',
                }]
        }], ctorParameters: function () { return [{ type: TableComponent, decorators: [{
                    type: Optional
                }, {
                    type: SkipSelf
                }, {
                    type: Inject,
                    args: [PathBased]
                }] }, { type: i1.LfStorage }, { type: i1.LfI18n }]; }, propDecorators: { allowsRemoval: [], isSelected: [{
                type: HostBinding,
                args: ['class.is-selected']
            }], _classIsInvalid: [{
                type: HostBinding,
                args: ['class.is-invalid']
            }], _classIsWarning: [{
                type: HostBinding,
                args: ['class.is-warning']
            }] } });

/**
 * Component used for editing a "single line" LF string.
 */
class TextComponent extends InlineValue {
    constructor(parentPathBasedComponent, lfStorage, lfI18n, lfRouter) {
        super(parentPathBasedComponent, lfStorage, lfI18n, lfRouter);
        makeObservable(this);
    }
    /**
     * Whether to show the "is required" icon on the component.
     */
    get showIsRequired() {
        return this.minLength !== undefined && this.minLength > 0;
    }
    /**
     * Minimum length allowed.
     */
    get minLength() {
        const minLength = this.relativeStorage.validationMode === ValidationMode.AUTO
            ? this.relativeStorage.getStateProperty('.', 'minLength')
            : this.relativeStorage.schema().minLength;
        return typeof minLength === 'number' ? minLength : undefined;
    }
    /**
     * Maximum length allowed.
     */
    get maxLength() {
        const maxLength = this.relativeStorage.validationMode === ValidationMode.AUTO
            ? this.relativeStorage.getStateProperty('.', 'maxLength')
            : this.relativeStorage.schema().maxLength;
        return typeof maxLength === 'number' ? maxLength : undefined;
    }
    /**
     * Action to run on every `input` event of the text input.
     * @param evt `input` event.
     */
    _onInput(evt) {
        this.relativeStorage.set('.', evt.target.value);
        this.relativeStorage.setDirty();
    }
    validatePath() {
        const schema = this.relativeStorage.schema();
        if (!isStringSchema(schema) || isNullableSchema(schema)) {
            throw pathError(this.path, 'Schema must be of the "string" type and not "nullable"');
        }
    }
}
Object.defineProperty(TextComponent, "\u0275fac", {
    enumerable: true,
    configurable: true,
    writable: true,
    value: i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0, type: TextComponent, deps: [{ token: PathBased, optional: true }, { token: i1.LfStorage }, { token: i1.LfI18n }, { token: LfRouter, optional: true }], target: i0.ɵɵFactoryTarget.Component })
});
Object.defineProperty(TextComponent, "\u0275cmp", {
    enumerable: true,
    configurable: true,
    writable: true,
    value: i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.15", type: TextComponent, selector: "lf-text", usesInheritance: true, ngImport: i0, template: "<ng-container *mobxAutorun>\n  <ng-container *ngIf=\"shouldDisplay\">\n    <!-- Label -->\n    <span *ngIf=\"label\" class=\"label\">{{ label }}</span>\n    <lf-help-tooltip *ngIf=\"helpMessage\" [help]=\"helpMessage\"></lf-help-tooltip>\n\n    <!-- Required icon -->\n    <lf-icon\n      class=\"is-required\"\n      icon=\"asterisk\"\n      *ngIf=\"showIsRequired && !isReadOnly\"\n    ></lf-icon>\n\n    <!-- Pending validation -->\n    <div\n      class=\"status pending\"\n      *ngIf=\"relativeStorage.shouldShowPending()\"\n    ></div>\n    <!-- Rejected validation -->\n    <div\n      class=\"status rejected\"\n      *ngIf=\"relativeStorage.shouldShowRejected()\"\n      (click)=\"relativeStorage.recomputeStateProperties()\"\n    >\n      <lf-tooltip [help]=\"retryValidateText\">\n        <lf-icon icon=\"warning\"></lf-icon>\n      </lf-tooltip>\n    </div>\n\n    <!-- (Debug) value state -->\n    <lf-value-state [path]=\"path\"></lf-value-state>\n\n    <!-- Input group -->\n    <div\n      class=\"input-group input-group-sm\"\n      [class.is-warning]=\"relativeStorage.shouldShowWarning()\"\n      [class.is-invalid]=\"relativeStorage.shouldShowError()\"\n    >\n      <!-- Code -->\n      <div *ngIf=\"code\" class=\"input-group-prepend\">\n        <div class=\"input-group-text\">{{ code }}</div>\n      </div>\n\n      <!-- Input -->\n      <input\n        #focusTarget\n        type=\"text\"\n        class=\"form-control\"\n        [class.is-warning]=\"relativeStorage.shouldShowWarning()\"\n        [class.is-invalid]=\"relativeStorage.shouldShowError()\"\n        [class.is-readonly]=\"isReadOnly\"\n        [name]=\"path\"\n        [value]=\"relativeStorage.get()\"\n        [attr.minLength]=\"minLength\"\n        [attr.maxLength]=\"maxLength\"\n        [readonly]=\"isReadOnly\"\n        autocomplete=\"off\"\n        (input)=\"_onInput($event)\"\n        (focus)=\"_onFocus($event)\"\n        (blur)=\"_onBlur($event)\"\n      />\n    </div>\n\n    <!-- Legend -->\n    <div *ngIf=\"legend\" class=\"legend\">{{ legend }}</div>\n  </ng-container>\n</ng-container>\n", components: [{ type: HelpTooltipComponent, selector: "lf-help-tooltip", inputs: ["help"] }, { type: IconComponent, selector: "lf-icon", inputs: ["icon", "size", "fixedWidth", "spin", "pulse", "ariaHidden"] }, { type: TooltipComponent, selector: "lf-tooltip", inputs: ["help", "placement", "delay"] }, { type: ValueStateComponent, selector: "lf-value-state" }], directives: [{ type: i6.MobxAutorunDirective, selector: "[mobxAutorun]", inputs: ["mobxAutorun"] }, { type: i7.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush })
});
__decorate([
    computed
], TextComponent.prototype, "showIsRequired", null);
__decorate([
    computed
], TextComponent.prototype, "minLength", null);
__decorate([
    computed
], TextComponent.prototype, "maxLength", null);
__decorate([
    action
], TextComponent.prototype, "_onInput", null);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0, type: TextComponent, decorators: [{
            type: Component,
            args: [{
                    selector: 'lf-text',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    templateUrl: './text.component.html',
                }]
        }], ctorParameters: function () { return [{ type: i1.PathBased, decorators: [{
                    type: Optional
                }, {
                    type: Inject,
                    args: [PathBased]
                }] }, { type: i1.LfStorage }, { type: i1.LfI18n }, { type: i1.LfRouter, decorators: [{
                    type: Optional
                }, {
                    type: Inject,
                    args: [LfRouter]
                }] }]; }, propDecorators: { showIsRequired: [], minLength: [], maxLength: [], _onInput: [] } });

/**
 * Component used for editing a "multiple lines" LF string.
 */
class TextareaComponent extends InlineValue {
    constructor(parentPathBasedComponent, lfStorage, lfI18n, lfRouter) {
        super(parentPathBasedComponent, lfStorage, lfI18n, lfRouter);
        /**
         * Initial height of the textarea (CSS measurement string).
         */
        Object.defineProperty(this, "initialHeight", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: '6rem'
        });
        makeObservable(this);
    }
    /**
     * Whether to show the "is required" icon on the component.
     */
    get showIsRequired() {
        return this.minLength !== undefined && this.minLength > 0;
    }
    /**
     * Minimum length allowed.
     */
    get minLength() {
        const minLength = this.relativeStorage.validationMode === ValidationMode.AUTO
            ? this.relativeStorage.getStateProperty('.', 'minLength')
            : this.relativeStorage.schema().minLength;
        return typeof minLength === 'number' ? minLength : undefined;
    }
    /**
     * Maximum length allowed.
     */
    get maxLength() {
        const maxLength = this.relativeStorage.validationMode === ValidationMode.AUTO
            ? this.relativeStorage.getStateProperty('.', 'maxLength')
            : this.relativeStorage.schema().maxLength;
        return typeof maxLength === 'number' ? maxLength : undefined;
    }
    /**
     * Action to run on every `input` event of the textarea input.
     * @param evt `input` event.
     */
    _onInput(evt) {
        this.relativeStorage.set('.', evt.target.value);
        this.relativeStorage.setDirty();
    }
    validatePath() {
        const schema = this.relativeStorage.schema();
        if (!isStringSchema(schema) || isNullableSchema(schema)) {
            throw pathError(this.path, 'Schema must be of the "string" type and not "nullable"');
        }
    }
}
Object.defineProperty(TextareaComponent, "\u0275fac", {
    enumerable: true,
    configurable: true,
    writable: true,
    value: i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0, type: TextareaComponent, deps: [{ token: PathBased, optional: true }, { token: i1.LfStorage }, { token: i1.LfI18n }, { token: LfRouter, optional: true }], target: i0.ɵɵFactoryTarget.Component })
});
Object.defineProperty(TextareaComponent, "\u0275cmp", {
    enumerable: true,
    configurable: true,
    writable: true,
    value: i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.15", type: TextareaComponent, selector: "lf-textarea", inputs: { initialHeight: "initialHeight" }, usesInheritance: true, ngImport: i0, template: "<ng-container *mobxAutorun>\n  <ng-container *ngIf=\"shouldDisplay\">\n    <!-- Label -->\n    <span *ngIf=\"label\" class=\"label\">{{ label }}</span>\n    <lf-help-tooltip *ngIf=\"helpMessage\" [help]=\"helpMessage\"></lf-help-tooltip>\n\n    <!-- Required icon -->\n    <lf-icon\n      class=\"is-required\"\n      icon=\"asterisk\"\n      *ngIf=\"showIsRequired && !isReadOnly\"\n    ></lf-icon>\n\n    <!-- Pending validation -->\n    <div\n      class=\"status pending\"\n      *ngIf=\"relativeStorage.shouldShowPending()\"\n    ></div>\n    <!-- Rejected validation -->\n    <div\n      class=\"status rejected\"\n      *ngIf=\"relativeStorage.shouldShowRejected()\"\n      (click)=\"relativeStorage.recomputeStateProperties()\"\n    >\n      <lf-tooltip [help]=\"retryValidateText\">\n        <lf-icon icon=\"warning\"></lf-icon>\n      </lf-tooltip>\n    </div>\n\n    <!-- (Debug) value state -->\n    <lf-value-state [path]=\"path\"></lf-value-state>\n\n    <!-- Input group -->\n    <div\n      class=\"input-group input-group-sm\"\n      [class.is-warning]=\"relativeStorage.shouldShowWarning()\"\n      [class.is-invalid]=\"relativeStorage.shouldShowError()\"\n    >\n      <!-- Code -->\n      <div *ngIf=\"code\" class=\"input-group-prepend\">\n        <div class=\"input-group-text\">{{ code }}</div>\n      </div>\n\n      <!-- Textarea -->\n      <textarea\n        #focusTarget\n        type=\"text\"\n        class=\"form-control\"\n        [class.is-warning]=\"relativeStorage.shouldShowWarning()\"\n        [class.is-invalid]=\"relativeStorage.shouldShowError()\"\n        [class.is-readonly]=\"isReadOnly\"\n        [style.height]=\"initialHeight\"\n        [name]=\"path\"\n        [value]=\"relativeStorage.get()\"\n        [attr.minLength]=\"minLength\"\n        [attr.maxLength]=\"maxLength\"\n        [readonly]=\"isReadOnly\"\n        autocomplete=\"off\"\n        (input)=\"_onInput($event)\"\n        (focus)=\"_onFocus($event)\"\n        (blur)=\"_onBlur($event)\"\n      ></textarea>\n    </div>\n\n    <!-- Legend -->\n    <div *ngIf=\"legend\" class=\"legend\">{{ legend }}</div>\n  </ng-container>\n</ng-container>\n", components: [{ type: HelpTooltipComponent, selector: "lf-help-tooltip", inputs: ["help"] }, { type: IconComponent, selector: "lf-icon", inputs: ["icon", "size", "fixedWidth", "spin", "pulse", "ariaHidden"] }, { type: TooltipComponent, selector: "lf-tooltip", inputs: ["help", "placement", "delay"] }, { type: ValueStateComponent, selector: "lf-value-state" }], directives: [{ type: i6.MobxAutorunDirective, selector: "[mobxAutorun]", inputs: ["mobxAutorun"] }, { type: i7.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush })
});
__decorate([
    computed
], TextareaComponent.prototype, "showIsRequired", null);
__decorate([
    computed
], TextareaComponent.prototype, "minLength", null);
__decorate([
    computed
], TextareaComponent.prototype, "maxLength", null);
__decorate([
    action
], TextareaComponent.prototype, "_onInput", null);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0, type: TextareaComponent, decorators: [{
            type: Component,
            args: [{
                    selector: 'lf-textarea',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    templateUrl: './textarea.component.html',
                }]
        }], ctorParameters: function () { return [{ type: i1.PathBased, decorators: [{
                    type: Optional
                }, {
                    type: Inject,
                    args: [PathBased]
                }] }, { type: i1.LfStorage }, { type: i1.LfI18n }, { type: i1.LfRouter, decorators: [{
                    type: Optional
                }, {
                    type: Inject,
                    args: [LfRouter]
                }] }]; }, propDecorators: { initialHeight: [{
                type: Input
            }], showIsRequired: [], minLength: [], maxLength: [], _onInput: [] } });

/**
 * Entry for an item of the tree-nav.
 */
class TreeEntryComponent extends PathBased {
    constructor(parentPathBasedComponent, lfStorage, lfI18n, lfRouter) {
        super(parentPathBasedComponent, lfStorage, lfI18n);
        Object.defineProperty(this, "lfRouter", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: lfRouter
        });
        /**
         * Whether this tree-entry is to be displayed as the root one (in which case
         * its label isn't shown anywhere and its children are displayed one after the
         * other). The entry can be displayed as root only when its schema is complex.
         * A button is displayed at the end of the list when there are optional values
         * to be added or to add a new element in case the schema is a list.
         */
        Object.defineProperty(this, "displayAsRoot", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: true
        });
        /**
         * Internal input used to make a tree only show entries that render in the
         * same outlet (values that should render inside other components shouldn't be
         * part of the same tree).
         */
        Object.defineProperty(this, "_componentLevel", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        Object.defineProperty(this, "disposeOnDisplayAsRootChanges", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: void 0
        });
        makeObservable(this);
    }
    /**
     * Label associated with this value.
     */
    get label() {
        const label = this.translate(I18N_VALUE_LABEL_KEY);
        return label === undefined
            ? this.relativeStorage.currentPath === '/'
                ? '/'
                : this.relativeStorage.currentId
            : label;
    }
    /**
     * Message used to ask the user to retry validating the value.
     */
    get retryValidateText() {
        return this.translate(I18N_VALUE_RETRY_VALIDATE_TEXT_KEY);
    }
    get addOptionalValueButtonText() {
        return this.translate(I18N_TREE_NAV_ADD_OPTIONAL_VALUE_BUTTON_TEXT_KEY);
    }
    get addValueToListButtonText() {
        return this.translate(I18N_TREE_NAV_ADD_VALUE_TO_LIST_BUTTON_TEXT_KEY);
    }
    get maxSize() {
        const maxSize = this.relativeStorage.validationMode === ValidationMode.AUTO
            ? this.relativeStorage.getStateProperty('.', 'maxSize')
            : this.relativeStorage.schema().maxSize;
        return typeof maxSize === 'number' ? maxSize : undefined;
    }
    get matchingRoutes() {
        return this.lfRouter.matchingRoutes(this.path, { navigateToParent: false });
    }
    get navigateableRoute() {
        return this.lfRouter.navigateableRouteFromMatchingRoutes(this.matchingRoutes);
    }
    get url() {
        return (this.navigateableRoute &&
            this.lfRouter.createUrlFromNavigateableRoute(this.navigateableRoute));
    }
    get isActive() {
        return this.lfRouter.isActive(this.path);
    }
    get isList() {
        const schema = this.relativeStorage.schema();
        return isListSchema(schema) || isTableSchema(schema);
    }
    get childrenIds() {
        return this.lfStorage.childrenIds(this.path).filter((id) => {
            const path = appendToPath(this.path, id);
            const matchingRoutes = this.lfRouter
                .matchingRoutes(path, { navigateToParent: false })
                .filter((matchingRoute) => this.matchingRouteComponentLevel(matchingRoute) ===
                this._componentLevel);
            return matchingRoutes.length > 0;
        });
    }
    get nonNullChildrenIds() {
        return this.childrenIds.filter((id) => this.relativeStorage.get(id.toString()) !== null);
    }
    get nullChildrenIds() {
        return this.childrenIds.filter((id) => this.relativeStorage.get(id.toString()) === null);
    }
    ngOnInit() {
        super.ngOnInit();
        // Validate the path whenever `displayAsRoot` changes
        this.disposeOnDisplayAsRootChanges = observe(this, 'displayAsRoot', () => {
            this.validatePath();
        });
        // Set `componentLevel` when not defined
        if (this._componentLevel === undefined) {
            this._componentLevel = this.matchingRouteComponentLevel(this.matchingRoutes[0]);
        }
    }
    ngOnDestroy() {
        super.ngOnDestroy();
        this.disposeOnDisplayAsRootChanges();
    }
    childLabel(id) {
        const childPath = appendToPath(this.path, id);
        return this.lfI18n.getFromPath(childPath, I18N_VALUE_LABEL_KEY) || id;
    }
    addToList() {
        const { schema, value } = this.lfStorage
            .pathInfo(this.path, { fetchValues: true })
            .slice(-1)[0];
        this.lfStorage.push(this.path, undefined);
        this.lfRouter.navigate(appendToPath(this.path, isListSchema(schema)
            ? value.length - 1
            : getRowId(value[value.length - 1])), { queryParamsHandling: 'merge' });
    }
    initializeChild(id) {
        this.relativeStorage.initialize(id.toString());
        this.lfRouter.navigate(appendToPath(this.path, id), {
            queryParamsHandling: 'merge',
        });
    }
    validatePath() {
        if (this.matchingRoutes.length === 0) {
            throw pathError(this.path, 'The path or one of its children must have an associated route');
        }
        const schema = this.relativeStorage.schema();
        if (this.displayAsRoot && !isComplexSchema(schema)) {
            throw pathError(this.path, 'Schema must be complex to display the entry as "root"');
        }
    }
    /**
     * The "component" level of the provided matching route (basically the number
     * of outlets used by the route).
     * @param matchingRoute Matching of a route with a provided path.
     * @returns Component level for the matching route.
     */
    matchingRouteComponentLevel(matchingRoute) {
        return matchingRoute.routes.reduce((level, route) => level + (route.component || route.redirectTo !== undefined ? 1 : 0), 0);
    }
}
Object.defineProperty(TreeEntryComponent, "\u0275fac", {
    enumerable: true,
    configurable: true,
    writable: true,
    value: i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0, type: TreeEntryComponent, deps: [{ token: PathBased, optional: true, skipSelf: true }, { token: i1.LfStorage }, { token: i1.LfI18n }, { token: i1.LfRouter }], target: i0.ɵɵFactoryTarget.Component })
});
Object.defineProperty(TreeEntryComponent, "\u0275cmp", {
    enumerable: true,
    configurable: true,
    writable: true,
    value: i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.15", type: TreeEntryComponent, selector: "lf-tree-entry", inputs: { displayAsRoot: "displayAsRoot", _componentLevel: "_componentLevel" }, providers: [{ provide: PathBased, useExisting: TreeEntryComponent }], usesInheritance: true, ngImport: i0, template: "<ng-container *mobxAutorun>\n  <ng-container *ngIf=\"relativeStorage.has() && relativeStorage.get() !== null\">\n    <!-- Root entry (only show children) -->\n    <ng-container *ngIf=\"displayAsRoot\">\n      <!-- Children -->\n      <ng-container [ngTemplateOutlet]=\"childrenTemplate\"></ng-container>\n\n      <!-- Action at the bottom (with label) -->\n      <ng-container\n        [ngTemplateOutlet]=\"actionsTemplate\"\n        [ngTemplateOutletContext]=\"{\n          addOptionalValueButtonText: addOptionalValueButtonText,\n          addValueToListButtonText: addValueToListButtonText\n        }\"\n      ></ng-container>\n    </ng-container>\n\n    <!-- Non-root entry (show entry + children) -->\n    <div\n      *ngIf=\"!displayAsRoot\"\n      [ngClass]=\"{ 'nav-item': true, active: isActive }\"\n      [class.is-warning]=\"relativeStorage.shouldShowWarning()\"\n      [class.is-invalid]=\"relativeStorage.shouldShowError()\"\n    >\n      <!-- Item content -->\n      <div class=\"item-content\">\n        <!-- Icon + label (either in link form or not, depending on whether a\n             link is available) -->\n        <a\n          *ngIf=\"url\"\n          class=\"nav-link\"\n          [routerLink]=\"url\"\n          queryParamsHandling=\"merge\"\n        >\n          <ng-container [ngTemplateOutlet]=\"linkTemplate\"></ng-container>\n        </a>\n        <div *ngIf=\"!url\" class=\"nav-link is-disabled\">\n          <ng-container [ngTemplateOutlet]=\"linkTemplate\"></ng-container>\n        </div>\n\n        <!-- Pending validation -->\n        <div\n          class=\"status pending\"\n          *ngIf=\"relativeStorage.shouldShowPending()\"\n        ></div>\n        <!-- Rejected validation -->\n        <div\n          class=\"status rejected\"\n          *ngIf=\"relativeStorage.shouldShowRejected()\"\n          (click)=\"relativeStorage.recomputeStateProperties()\"\n        >\n          <lf-tooltip [help]=\"retryValidateText\">\n            <lf-icon icon=\"warning\"></lf-icon>\n          </lf-tooltip>\n        </div>\n\n        <!-- Actions -->\n        <ng-container\n          [ngTemplateOutlet]=\"actionsTemplate\"\n          [ngTemplateOutletContext]=\"{ alignRight: true }\"\n        ></ng-container>\n      </div>\n\n      <!-- Children -->\n      <ng-container\n        *ngIf=\"isActive\"\n        [ngTemplateOutlet]=\"childrenTemplate\"\n      ></ng-container>\n    </div>\n  </ng-container>\n</ng-container>\n\n<ng-template #linkTemplate>\n  <!-- Icon for items with sub-items, either \"v\" or \">\" or bars for lists -->\n  <span *ngIf=\"isList || nonNullChildrenIds.length > 0\" class=\"item-icon\">\n    <lf-icon\n      [icon]=\"isList ? 'bars' : isActive ? 'angle-down' : 'angle-right'\"\n      [fixedWidth]=\"true\"\n    >\n    </lf-icon>\n  </span>\n\n  <!-- Entry label -->\n  <div class=\"item-label\">{{ label }}</div>\n</ng-template>\n\n<!-- Template to show all children -->\n<ng-template #childrenTemplate>\n  <!-- Children -->\n  <ng-container *ngFor=\"let id of nonNullChildrenIds\">\n    <nav class=\"nav flex-column\">\n      <lf-tree-entry\n        [path]=\"id.toString()\"\n        [displayAsRoot]=\"false\"\n        [_componentLevel]=\"_componentLevel\"\n      ></lf-tree-entry>\n    </nav>\n  </ng-container>\n</ng-template>\n\n<!-- Template to show the item's action (if appropriate), either a button to add\n     a new element to the list, or a menu to add an optional value; possibly,\n     each action may be labelled and the menu aligned to the right -->\n<ng-template\n  #actionsTemplate\n  let-addOptionalText=\"addOptionalValueButtonText\"\n  let-addToListText=\"addValueToListButtonText\"\n  let-alignRight=\"alignRight\"\n>\n  <!-- Add optional value -->\n  <div *ngIf=\"!isList && nullChildrenIds.length > 0\" class=\"value-add\">\n    <lf-dropdown>\n      <button\n        lf-button\n        [style]=\"'outline-secondary'\"\n        size=\"sm\"\n        [dropdownToggle]=\"true\"\n        [block]=\"true\"\n      >\n        <lf-icon icon=\"plus-circle\"></lf-icon>\n        {{ addOptionalText }}\n      </button>\n      <!-- Align to the right when not -->\n      <lf-dropdown-menu [alignRight]=\"alignRight\">\n        <button\n          lf-dropdown-item\n          *ngFor=\"let id of nullChildrenIds\"\n          (click)=\"initializeChild(id)\"\n        >\n          {{ childLabel(id) }}\n        </button>\n      </lf-dropdown-menu>\n    </lf-dropdown>\n  </div>\n\n  <!-- Add value to list -->\n  <div *ngIf=\"isList\" class=\"value-add\">\n    <button\n      lf-button\n      [style]=\"'outline-secondary'\"\n      [isDisabled]=\"maxSize != null && relativeStorage.size() >= maxSize\"\n      size=\"sm\"\n      (click)=\"addToList()\"\n    >\n      <lf-icon icon=\"plus-circle\"></lf-icon>\n      {{ addToListText }}\n    </button>\n  </div>\n</ng-template>\n", components: [{ type: TooltipComponent, selector: "lf-tooltip", inputs: ["help", "placement", "delay"] }, { type: IconComponent, selector: "lf-icon", inputs: ["icon", "size", "fixedWidth", "spin", "pulse", "ariaHidden"] }, { type: TreeEntryComponent, selector: "lf-tree-entry", inputs: ["displayAsRoot", "_componentLevel"] }, { type: DropdownComponent, selector: "lf-dropdown, [lf-dropdown]", inputs: ["position", "offset", "flip", "boundary", "reference", "display"], outputs: ["shown", "hidden"] }, { type: ButtonComponent, selector: "button[lf-button], input[lf-button], a[lf-button]", inputs: ["style", "size", "type", "block", "dropdownToggle", "dropdownToggleSplit", "isDisabled", "isActive"] }, { type: DropdownMenuComponent, selector: "lf-dropdown-menu, [lf-dropdown-menu]", inputs: ["alignRight"] }, { type: DropdownItemComponent, selector: "lf-dropdown-item, [lf-dropdown-item]", inputs: ["itemType", "isActive", "isDisabled"] }], directives: [{ type: i6.MobxAutorunDirective, selector: "[mobxAutorun]", inputs: ["mobxAutorun"] }, { type: i7.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { type: i7.NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet"] }, { type: i7.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { type: i7$1.RouterLinkWithHref, selector: "a[routerLink],area[routerLink]", inputs: ["routerLink", "target", "queryParams", "fragment", "queryParamsHandling", "preserveFragment", "skipLocationChange", "replaceUrl", "state", "relativeTo"] }, { type: i7.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush })
});
__decorate([
    observable
], TreeEntryComponent.prototype, "displayAsRoot", void 0);
__decorate([
    computed
], TreeEntryComponent.prototype, "label", null);
__decorate([
    computed
], TreeEntryComponent.prototype, "retryValidateText", null);
__decorate([
    computed
], TreeEntryComponent.prototype, "addOptionalValueButtonText", null);
__decorate([
    computed
], TreeEntryComponent.prototype, "addValueToListButtonText", null);
__decorate([
    computed
], TreeEntryComponent.prototype, "maxSize", null);
__decorate([
    computed
], TreeEntryComponent.prototype, "matchingRoutes", null);
__decorate([
    computed
], TreeEntryComponent.prototype, "navigateableRoute", null);
__decorate([
    computed
], TreeEntryComponent.prototype, "url", null);
__decorate([
    computed
], TreeEntryComponent.prototype, "isActive", null);
__decorate([
    computed
], TreeEntryComponent.prototype, "isList", null);
__decorate([
    computed
], TreeEntryComponent.prototype, "childrenIds", null);
__decorate([
    computed
], TreeEntryComponent.prototype, "nonNullChildrenIds", null);
__decorate([
    computed
], TreeEntryComponent.prototype, "nullChildrenIds", null);
__decorate([
    action
], TreeEntryComponent.prototype, "addToList", null);
__decorate([
    action
], TreeEntryComponent.prototype, "initializeChild", null);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0, type: TreeEntryComponent, decorators: [{
            type: Component,
            args: [{
                    selector: 'lf-tree-entry',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [{ provide: PathBased, useExisting: TreeEntryComponent }],
                    templateUrl: './tree-entry.component.html',
                }]
        }], ctorParameters: function () { return [{ type: i1.PathBased, decorators: [{
                    type: Optional
                }, {
                    type: SkipSelf
                }, {
                    type: Inject,
                    args: [PathBased]
                }] }, { type: i1.LfStorage }, { type: i1.LfI18n }, { type: i1.LfRouter }]; }, propDecorators: { displayAsRoot: [{
                type: Input
            }], _componentLevel: [{
                type: Input
            }], label: [], retryValidateText: [], addOptionalValueButtonText: [], addValueToListButtonText: [], maxSize: [], matchingRoutes: [], navigateableRoute: [], url: [], isActive: [], isList: [], childrenIds: [], nonNullChildrenIds: [], nullChildrenIds: [], addToList: [], initializeChild: [] } });

/**
 * Component used to show a tree to navigate between values.
 */
class TreeNavComponent extends PathBased {
    constructor(parentPathBasedComponent, lfStorage, lfI18n, lfRouter) {
        super(parentPathBasedComponent, lfStorage, lfI18n);
        Object.defineProperty(this, "lfRouter", {
            enumerable: true,
            configurable: true,
            writable: true,
            value: lfRouter
        });
        makeObservable(this);
    }
    get _hasRoutes() {
        return (this.lfRouter.matchingRoutes(this.path, { navigateToParent: false })
            .length > 0);
    }
    /**
     * Hide the tree-nav.
     */
    hideTreeNav() {
        this.parentPathBasedComponent.hideTreeNav();
    }
}
Object.defineProperty(TreeNavComponent, "\u0275fac", {
    enumerable: true,
    configurable: true,
    writable: true,
    value: i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0, type: TreeNavComponent, deps: [{ token: PathBased, optional: true, skipSelf: true }, { token: i1.LfStorage }, { token: i1.LfI18n }, { token: i1.LfRouter }], target: i0.ɵɵFactoryTarget.Component })
});
Object.defineProperty(TreeNavComponent, "\u0275cmp", {
    enumerable: true,
    configurable: true,
    writable: true,
    value: i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.15", type: TreeNavComponent, selector: "lf-tree-nav", providers: [{ provide: PathBased, useExisting: TreeNavComponent }], usesInheritance: true, ngImport: i0, template: "<ng-container *mobxAutorun>\n  <nav class=\"nav flex-column\" role=\"navigation\">\n    <!-- Small screen: hide tree-nav button -->\n    <div class=\"tree-nav-actions d-md-none\">\n      <button class=\"tree-nav-hide close\" (click)=\"hideTreeNav()\">\n        &times;\n      </button>\n    </div>\n\n    <!-- Recursively render tree entries -->\n    <lf-tree-entry *ngIf=\"_hasRoutes\" [path]=\"path\"></lf-tree-entry>\n  </nav>\n</ng-container>\n", components: [{ type: TreeEntryComponent, selector: "lf-tree-entry", inputs: ["displayAsRoot", "_componentLevel"] }], directives: [{ type: i6.MobxAutorunDirective, selector: "[mobxAutorun]", inputs: ["mobxAutorun"] }, { type: i7.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }], changeDetection: i0.ChangeDetectionStrategy.OnPush })
});
__decorate([
    computed
], TreeNavComponent.prototype, "_hasRoutes", null);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0, type: TreeNavComponent, decorators: [{
            type: Component,
            args: [{
                    selector: 'lf-tree-nav',
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [{ provide: PathBased, useExisting: TreeNavComponent }],
                    templateUrl: './tree-nav.component.html',
                }]
        }], ctorParameters: function () { return [{ type: i1.PathBased, decorators: [{
                    type: Optional
                }, {
                    type: SkipSelf
                }, {
                    type: Inject,
                    args: [PathBased]
                }] }, { type: i1.LfStorage }, { type: i1.LfI18n }, { type: i1.LfRouter }]; }, propDecorators: { _hasRoutes: [] } });

/**
 * Exported/declared components and directives.
 */
const DECLARATIONS = [
    ActionsMenuComponent,
    AlertComponent,
    AppComponent,
    ButtonComponent,
    CardComponent,
    CardContentComponent,
    CheckboxComponent,
    CheckboxGroupComponent,
    DateComponent,
    DateRangeComponent,
    DropdownComponent,
    DropdownItemComponent,
    DropdownMenuComponent,
    FileComponent,
    FormComponent,
    HelpTooltipComponent,
    IconComponent,
    ModalBodyComponent,
    ModalComponent,
    ModalFooterComponent,
    ModalHeaderComponent,
    NumberComponent,
    RadioComponent,
    SelectComponent,
    TableCellComponent,
    TableComponent,
    TableRowComponent,
    TextareaComponent,
    TextComponent,
    TooltipComponent,
    TopBarComponent,
    TreeEntryComponent,
    TreeNavComponent,
    ValidationIssueDirective,
    ValidationPanelComponent,
    ValueStateComponent,
];
/**
 * LF Bootstrap theme module.
 */
class LfBootstrapThemeModule {
}
Object.defineProperty(LfBootstrapThemeModule, "\u0275fac", {
    enumerable: true,
    configurable: true,
    writable: true,
    value: i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0, type: LfBootstrapThemeModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule })
});
Object.defineProperty(LfBootstrapThemeModule, "\u0275mod", {
    enumerable: true,
    configurable: true,
    writable: true,
    value: i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0, type: LfBootstrapThemeModule, declarations: [ActionsMenuComponent,
            AlertComponent,
            AppComponent,
            ButtonComponent,
            CardComponent,
            CardContentComponent,
            CheckboxComponent,
            CheckboxGroupComponent,
            DateComponent,
            DateRangeComponent,
            DropdownComponent,
            DropdownItemComponent,
            DropdownMenuComponent,
            FileComponent,
            FormComponent,
            HelpTooltipComponent,
            IconComponent,
            ModalBodyComponent,
            ModalComponent,
            ModalFooterComponent,
            ModalHeaderComponent,
            NumberComponent,
            RadioComponent,
            SelectComponent,
            TableCellComponent,
            TableComponent,
            TableRowComponent,
            TextareaComponent,
            TextComponent,
            TooltipComponent,
            TopBarComponent,
            TreeEntryComponent,
            TreeNavComponent,
            ValidationIssueDirective,
            ValidationPanelComponent,
            ValueStateComponent], imports: [BrowserAnimationsModule,
            CommonModule, i7$1.RouterModule, i9.BsDatepickerModule, LfCoreModule,
            LfTableHeaderModule, i2.MarkdownModule, MobxAngularModule,
            ScrollingModule, i2$1.TooltipModule], exports: [LfCoreModule,
            LfTableHeaderModule,
            MobxAngularModule, ActionsMenuComponent,
            AlertComponent,
            AppComponent,
            ButtonComponent,
            CardComponent,
            CardContentComponent,
            CheckboxComponent,
            CheckboxGroupComponent,
            DateComponent,
            DateRangeComponent,
            DropdownComponent,
            DropdownItemComponent,
            DropdownMenuComponent,
            FileComponent,
            FormComponent,
            HelpTooltipComponent,
            IconComponent,
            ModalBodyComponent,
            ModalComponent,
            ModalFooterComponent,
            ModalHeaderComponent,
            NumberComponent,
            RadioComponent,
            SelectComponent,
            TableCellComponent,
            TableComponent,
            TableRowComponent,
            TextareaComponent,
            TextComponent,
            TooltipComponent,
            TopBarComponent,
            TreeEntryComponent,
            TreeNavComponent,
            ValidationIssueDirective,
            ValidationPanelComponent,
            ValueStateComponent] })
});
Object.defineProperty(LfBootstrapThemeModule, "\u0275inj", {
    enumerable: true,
    configurable: true,
    writable: true,
    value: i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0, type: LfBootstrapThemeModule, imports: [[
                BrowserAnimationsModule,
                CommonModule,
                RouterModule.forChild([]),
                BsDatepickerModule.forRoot(),
                LfCoreModule,
                LfTableHeaderModule,
                MarkdownModule.forRoot(),
                MobxAngularModule,
                ScrollingModule,
                TooltipModule.forRoot(),
            ], LfCoreModule,
            LfTableHeaderModule,
            MobxAngularModule] })
});
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.15", ngImport: i0, type: LfBootstrapThemeModule, decorators: [{
            type: NgModule,
            args: [{
                    imports: [
                        BrowserAnimationsModule,
                        CommonModule,
                        RouterModule.forChild([]),
                        BsDatepickerModule.forRoot(),
                        LfCoreModule,
                        LfTableHeaderModule,
                        MarkdownModule.forRoot(),
                        MobxAngularModule,
                        ScrollingModule,
                        TooltipModule.forRoot(),
                    ],
                    declarations: DECLARATIONS,
                    exports: [
                        LfCoreModule,
                        LfTableHeaderModule,
                        MobxAngularModule,
                        ...DECLARATIONS,
                    ],
                }]
        }] });
/**
 * Theme services that should be provided for each provided `LF_APP_SCHEMA`.
 * Currently empty, reserved for future use.
 */
const LF_BOOTSTRAP_THEME_SERVICES = [];

/**
 * Default english translations for Bootstrap theme strings.
 */
const I18N_EN_US = {
    '*': {
        // App
        [I18N_BS_LOCALE_KEY]: 'en',
        // Unload alert service
        [I18N_UNLOAD_ALERT_MESSAGE_KEY]: 'Are you sure you want to leave? Changes that you made may not be saved.',
        // Value
        [I18N_VALUE_RETRY_VALIDATE_TEXT_KEY]: 'Retry validation',
        // Tree-nav
        [I18N_TREE_NAV_ADD_OPTIONAL_VALUE_BUTTON_TEXT_KEY]: 'Add',
        [I18N_TREE_NAV_ADD_VALUE_TO_LIST_BUTTON_TEXT_KEY]: 'Add',
        // Closeable
        [I18N_CLOSE_BUTTON_TOOLTIP_KEY]: 'Close',
        // Actions-menu
        [I18N_ACTIONS_MENU_BUTTON_TEXT_KEY]: 'Actions',
        // Validation panel
        [I18N_VALIDATION_PANEL_ERRORS_TEXT_KEY]: 'Errors:',
        [I18N_VALIDATION_PANEL_WARNINGS_TEXT_KEY]: 'Warnings:',
        [I18N_VALIDATION_PANEL_NO_ISSUES_TEXT_KEY]: 'Everything looks great!',
        [I18N_VALIDATION_PANEL_FOCUS_TEXT_KEY]: 'Focus field',
        [I18N_VALIDATION_PANEL_NEXT_BUTTON_TOOLTIP_KEY]: 'Next field',
        [I18N_VALIDATION_PANEL_PREV_BUTTON_TOOLTIP_KEY]: 'Previous field',
        // Form
        [I18N_FORM_HELP_ACTION_TEXT_KEY]: 'Help',
        [I18N_FORM_REMOVE_ACTION_TEXT_KEY]: 'Remove',
        [I18N_FORM_ENSURE_REMOVE_TEXT_KEY]: 'Please confirm that you wish to remove this form.',
        [I18N_FORM_CANCEL_REMOVE_BUTTON_TEXT_KEY]: 'Cancel',
        [I18N_FORM_CONFIRM_REMOVE_BUTTON_TEXT_KEY]: 'Confirm',
        // Date
        [I18N_DATE_FORMAT_KEY]: 'M/D/YYYY',
        [I18N_DATE_PLACEHOLDER_KEY]: 'm/d/yyyy',
        // Date-range
        [I18N_DATE_RANGE_SEPARATOR_KEY]: ' - ',
        // File
        [I18N_FILE_CHOOSE_PLACEHOLDER_KEY]: 'Choose file',
        [I18N_FILE_BROWSE_TEXT_KEY]: 'Browse',
        [I18N_FILE_NONE_CHOSEN_KEY]: 'No file chosen',
        [I18N_FILE_CLEAR_BUTTON_TOOLTIP_KEY]: 'Clear',
        // Number
        [I18N_NUMBER_DECIMAL_SEPARATOR_KEY]: '.',
        [I18N_NUMBER_THOUSANDS_SEPARATOR_KEY]: '',
        // Table
        [I18N_TABLE_ADD_ROW_ACTION_TEXT_KEY]: 'Add row',
        [I18N_TABLE_REMOVE_ROWS_ACTION_TEXT_KEY]: 'Remove rows',
        [I18N_TABLE_NO_ROWS_TEXT_KEY]: 'No rows to display.',
        // Selection
        [I18N_SELECTION_NO_OPTIONS_TEXT_KEY]: 'No options available.',
        // Validations
        [I18N_VALIDATIONS_KEY]: {
            [IS_REJECTED_CODE]: 'An error occurred validating this field.',
            [IS_REQUIRED_CODE]: 'The field is required.',
            [DISALLOWED_VALUE_CODE]: (ctx, { allowedValues }) => {
                if (isBooleanSchema(ctx.schema()) && allowedValues.length === 1) {
                    return `The field must${allowedValues[0] === true ? '' : ' not'} be ticked.`;
                }
                return `The field's value must be one of: ${allowedValues.join(', ')}.`;
            },
            [INVALID_DATE_RANGE_CODE]: 'The range is invalid. The start date must not be after the end date.',
            [DATE_OUT_OF_BOUNDS_CODE]: (ctx, { minDate, maxDate }) => {
                // TODO: Format dates properly
                if (isDateRangeSchema(ctx.schema())) {
                    return maxDate === undefined
                        ? `The start date mustn't be before ${minDate}.`
                        : minDate === undefined
                            ? `The end date mustn't be after ${maxDate}.`
                            : `The range must be between ${minDate} and ${maxDate}.`;
                }
                return maxDate === undefined
                    ? `The date mustn't be before ${minDate}.`
                    : minDate === undefined
                        ? `The date mustn't be after ${maxDate}.`
                        : `The date must be between ${minDate} and ${maxDate}.`;
            },
            [SIZE_OUT_OF_BOUNDS_CODE]: (ctx, { size, minSize, maxSize }) => {
                if (size === 0 && minSize > 0) {
                    return 'The field is required.';
                }
                // Checkbox group
                if (ctx.hasStateProperty('.', `i18n(${I18N_SELECTION_OPTIONS_KEY})`)) {
                    return maxSize === undefined
                        ? `A minimum of ${+minSize} option${+minSize === 1 ? '' : 's'} must be selected.`
                        : minSize === undefined
                            ? `A maximum of ${+maxSize} option${+maxSize === 1 ? '' : 's'} must be selected.`
                            : maxSize === minSize
                                ? `${+maxSize} option${+maxSize === 1 ? '' : 's'} must be selected.`
                                : `Between ${+minSize} and ${+maxSize} options must be selected.`;
                }
                // Tables and form-lists
                return maxSize === undefined
                    ? `The collection must have at least ${+minSize} element${+minSize === 1 ? '' : 's'}.`
                    : minSize === undefined
                        ? `The collection must have no more than ${+maxSize} element${+maxSize === 1 ? '' : 's'}.`
                        : maxSize === minSize
                            ? `The collection must have ${+maxSize} element${+maxSize === 1 ? '' : 's'}.`
                            : `The collection must have between ${+minSize} and ${+maxSize} ` +
                                'elements.';
            },
            [NUMBER_OUT_OF_BOUNDS_CODE]: (_, { min, max }) => {
                return max === undefined
                    ? `The value mustn't be lesser than ${+min}.`
                    : min === undefined
                        ? `The value mustn't be greater than ${+max}.`
                        : `The value must be between ${+min} and ${+max}.`;
            },
            [LENGTH_OUT_OF_BOUNDS_CODE]: (_, { length, minLength, maxLength }) => {
                if (length === 0 && minLength > 0) {
                    return 'The field is required.';
                }
                return maxLength === undefined
                    ? `The value must have at least ${+minLength} character${+minLength === 1 ? '' : 's'}.`
                    : minLength === undefined
                        ? `The value must have at most ${+maxLength} character${+maxLength === 1 ? '' : 's'}.`
                        : maxLength === minLength
                            ? `The value must have ${+maxLength} character${+maxLength === 1 ? '' : 's'}.`
                            : `The value must have ${+minLength} to ${+maxLength} characters.`;
            },
        },
    },
};

// Define `es` locale
defineLocale('es', esLocale);
/**
 * Default spanish translations for Bootstrap theme strings.
 */
const I18N_ES_ES = {
    '*': {
        // App
        [I18N_BS_LOCALE_KEY]: 'es',
        // Unload alert service
        [I18N_UNLOAD_ALERT_MESSAGE_KEY]: 'Estás seguro que quieres irte? Es posible que los cambios realizados no se guarden.',
        // Value
        [I18N_VALUE_RETRY_VALIDATE_TEXT_KEY]: 'Reintentar la validación',
        // Tree-nav
        [I18N_TREE_NAV_ADD_OPTIONAL_VALUE_BUTTON_TEXT_KEY]: 'Añadir',
        [I18N_TREE_NAV_ADD_VALUE_TO_LIST_BUTTON_TEXT_KEY]: 'Añadir',
        // Actions-menu
        [I18N_ACTIONS_MENU_BUTTON_TEXT_KEY]: 'Comportamiento',
        // Closeable
        [I18N_CLOSE_BUTTON_TOOLTIP_KEY]: 'Cerrar',
        // Validation panel
        [I18N_VALIDATION_PANEL_ERRORS_TEXT_KEY]: 'Errores:',
        [I18N_VALIDATION_PANEL_WARNINGS_TEXT_KEY]: 'Advertencias:',
        [I18N_VALIDATION_PANEL_NO_ISSUES_TEXT_KEY]: '¡Todo parece genial!',
        [I18N_VALIDATION_PANEL_FOCUS_TEXT_KEY]: 'Seleccionar campo',
        [I18N_VALIDATION_PANEL_NEXT_BUTTON_TOOLTIP_KEY]: 'Siguiente campo',
        [I18N_VALIDATION_PANEL_PREV_BUTTON_TOOLTIP_KEY]: 'Campo anterior',
        // Form
        [I18N_FORM_HELP_ACTION_TEXT_KEY]: 'Ayuda',
        [I18N_FORM_REMOVE_ACTION_TEXT_KEY]: 'Eliminar',
        [I18N_FORM_ENSURE_REMOVE_TEXT_KEY]: 'Confirme que desea eliminar este formulario.',
        [I18N_FORM_CANCEL_REMOVE_BUTTON_TEXT_KEY]: 'Cancelar',
        [I18N_FORM_CONFIRM_REMOVE_BUTTON_TEXT_KEY]: 'Confirmar',
        // Date
        [I18N_DATE_FORMAT_KEY]: 'DD/MM/YYYY',
        [I18N_DATE_PLACEHOLDER_KEY]: 'dd/mm/aaaa',
        // Date-range
        [I18N_DATE_RANGE_SEPARATOR_KEY]: ' - ',
        // File
        [I18N_FILE_CHOOSE_PLACEHOLDER_KEY]: 'Elija el archivo',
        [I18N_FILE_BROWSE_TEXT_KEY]: 'Buscar',
        [I18N_FILE_NONE_CHOSEN_KEY]: 'Ningún archivo elegido',
        [I18N_FILE_CLEAR_BUTTON_TOOLTIP_KEY]: 'Limpiar',
        // Number
        [I18N_NUMBER_DECIMAL_SEPARATOR_KEY]: ',',
        [I18N_NUMBER_THOUSANDS_SEPARATOR_KEY]: '',
        // Table
        [I18N_TABLE_ADD_ROW_ACTION_TEXT_KEY]: 'Añadir fila',
        [I18N_TABLE_REMOVE_ROWS_ACTION_TEXT_KEY]: 'Eliminar filas',
        [I18N_TABLE_NO_ROWS_TEXT_KEY]: 'No hay filas para mostrar.',
        // Selection
        [I18N_SELECTION_NO_OPTIONS_TEXT_KEY]: 'No hay opciones disponibles.',
        // Validations
        [I18N_VALIDATIONS_KEY]: {
            [IS_REJECTED_CODE]: 'Se produjo un error al validar este campo.',
            [IS_REQUIRED_CODE]: 'El campo es obligatorio.',
            [DISALLOWED_VALUE_CODE]: (ctx, { allowedValues }) => {
                if (isBooleanSchema(ctx.schema()) && allowedValues.length === 1) {
                    return `El campo${allowedValues[0] === true ? '' : ' no'} debe estar marcado.`;
                }
                return `El valor del campo debe ser uno de: ${allowedValues.join(', ')}.`;
            },
            [INVALID_DATE_RANGE_CODE]: 'El rango no es válido. La fecha de inicio no debe ser posterior a la fecha de fin.',
            [DATE_OUT_OF_BOUNDS_CODE]: (ctx, { minDate, maxDate }) => {
                // TODO: Format dates properly
                if (isDateRangeSchema(ctx.schema())) {
                    return maxDate === undefined
                        ? `La fecha de inicio no puede ser anterior al ${minDate}.`
                        : minDate === undefined
                            ? `La fecha de fin no puede ser posterior al ${maxDate}.`
                            : `El rango debe estar entre el ${minDate} y el ${maxDate}.`;
                }
                return maxDate === undefined
                    ? `La fecha no puede ser anterior al ${minDate}.`
                    : minDate === undefined
                        ? `La fecha no puede ser posterior al ${maxDate}.`
                        : `La fecha debe estar entre el ${minDate} y el ${maxDate}.`;
            },
            [SIZE_OUT_OF_BOUNDS_CODE]: (ctx, { size, minSize, maxSize }) => {
                if (size === 0 && minSize > 0) {
                    return 'El campo es obligatorio.';
                }
                // Checkbox group
                if (ctx.hasStateProperty('.', `i18n(${I18N_SELECTION_OPTIONS_KEY})`)) {
                    const numOptions = (n) => (n === 1 ? 'una' : n === 2 ? 'dos' : n);
                    return maxSize === undefined
                        ? `Debes seleccionar al menos ${numOptions(+minSize)} ${+minSize === 1 ? 'opción' : 'opciones'}.`
                        : minSize === undefined
                            ? `Debes seleccionar un máximo de ${numOptions(+maxSize)} ${+minSize === 1 ? 'opción' : 'opciones'}.`
                            : maxSize === minSize
                                ? `Debes seleccionar ${numOptions(+maxSize)} ${+maxSize === 1 ? 'opción' : 'opciones'}.`
                                : `Debes seleccionar entre ${numOptions(+minSize)} y ${numOptions(+maxSize)} opciones.`;
                }
                // Tables and form-lists
                return maxSize === undefined
                    ? `La colección debe tener al menos ${+minSize} elemento${+minSize === 1 ? '' : 's'}.`
                    : minSize === undefined
                        ? `La colección debe tener un máximo de ${+maxSize} elemento${+maxSize === 1 ? '' : 's'}.`
                        : maxSize === minSize
                            ? `La colección debe tener ${+maxSize} elemento${+maxSize === 1 ? '' : 's'}.`
                            : `La colección debe tener entre ${+minSize} y ${+maxSize} elementos.`;
            },
            [NUMBER_OUT_OF_BOUNDS_CODE]: (_, { min, max }) => {
                return max === undefined
                    ? `El valor no puede ser inferior a ${+min}.`
                    : min === undefined
                        ? `El valor no puede ser superior a ${+max}.`
                        : `El valor debe estar entre ${+min} y ${+max}.`;
            },
            [LENGTH_OUT_OF_BOUNDS_CODE]: (_, { length, minLength, maxLength }) => {
                if (length === 0 && minLength > 0) {
                    return 'El campo es obligatorio.';
                }
                return maxLength === undefined
                    ? `El valor debe tener al menos ${+minLength} ${+minLength === 1 ? 'carácter' : 'caracteres'}.`
                    : minLength === undefined
                        ? `El valor debe tener un máximo de ${+maxLength} ${+maxLength === 1 ? 'carácter' : 'caracteres'}.`
                        : maxLength === minLength
                            ? `El valor debe tener ${+maxLength} ${+maxLength === 1 ? 'carácter' : 'caracteres'}.`
                            : `El valor debe tener entre ${+minLength} y ${+maxLength} ` +
                                'caracteres.';
            },
        },
    },
};

// Define `pt` locale
defineLocale('pt', ptBrLocale);
/**
 * Default portuguese translations for Bootstrap theme strings.
 */
const I18N_PT_PT = {
    '*': {
        // App
        [I18N_BS_LOCALE_KEY]: 'pt',
        // Unload alert service
        [I18N_UNLOAD_ALERT_MESSAGE_KEY]: 'Tem a certeza que pretende sair? Alterações feitas podem não estar guardadas.',
        // Value
        [I18N_VALUE_RETRY_VALIDATE_TEXT_KEY]: 'Voltar a tentar validar',
        // Tree-nav
        [I18N_TREE_NAV_ADD_OPTIONAL_VALUE_BUTTON_TEXT_KEY]: 'Adicionar',
        [I18N_TREE_NAV_ADD_VALUE_TO_LIST_BUTTON_TEXT_KEY]: 'Adicionar',
        // Actions-menu
        [I18N_ACTIONS_MENU_BUTTON_TEXT_KEY]: 'Ações',
        // Closeable
        [I18N_CLOSE_BUTTON_TOOLTIP_KEY]: 'Fechar',
        // Validation panel
        [I18N_VALIDATION_PANEL_ERRORS_TEXT_KEY]: 'Erros:',
        [I18N_VALIDATION_PANEL_WARNINGS_TEXT_KEY]: 'Avisos:',
        [I18N_VALIDATION_PANEL_NO_ISSUES_TEXT_KEY]: 'Nenhum problema a reportar!',
        [I18N_VALIDATION_PANEL_FOCUS_TEXT_KEY]: 'Selecionar campo',
        [I18N_VALIDATION_PANEL_NEXT_BUTTON_TOOLTIP_KEY]: 'Campo seguinte',
        [I18N_VALIDATION_PANEL_PREV_BUTTON_TOOLTIP_KEY]: 'Campo anterior',
        // Form
        [I18N_FORM_HELP_ACTION_TEXT_KEY]: 'Ajuda',
        [I18N_FORM_REMOVE_ACTION_TEXT_KEY]: 'Remover',
        [I18N_FORM_ENSURE_REMOVE_TEXT_KEY]: 'Por favor confirme que pretende remover este formulário.',
        [I18N_FORM_CANCEL_REMOVE_BUTTON_TEXT_KEY]: 'Cancelar',
        [I18N_FORM_CONFIRM_REMOVE_BUTTON_TEXT_KEY]: 'Confirmar',
        // Date
        [I18N_DATE_FORMAT_KEY]: 'DD/MM/YYYY',
        [I18N_DATE_PLACEHOLDER_KEY]: 'dd/mm/aaaa',
        // Date-range
        [I18N_DATE_RANGE_SEPARATOR_KEY]: ' - ',
        // File
        [I18N_FILE_CHOOSE_PLACEHOLDER_KEY]: 'Escolher ficheiro',
        [I18N_FILE_BROWSE_TEXT_KEY]: 'Procurar',
        [I18N_FILE_NONE_CHOSEN_KEY]: 'Nenhum ficheiro escolhido',
        [I18N_FILE_CLEAR_BUTTON_TOOLTIP_KEY]: 'Limpar',
        // Number
        [I18N_NUMBER_DECIMAL_SEPARATOR_KEY]: ',',
        [I18N_NUMBER_THOUSANDS_SEPARATOR_KEY]: '',
        // Table
        [I18N_TABLE_ADD_ROW_ACTION_TEXT_KEY]: 'Adicionar linha',
        [I18N_TABLE_REMOVE_ROWS_ACTION_TEXT_KEY]: 'Remover linhas',
        [I18N_TABLE_NO_ROWS_TEXT_KEY]: 'Nenhuma linha a mostrar.',
        // Selection
        [I18N_SELECTION_NO_OPTIONS_TEXT_KEY]: 'Nenhuma opção disponível.',
        // Validations
        [I18N_VALIDATIONS_KEY]: {
            [IS_REJECTED_CODE]: 'Ocorreu um erro ao validar este valor.',
            [IS_REQUIRED_CODE]: 'Campo de preenchimento obrigatório.',
            [DISALLOWED_VALUE_CODE]: (ctx, { allowedValues }) => {
                if (isBooleanSchema(ctx.schema()) && allowedValues.length === 1) {
                    return `O campo ${allowedValues[0] === true ? 'tem de ser' : 'não pode ser'} marcado.`;
                }
                return `O valor do campo tem de ser um de: ${allowedValues.join(', ')}.`;
            },
            [INVALID_DATE_RANGE_CODE]: 'O intervalo não é válido. A data de início não pode ser posterior à ' +
                'data de fim.',
            [DATE_OUT_OF_BOUNDS_CODE]: (ctx, { minDate, maxDate }) => {
                // TODO: Format dates properly
                if (isDateRangeSchema(ctx.schema())) {
                    return maxDate === undefined
                        ? `A data de início não pode ser anterior a ${minDate}.`
                        : minDate === undefined
                            ? `A data de fim não pode ser posterior a ${maxDate}.`
                            : `O intervalo tem de estar entre ${minDate} e ${maxDate}.`;
                }
                return maxDate === undefined
                    ? `A data não pode ser anterior a ${minDate}.`
                    : minDate === undefined
                        ? `A data não pode ser posterior a ${maxDate}.`
                        : `A data tem de estar entre ${minDate} e ${maxDate}.`;
            },
            [SIZE_OUT_OF_BOUNDS_CODE]: (ctx, { size, minSize, maxSize }) => {
                if (size === 0 && minSize > 0) {
                    return 'Campo de preenchimento obrigatório.';
                }
                // Checkbox group
                if (ctx.hasStateProperty('.', `i18n(${I18N_SELECTION_OPTIONS_KEY})`)) {
                    const numOptions = (n) => (n === 1 ? 'uma' : n === 2 ? 'duas' : n);
                    return maxSize === undefined
                        ? `Tem de selecionar no mínimo ${numOptions(+minSize)} ${+minSize === 1 ? 'opção' : 'opções'}.`
                        : minSize === undefined
                            ? `Tem de selecionar no máximo ${numOptions(+maxSize)} ${+minSize === 1 ? 'opção' : 'opções'}.`
                            : maxSize === minSize
                                ? `Tem de selecionar ${numOptions(+maxSize)} ${+maxSize === 1 ? 'opção' : 'opções'}.`
                                : `Entre ${numOptions(+minSize)} e ${numOptions(+maxSize)} opções têm de ser selecionadas.`;
                }
                // Tables and form-lists
                return maxSize === undefined
                    ? `A coleção tem de ter no mínimo ${+minSize} elemento${+minSize === 1 ? '' : 's'}.`
                    : minSize === undefined
                        ? `A coleção tem de ter no máximo ${+maxSize} elemento${+maxSize === 1 ? '' : 's'}.`
                        : maxSize === minSize
                            ? `A coleção tem de ter ${+maxSize} elemento${+maxSize === 1 ? '' : 's'}.`
                            : `A coleção tem de ter entre ${+minSize} e ${+maxSize} elementos.`;
            },
            [NUMBER_OUT_OF_BOUNDS_CODE]: (_, { min, max }) => {
                return max === undefined
                    ? `O valor não pode ser menor do que ${+min}.`
                    : min === undefined
                        ? `O valor não pode ser maior do que ${+max}.`
                        : `O valor tem de estar entre ${+min} e ${+max}.`;
            },
            [LENGTH_OUT_OF_BOUNDS_CODE]: (_, { length, minLength, maxLength }) => {
                if (length === 0 && minLength > 0) {
                    return 'Campo de preenchimento obrigatório.';
                }
                return maxLength === undefined
                    ? `O valor tem de ter no mínimo ${+minLength} ${+minLength === 1 ? 'carácter' : 'caracteres'}.`
                    : minLength === undefined
                        ? `O valor tem de ter no máximo ${+maxLength} ${+maxLength === 1 ? 'carácter' : 'caracteres'}.`
                        : maxLength === minLength
                            ? `O valor tem de ter ${+maxLength} ${+maxLength === 1 ? 'carácter' : 'caracteres'}.`
                            : `O valor tem de ter entre ${+minLength} e ${+maxLength} ` +
                                'caracteres.';
            },
        },
    },
};

// Module

/**
 * Generated bundle index. Do not edit.
 */

export { ActionsMenuComponent, AlertComponent, AppComponent, BsLocaleChanger, ButtonComponent, CardComponent, CardContentComponent, CheckboxComponent, CheckboxGroupComponent, DateComponent, DateRangeComponent, DropdownComponent, DropdownItemComponent, DropdownMenuComponent, FileComponent, FormComponent, HelpTooltipComponent, I18N_ACTIONS_MENU_BUTTON_TEXT_KEY, I18N_ACTIONS_MENU_KEY, I18N_ACTIONS_MENU_OPTIONS_KEY, I18N_BS_LOCALE_KEY, I18N_CLOSE_BUTTON_TOOLTIP_KEY, I18N_DATE_FORMAT_KEY, I18N_DATE_PLACEHOLDER_KEY, I18N_DATE_RANGE_SEPARATOR_KEY, I18N_EN_US, I18N_ES_ES, I18N_FILE_BROWSE_TEXT_KEY, I18N_FILE_CHOOSE_PLACEHOLDER_KEY, I18N_FILE_CLEAR_BUTTON_TOOLTIP_KEY, I18N_FILE_NONE_CHOSEN_KEY, I18N_FORM_CANCEL_REMOVE_BUTTON_TEXT_KEY, I18N_FORM_CONFIRM_REMOVE_BUTTON_TEXT_KEY, I18N_FORM_ENSURE_REMOVE_TEXT_KEY, I18N_FORM_HELP_ACTION_TEXT_KEY, I18N_FORM_REMOVE_ACTION_TEXT_KEY, I18N_NUMBER_DECIMAL_SEPARATOR_KEY, I18N_NUMBER_PREFIX_KEY, I18N_NUMBER_SUFFIX_KEY, I18N_NUMBER_THOUSANDS_SEPARATOR_KEY, I18N_PT_PT, I18N_SELECTION_NO_OPTIONS_TEXT_KEY, I18N_SELECTION_OPTIONS_KEY, I18N_TABLE_ADD_ROW_ACTION_TEXT_KEY, I18N_TABLE_COLUMN_LABELS_KEY, I18N_TABLE_NO_ROWS_TEXT_KEY, I18N_TABLE_REMOVE_ROWS_ACTION_TEXT_KEY, I18N_TREE_NAV_ADD_OPTIONAL_VALUE_BUTTON_TEXT_KEY, I18N_TREE_NAV_ADD_VALUE_TO_LIST_BUTTON_TEXT_KEY, I18N_VALIDATIONS_KEY, I18N_VALIDATION_PANEL_ERRORS_TEXT_KEY, I18N_VALIDATION_PANEL_FOCUS_TEXT_KEY, I18N_VALIDATION_PANEL_NEXT_BUTTON_TOOLTIP_KEY, I18N_VALIDATION_PANEL_NO_ISSUES_TEXT_KEY, I18N_VALIDATION_PANEL_PREV_BUTTON_TOOLTIP_KEY, I18N_VALIDATION_PANEL_WARNINGS_TEXT_KEY, I18N_VALUE_CODE_KEY, I18N_VALUE_HELP_MESSAGE_KEY, I18N_VALUE_LABEL_KEY, I18N_VALUE_LEGEND_KEY, I18N_VALUE_RETRY_VALIDATE_TEXT_KEY, INVALID_DATE_RANGE_CODE, INVALID_DATE_RANGE_TYPE, IconComponent, InlineValue, LF_BOOTSTRAP_THEME_SERVICES, LF_URL_PROTOCOL, LfBootstrapThemeModule, ModalBodyComponent, ModalComponent, ModalFooterComponent, ModalHeaderComponent, NumberComponent, RadioComponent, SELECTION_COLUMN_WIDTH, SelectComponent, SelectionValue, SingleSelectionValue, TableCellComponent, TableComponent, TableRowComponent, TextComponent, TextareaComponent, Toggleable, TooltipComponent, TopBarComponent, TreeEntryComponent, TreeNavComponent, ValidationIssueDirective, ValidationPanelComponent, Value, ValueStateComponent, dateRangeSchema, isDateRangeSchema };
//# sourceMappingURL=lightweightform-bootstrap-theme.js.map
